; ------------------------------
;	Initialiser une dmo
; ------------------------------

	TEXT
BoucleInitDemo
	; Reprendre le controle

	move.l	#ControleNone,ControleVbl

	; Si une dmo en mmoire on la vire

	tst.l	demo_malloc
	beq.s	.NoDemo
	SupXazMfree	demo_malloc
	clr.l	demo_malloc

	move	DemoNum,d0
	addq	#1,d0
	cmp	#3,d0
	bmi.s	.DemoMaxOk
	clr	d0
.DemoMaxOk	move	d0,DemoNum

.NoDemo
	; Numro de la dmo
	
	move	DemoNum,d0
	add	#"1",d0
	move.b	d0,demo_name+4

	; Trouver donnes de la dmo

	lea	demo_name,a0
	move.l	dir_start,a1
	move.l	dir_end,a2
	bsr	cherche_adresse
	cmp.l	#0,a0
	beq	BID_erreur
	move.l	4(a0),d7	; Longueur de la dmo

	; Charger la dmo

	SupXazMxalloc	d7,#XAZ_PREFTTRAM
	move.l	d0,demo_malloc
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	BID_erreur
	move.l	(a0),a0	; Source
	move.l	d0,a1	; Dest

	subq	#1,d7
.boucle	move.b	(a0)+,(a1)+
	dbra	d7,.boucle

	; Faire les inits
	
	move.l	demo_malloc,a0
	cmp.b	#104,(a0)
	bmi.s	DemoHeader7

	; Header 13 octets
DemoHeader13
	clr	d0
	move.b	DEMO2_SKILL(a0),d0
	move	d0,game_skill

	cmp	#2,game_type
	beq.s	DemoDoom2
DemoDoom
	move.b	DEMO2_EPISODE(a0),d0
	add.b	#"0",d0
	move.b	d0,game_level+1
	move.b	DEMO2_MAP(a0),d0
	add.b	#"0",d0
	move.b	d0,game_level+3
	bra.s	DemoHeader13_next
DemoDoom2
	clr.l	d0
	move.b	DEMO2_MAP(a0),d0
	divu	#10,d0
	add.b	#"0",d0
	move.b	d0,game_level+3

	clr.l	d0
	move.b	DEMO2_MAP(a0),d0
	divu	#10,d0
	swap	d0
	add.b	#"0",d0
	move.b	d0,game_level+4
DemoHeader13_next
	lea	DEMO2_PLAYER1(a0),a2
	lea	13(a0),a1
	bra.s	DemoHeaderDone

	; Header 7 octets
DemoHeader7
	clr	d0
	move.b	DEMO1_SKILL(a0),d0
	move	d0,game_skill

	move.b	DEMO1_EPISODE(a0),d0
	add.b	#"0",d0
	move.b	d0,game_level+1
	move.b	DEMO1_MAP(a0),d0
	add.b	#"0",d0
	move.b	d0,game_level+3
	
	lea	DEMO1_PLAYER1(a0),a2
	lea	7(a0),a1
DemoHeaderDone

	; Combien de joueurs enregistrs dans la dmo ?

	clr.l	d1
	moveq	#3,d0
.boucle	tst.b	(a2)+
	beq.s	.boucle_next
	addq	#1,d1
.boucle_next	dbra	d0,.boucle

	; d1 Nb de commandes de joueurs	

	move.l	a1,DemoCommand
	add.l	d1,d1
	add.l	d1,d1
	move.l	d1,DemoNext

	; Ya plus qu' lancer la dmo

	clr	DemoTic
	move.l	#BoucleChargerNiveau1,BouclePrincipale
	move.l	#ControleNone,ControleVbl

	or	#1<<FUNC_DETAIL,DoFunctions

	rts

	DATA
demo_name	dc.b	"DEMO1",0,0,0

	BSS
DemoCommand	ds.l	1	; Commande  lire
DemoNext	ds.l	1	; Offset vers la prochaine commande
DemoTic	ds.w	1
DemoNum	ds.w	1	; Nb de la dmo en cours
demo_malloc	ds.l	1	; Adresse de la dmo en mmoire

; -------------	Si une erreur on renvoie les images de prsentation

	TEXT
BID_erreur1
	tst.l	demo_malloc
	beq.s	BID_erreur
	SupXazMfree	demo_malloc
	clr.l	demo_malloc
BID_erreur
	move.l	#BoucleTitlePic,BouclePrincipale
	move.l	#ControleTitlePic,ControleVbl
	rts
