; ------------------------------
;	Afficher la texture
; ------------------------------

	TEXT
BoucleTextures0
	; Contruire le cache pour toutes les textures
	
	move	#-1,CacheForBrowser
	bsr	TexturesBuildCache
	tst	d0
	bne	TB_erreur
	
	; Inits du browser

	clr	TextureNb
	move.l	#BoucleTextures1,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

BoucleTextures1
	; Effacer l'cran pour la texture (256x128)

	move.l	affiche1,a0
	move	#200-1,d0
BT_clry	move	#320/8-1,d1
BT_clrx	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d1,BT_clrx
	dbra	d0,BT_clry

	; Afficher la texture de numro TextureNb

	move	TextureNb,d0
	move	#-1,tcache_flag
	bsr	cherche_texture

	cmp.l	#0,a0
	beq	BT_fin
	move.l	(a0)+,a1	; mur_adr
	move	(a0)+,d0	; mur_tx
	move	(a0)+,d1	; mur_ty

	move.l	affiche1,a0
	move.l	palette,a3
	moveq	#0,d3
	subq	#1,d1
BT_bcly
	move.l	a0,a2
	move.l	a1,a4
	move	d0,d2
	subq	#1,d2
BT_bclx
	move.b	(a4)+,d3
	move	(a3,d3.w*4),(a2)+
	dbra	d2,BT_bclx
	lea	screenx*2(a0),a0
	lea	256(a1),a1
	dbra	d1,BT_bcly

	; Affiche le nom de la texture
	
	move	TextureNb,d0
	move.l	(4,[texture_malloc],d0.w*4),a0
	move.l	(a0),texture_name
	move.l	4(a0),texture_name+4
	clr	texture_name+8

	clr	PrintX
	move	#screeny-16,PrintY
	lea	texture_name,a1
	move.l	TextFonte,a0

	bsr	PrintStringAdress
BT_fin
	rts

	BSS
display_browser	ds.w	1
TextureNb	ds.w	1
texture_name	ds.b	10
	
; -------------	Erreur  l'initialisation

	TEXT

TB_erreur	clr	MenuActif
	clr	TitleNum
	move.l	#ControleTitlePic,ControleVbl
	move.l	#BoucleTitlePic,BouclePrincipale
	rts
