; ------------------------------
;	Construction de la scene
; ------------------------------

	INCLUDE	build\pile.s

	TEXT
BuildScene
	clr	walls_flag
	move	display_sprites,sprites_flag

	move.l	obj_observateur,a2

	move	OBJET_X(a2),d0
	ext.l	d0
	move.l	d0,vue_x

	move	OBJET_Y(a2),d0
	ext.l	d0
	move.l	d0,vue_y

	move	OBJET_H(a2),d0
	swap	d0
	clr	d0
	add.l	OBJET_Z(a2),d0
	asr.l	#8,d0
	move.l	d0,vue_z

	tst	tombraidermode
	beq.s	NoTRmode
	add.l	#16<<8,vue_z

	move	OBJET_A(a2),d2
	and	#-4,d2

	moveq	#-112,d0
	muls.l	([cosinus],d2.w),d0
	add.l	OBJET_X(a2),d0
	swap	d0
	ext.l	d0
	move.l	d0,vue_x

	moveq	#-112,d1
	muls.l	([sinus],d2.w),d1
	add.l	OBJET_Y(a2),d1
	swap	d1
	ext.l	d1
	move.l	d1,vue_y
NoTRmode

	BSS
vue_x	ds.l	1
vue_y	ds.l	1
vue_z	ds.l	1

; -------------	Envoie au DSP les donnes de la scne  construire

	TEXT

	lea	$ffffa202.w,a6

	DSPWAITINPUT	(a6)
	move.l	#"SCR",2(a6)

	DSPWAITINPUT	(a6)
	move.l	sys_hz_35,2(a6) ; Timer

	DSPWAITINPUT	(a6)
	move	ciel_offset,4(a6) ; Offset pour le ciel

	move	resx,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	move	resy,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	clr.l	d0
	move	ScreenRatioX,d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	clr.l	d0
	move	ScreenRatioY,d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)
	
	DSPWAITINPUT	(a6)
	move.l	vue_x,2(a6)

	DSPWAITINPUT	(a6)
	move.l	vue_y,2(a6)

	move	OBJET_A(a2),d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	DSPWAITINPUT	(a6)
	move.l	vue_z,2(a6)

	move	ecr_ligne,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	move.l	sinus,a4
	move.l	cosinus,a5

	move	OBJET_A(a2),d0	; Pour le sol/plafond
	DSPWAITINPUT	(a6)
	move.l	(a4,d0.w),2(a6)
	DSPWAITINPUT	(a6)
	move.l	(a5,d0.w),2(a6)

	move	OBJET_A(a2),d0	; Pour les nodes
	sub	#(nb_angles/8)*4,d0
	DSPWAITINPUT	(a6)
	move.l	(a5,d0.w),2(a6)
	DSPWAITINPUT	(a6)
	move.l	(a4,d0.w),2(a6)

	move	OBJET_A(a2),d0	; Pour les SEGS
	sub	#(nb_angles/4)*4,d0
	DSPWAITINPUT	(a6)
	move.l	(a5,d0.w),2(a6)
	DSPWAITINPUT	(a6)
	move.l	(a4,d0.w),2(a6)

; -------------	On commence  tracer dans la pile

	clr	draw_walls	; nb de murs dans la pile
	clr	draw_sprites	; nb de sprites dans la pile
	lea	drawstack,a5	; adr premier mur

;	move	OBJET_X(a2),d6	; position du joueur
;	move	OBJET_Y(a2),d7
	move.l	vue_x,d6
	move.l	vue_y,d7

	tst	display_weapon
	bne.s	.NoDisplayWeapon
	tst	tombraidermode
	bne.s	.NoDisplayWeapon
	bsr	AfficheArmeScene
.NoDisplayWeapon
	move.l	adr_nodes,a1
	move.l	num_nodes,d0
	subq	#1,d0
	INCLUDE	build\node.s
;	bsr	EmpileNoeud
;	rts
	
; -------------	Routines diverses

	INCLUDE	build\thing.s

	BSS

walls_flag	ds.w	1
sprites_flag	ds.w	1
