; -----------------------------------------------------
;	Empile le NODE
; -----------------------------------------------------
;	d0	Numero du NODE  tracer
;	d6	player_x
;	d7	player_y
;	a1	adr_nodes
;	a2	Observateur
;	a5	adresse element de la pile
;	a6	$ffffa202.w

	TEXT
EmpileNoeud	
	tst	d0
	bpl	EmpileNoeud1
	INCLUDE	build\ssector.s
	rts
EmpileNoeud1

; -------------	Calcul pour savoir si joueur a gauche ou a droite

	mulu	#SIZEOF_NODE,d0
	lea	(a1,d0.l),a0
	move.l	a0,a4

	move	d6,d1
	sub	(a4)+,d1	; xp
	move	d7,d0
	sub	(a4)+,d0	; yp
	
	muls	(a4)+,d0	; d0=(py-yc)*xv
	muls	(a4)+,d1	; d1=(px-xc)*yv
	
	sub.l	d1,d0
	bpl.s	left_first	; on est a droite: on trace d'abord le gauche

; -------------	Right then left

right_first
	lea	NODE_RIGHT(a0),a4
	bsr.s	NoeudTest
	bne.s	left_second
	move	NODE_R_CHILD(a0),d0
	move.l	a0,-(sp)
	bsr	EmpileNoeud
	move.l	(sp)+,a0

	tst	walls_flag
	bne.s	right_done
left_second
	lea	NODE_LEFT(a0),a4
	bsr.s	NoeudTest
	bne.s	right_done
	move	NODE_L_CHILD(a0),d0
	bsr	EmpileNoeud
right_done	
	rts

; -------------	Left then right

left_first
	lea	NODE_LEFT(a0),a4
	bsr.s	NoeudTest
	bne.s	right_second
	move	NODE_L_CHILD(a0),d0
	move.l	a0,-(sp)
	bsr	EmpileNoeud
	move.l	(sp)+,a0

	tst	walls_flag
	bne.s	left_done
right_second
	lea	NODE_RIGHT(a0),a4
	bsr.s	NoeudTest
	bne.s	left_done
	move	NODE_R_CHILD(a0),d0
	bsr	EmpileNoeud
left_done	
	rts

; -------------	Test visibilit d'un noeud

NoeudTest
	movem	(a4),d0-d3

	DSPWAITINPUT	(a6)
	move.l	#"NOD",2(a6)
	
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)

	DSPWAITINPUT	(a6)
	move.l	d1,2(a6)

	DSPWAITINPUT	(a6)
	move.l	d2,2(a6)

	DSPWAITINPUT	(a6)
	move.l	d3,2(a6)

	DSPWAITOUTPUT	(a6)
	tst	4(a6)
	rts
