; ------------------------------
;	Empile un THING/OBJECT
; ------------------------------
;	d6	player_x
;	d7	player_y
;	a1	adr_nodes
;	a2	Observateur
;	a4	adresse du SSECTOR
;	a5	element de la pile
;	a6	$ffffa202.w

	TEXT
EmpileThing
	move.l	a1,-(sp)

	move.l	SSECTOR_SPRITES(a4),a3
EmpileObjectAgain
	cmp.l	#0,a3
	beq	EmpileObjectStop

	moveq	#0,d0
	
	move.l	OBJET_LIFE(a3),a1
	cmp.l	#0,a1
	beq.s	EmpileObjectNoLife
	jsr	(a1)
EmpileObjectNoLife
	move	d0,DRAW_OBJ_SYM(a5)

	move.l	OBJET_SPRITE(a3),a1
	cmp.l	#0,a1
	beq	continue_empile_objets
	move.l	a1,DRAW_OBJ_ADR(a5)
	
	; Envoyer le THING au DSP

	DSPWAITINPUT	(a6)
	move.l	#"THI",2(a6)

	move	OBJET_X(a3),d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; position x

	move	OBJET_Y(a3),d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; position y

	move	OBJET_Z(a3),d0

;	move.l	OBJET_THING(a3),a0 ; Si joueur on touche pas  Z
	cmp	#1,OBJET_TYPE(a3)
	beq.s	.FloorG1
	move	OBJET_SSECTOR(a3),d1
	mulu	#SIZEOF_SSECTOR,d1
	move.l	(SSECTOR_SECTOR,[adr_ssectors],d1.l),a0
	move	SECTOR_FLOOR(a0),d1
	
	cmp	d1,d0
	bge.s	.FloorMinOk
	move	d1,d0
	bra.s	.FloorG1
.FloorMinOk	cmp	#1,OBJET_GRAVITE(a3) ; Si objet avec gravit/sol
	bne.s	.FloorG1
	cmp	d1,d0	; et si au dessus sol
	ble.s	.FloorG1
	move	d1,d0	; alors objet au sol
.FloorG1

;	move	OBJET_Z(a3),d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; position z

	INVERSE_MOT2	a1,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; taille x
	
	INVERSE_MOT2	a1,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; taille y

	INVERSE_MOT2	a1,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; offset x
	
	INVERSE_MOT2	a1,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; offset y

	DSPWAITOUTPUT	(a6)
	tst	4(a6)
	bne.s	continue_empile_objets

	; Ajouter dans la pile

	lea	SIZEOF_DRAW(a5),a5
	addq.w	#1,draw_sprites
	cmp	#MAX_SPRITES,draw_sprites
	bmi.s	continue_empile_objets
	move	#-1,sprites_flag
EmpileObjectStop
	move.l	(sp)+,a1
	rts
continue_empile_objets
	move.l	OBJET_NEXT(a3),a3
	bra	EmpileObjectAgain
