; ------------------------------
;	Dmo du jeu
; ------------------------------

	TEXT
ControleDemo
	movem.l	d0-d7/a0-a1,-(sp)

	; Lire la commande actuelle
	
	move.l	DemoCommand,a0
	cmp.b	#128,(a0)
	bne.s	.DemoNotFinished
	
	move.l	#BoucleTitlePic,BouclePrincipale
	move.l	#ControleTitlePic,ControleVbl
	move	#2,TitleSemaphore

	move	TitleNum,d0
	addq	#1,d0
	cmp	TitleNb,d0
	bmi.s	.OkNumNotMax		
	clr	d0
.OkNumNotMax	move	d0,TitleNum
	move.l	game_timer,TitleTime

	bra	ControleDemo_stop
.DemoNotFinished
	move.l	obj_observateur,a1
;	move	OBJET_A(a0),d0
;	and	#-4,d0
;	move.l	([cosinus],d0.w),d1
;	asr.l	#4,d1
;	move.l	([sinus],d0.w),d2
;	asr.l	#4,d2

	; Premier octet : dplacement Y

	move.b	(a0),d0
	ext.w	d0
	swap	d0
	clr	d0
	asr.l	#3,d0
;	move.l	d1,d3
;	move.l	d2,d4
;	muls.l	d0,d3
;	muls.l	d0,d4
;	add.l	d3,OBJET_X1(a1) ; x=x+v*cos
;	add.l	d4,OBJET_Y1(a1)	; y=y+v*sin
	add.l	d0,OBJET_Y1(a1)
	
	; Second octet : dplacement X

	move.b	1(a0),d0
	ext.w	d0
	swap	d0
	clr	d0
	asr.l	#3,d0
;	move.l	d1,d3
;	move.l	d2,d4
;	muls.l	d0,d3
;	muls.l	d0,d4
;	add.l	d4,OBJET_X1(a1)	; x=x+v*cos
;	sub.l	d3,OBJET_Y1(a1)	; y=y-v*sin
	add.l	d0,OBJET_X1(a1)

	; Troisime octet : dplacement A

	move.b	2(a0),d0
	asr.b	#2,d0
	lsl	#8,d0
	add	d0,OBJET_A1(a1)
	
	; Quatrime octet : action

	btst.b	#1,3(a0)
	beq.s	.DemoNotSwitch
	move.b	#-1,K_SPACE+clavier
.DemoNotSwitch	
;	btst.b	#2,3(a0)
;	beq.s	.DemoNoWeapon
;.DemoNoWeapon

	; Passer  la commande suivante
	
	move.l	DemoNext,d0
	add.l	d0,DemoCommand

; -------------	Appui sur ESC ?

	tst.b	K_ESC+clavier
	beq.s	.Not_Esc
	clr.b	K_ESC+clavier
	move	#-1,display_menu
	move.l	#ControleDemo,ControlePrec
	move.l	#ControleMenu,ControleVbl
.Not_Esc

; -------------	Fin controle demo

ControleDemo_stop
	movem.l	(sp)+,d0-d7/a0-a1
	rts
