; ------------------------------
;	Gestion des menus
; ------------------------------

	TEXT
DoomInitMenus
	move.l	dir_start,a1
	move.l	dir_end,a2

	lea	DoomMenu_Doom,a6
	move	#(8+6+6+7+5+2+4+2+5)-1,d0
.boucle	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)
	addq	#8,a6
	dbra	d0,.boucle

	clr	MenuActif
	move.l	#DoomMenu_table,MenuTable
	clr.l	MenuFonte

	move.l	DoomCur_Left,CurseurGauche
	move.l	DoomCur_Right,CurseurDroit
	move.l	DoomCur_Mid,CurseurMil1
	move.l	DoomCur_Mid,CurseurMil2
	move.l	DoomCur_Cur,CurseurSprite

	move.l	DoomCur_select1,Selector1
	move.l	DoomCur_select2,Selector2

	move.l	DoomMenu_left,FieldLeft
	move.l	DoomMenu_center,FieldCenter
	move.l	DoomMenu_right,FieldRight

	cmp	#2,game_type
	bne.s	.NotDoom2
	lea	DoomMenu0,a0
	lea	SIZEOF_MENU(a0),a0
	move.l	#SelectNewSkill,MENU_SELECT(a0)
	lea	DoomMenu2,a0
	lea	2*SIZEOF_MENU(a0),a0
	moveq	#5-1,d0
.boucle1	move.l	#SelectGeneral,MENU_CANCEL(a0)
	lea	SIZEOF_MENU(a0),a0
	dbra	d0,.boucle1
.NotDoom2
	tst.l	DoomMenu_Epi4
	bne.s	.YesEpi4
	lea	DoomMenuEpi4,a0
	clr.l	MENU_TITLE(a0)
.YesEpi4
	rts

	DATA

DoomMenu_table	dc.l	DoomMenu0,0
	dc.l	DoomMenu1,0
	dc.l	DoomMenu2,0
	dc.l	DoomMenu3,0
	dc.l	DoomMenu4,0
	dc.l	DoomMenu5,0
	dc.l	DoomMenu6,0
	dc.l	DoomMenu7,0

; 	1 Logo		M_DOOM
;	2 New game		M_NGAME
;	3 Load game		M_LOADG
;	4 Save game		M_SAVEG
;	5 Options		M_OPTION
;	6 Read this		M_RDTHIS
;	7 End game		M_ENDGAM
;	8 Quit game		M_QUITG

DoomMenu_Doom	dc.b	"M_DOOM",0,0
DoomMenu_Ngame	dc.b	"M_NGAME",0
DoomMenu_Lgame	dc.b	"M_LOADG",0
DoomMenu_Sgame	dc.b	"M_SAVEG",0
DoomMenu_Option	dc.b	"M_OPTION"
DoomMenu_Rdthis	dc.b	"M_RDTHIS"
DoomMenu_Egame	dc.b	"M_ENDGAM"
DoomMenu_Quit	dc.b	"M_QUITG",0	

;	1 New game		M_NEWG
;	2 Which epi?		M_EPISOD
;	3 Knee-deep in the dead	M_EPI1
;	4 The Shores of hell	M_EPI2
;	5 Inferno		M_EPI3
;	6 Thy flesh consumed	M_EPI4

DoomMenu_NewG	dc.b	"M_NEWG",0,0
DoomMenu_Which	dc.b	"M_EPISOD"
DoomMenu_Epi1	dc.b	"M_EPI1",0,0
DoomMenu_Epi2	dc.b	"M_EPI2",0,0
DoomMenu_Epi3	dc.b	"M_EPI3",0,0
DoomMenu_Epi4	dc.b	"M_EPI4",0,0

;	1 New game		M_NEWG
;	2 skill level		M_SKILL
;	3 I'm too young to die	M_JKILL
;	4 Hey not to rough!	M_ROUGH
;	5 Hurt me plenty	M_HURT
;	6 Ultra violence	M_ULTRA
;	7 Nightmare		M_NMARE

DoomMenu_Skill	dc.b	"M_SKILL",0
DoomMenu_Skill1	dc.b	"M_JKILL",0
DoomMenu_Skill2	dc.b	"M_ROUGH",0
DoomMenu_Skill3	dc.b	"M_HURT",0,0
DoomMenu_Skill4	dc.b	"M_ULTRA",0
DoomMenu_Skill5	dc.b	"M_NMARE",0

;	1 Options		M_OPTTTL
;	2 Messages		M_MESSG
;	3 on/off		M_MSG ON/OFF
;	4 Mouse sensitivity	M_MSENS
;	5 Display		M_DISP
;	6 Sound volume		M_SVOL

DoomMenu_option	dc.b	"M_OPTTTL"
DoomMenu_msg	dc.b	"M_MESSG",0
DoomMenu_msgon	dc.b	"M_MSGON",0
DoomMenu_msgoff	dc.b	"M_MSGOFF"
DoomMenu_mouse	dc.b	"M_MSENS",0
DoomMenu_disp	dc.b	"M_DISP",0,0
DoomMenu_sound	dc.b	"M_SVOL",0,0

;	1 Display options	M_DISOPT
;	2 Graphic detail	M_DETAIL
;	3 high/low		M_GD HIGH/LOW
;	4 Screen size		M_SCRNSZ

DoomMenu_Mdisp	dc.b	"M_DISOPT"
DoomMenu_detail	dc.b	"M_DETAIL"
DoomMenu_low	dc.b	"M_GDLOW",0
DoomMenu_high	dc.b	"M_GDHIGH"
DoomMenu_size	dc.b	"M_SCRNSZ"

;	1 Sound volume		M_SVOL
;	2 Sfx volume		M_SFXVOL
;	3 Music volume		M_MUSVOL

DoomMenu_sfx	dc.b	"M_SFXVOL"
DoomMenu_music	dc.b	"M_MUSVOL"

;	Curseurs

DoomCur_Left	dc.b	"M_THERML"
DoomCur_Mid	dc.b	"M_THERMM"
DoomCur_Right	dc.b	"M_THERMR"
DoomCur_Cur	dc.b	"M_THERMO"

;	Slecteurs

DoomCur_select1	dc.b	"M_SKULL1"
DoomCur_select2	dc.b	"M_SKULL2"

;	Sauvegarde

DoomMenu_load	dc.b	"M_LGTTL",0
DoomMenu_save	dc.b	"M_SGTTL",0
DoomMenu_left	dc.b	"M_LSLEFT"
DoomMenu_right	dc.b	"M_LSRGHT"
DoomMenu_center	dc.b	"M_LSCNTR"
	
; -------------	Menus

	even
DoomMenu0
	DEF_MENU	100,16,DoomMenu_Doom,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	100,80,DoomMenu_Ngame,MENUTYPE_LUMP,0,MENU_SEL,SelectNewEpisode,0
	DEF_MENU	100,96,DoomMenu_Lgame,MENUTYPE_LUMP,0,MENU_SEL,SelectLoadGame,0
	DEF_MENU	100,112,DoomMenu_Sgame,MENUTYPE_LUMP,0,MENU_SEL,SelectSaveGame,0
	DEF_MENU	100,128,DoomMenu_Option,MENUTYPE_LUMP,0,MENU_SEL,SelectOptions,0
	DEF_MENU	100,144,DoomMenu_Rdthis,MENUTYPE_LUMP,0,MENU_SEL,0,0
;	DEF_MENU	100,160,DoomMenu_Egame,MENUTYPE_LUMP,0,MENU_SEL,0,0
	DEF_MENU	100,160,DoomMenu_Quit,MENUTYPE_LUMP,0,MENU_SEL,SelectQuit,0
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu1
	DEF_MENU	100,16,DoomMenu_NewG,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,48,DoomMenu_Which,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,72,DoomMenu_Epi1,MENUTYPE_LUMP,0,MENU_SEL,SelectEpisode1,SelectGeneral
	DEF_MENU	32,88,DoomMenu_Epi2,MENUTYPE_LUMP,0,MENU_SEL,SelectEpisode2,SelectGeneral
	DEF_MENU	32,104,DoomMenu_Epi3,MENUTYPE_LUMP,0,MENU_SEL,SelectEpisode3,SelectGeneral
DoomMenuEpi4	DEF_MENU	32,120,DoomMenu_Epi4,MENUTYPE_LUMP,0,MENU_SEL,SelectEpisode4,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu2
	DEF_MENU	100,16,DoomMenu_NewG,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,48,DoomMenu_Skill,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,72,DoomMenu_Skill1,MENUTYPE_LUMP,0,MENU_SEL,SelectSkill1,SelectNewEpisode
	DEF_MENU	32,88,DoomMenu_Skill2,MENUTYPE_LUMP,0,MENU_SEL,SelectSkill2,SelectNewEpisode
	DEF_MENU	32,104,DoomMenu_Skill3,MENUTYPE_LUMP,0,MENU_SEL,SelectSkill3,SelectNewEpisode
	DEF_MENU	32,120,DoomMenu_Skill4,MENUTYPE_LUMP,0,MENU_SEL,SelectSkill4,SelectNewEpisode
	DEF_MENU	32,136,DoomMenu_Skill5,MENUTYPE_LUMP,0,MENU_SEL,SelectSkill5,SelectNewEpisode
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu3
	DEF_MENU	100,16,DoomMenu_option,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	64,48,DoomMenu_msg,MENUTYPE_LUMP,0,MENU_SEL,SelectMessages,SelectGeneral
DoomMenu_Msg	DEF_MENU	192,48,DoomMenu_msgon,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	64,64,DoomMenu_mouse,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	64,80,MouseSense,MENUTYPE_VAR,256,MENU_SEL,0,0
	DEF_MENU	64,96,DoomMenu_disp,MENUTYPE_LUMP,0,MENU_SEL,SelectDisplay,SelectGeneral
	DEF_MENU	64,112,DoomMenu_sound,MENUTYPE_LUMP,0,MENU_SEL,SelectSound,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu4
	DEF_MENU	100,16,DoomMenu_disp,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,60,DoomMenu_detail,MENUTYPE_LUMP,0,MENU_SEL,SelectDetail,SelectOptions
DoomMenu_Detail	DEF_MENU	216,60,DoomMenu_high,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,80,DoomMenu_size,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	32,100,ScreenSize,MENUTYPE_VAR,8,MENU_SEL,0,SelectOptions
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu5
	DEF_MENU	64,16,DoomMenu_sound,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	48,60,DoomMenu_sfx,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	48,80,SfxVolume,MENUTYPE_VAR,256,MENU_SEL,0,SelectOptions
	DEF_MENU	48,100,DoomMenu_music,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	48,120,MusVolume,MENUTYPE_VAR,256,MENU_SEL,0,SelectOptions
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu6
	DEF_MENU	100,16,DoomMenu_load,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	100,40,NameGame+8*0,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,60,NameGame+8*1,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,80,NameGame+8*2,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,100,NameGame+8*3,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,120,NameGame+8*4,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,140,NameGame+8*5,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,160,NameGame+8*6,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,180,NameGame+8*7,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
DoomMenu7
	DEF_MENU	100,16,DoomMenu_save,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	100,40,NameGame+8*0,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,60,NameGame+8*1,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,80,NameGame+8*2,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,100,NameGame+8*3,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,120,NameGame+8*4,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,140,NameGame+8*5,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,160,NameGame+8*6,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	100,180,NameGame+8*7,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
