; ------------------------------
;	Affiche la barre de status
; ------------------------------

	TEXT
DoomDispStatusBar
	subq.w	#1,StbarSemaphore
	bmi	DoomStbar_stop

	tst	maponscreen
	bne.s	DoomStbar_yes

	tst	reszoom
	beq	DoomStbar_stop
DoomStbar_yes

	move.l	DoomStbar,a0
	clr	PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	bsr	PrintLumpAdress

	; ------------- De gauche  droite
	
	; --- Munitions de l'arme courante (rien si main ou trononneuse)

	move	current_weapon,d0
	cmp	#ARME_PISTOLET,d0
	bmi.s	.NoMunitions
	clr.l	d1
	
	move	Balles,d1
	cmp	#ARME_PISTOLET,d0
	beq.s	.YesMunitions
	cmp	#ARME_CHAINE,d0
	beq.s	.YesMunitions

	move	Cartouches,d1
	cmp	#ARME_FUSIL,d0
	beq.s	.YesMunitions
	cmp	#ARME_FUSIL2,d0
	beq.s	.YesMunitions

	move	Roquettes,d1
	cmp	#ARME_LR,d0
	beq.s	.YesMunitions
	
	move	Cellules,d1
.YesMunitions

	move	#2,PrintX	; Position  l'cran
	move	#screeny+4,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	lea	DoomStbarR0,a1
	bsr	PrintNb3
.NoMunitions

	; --- Sant (%)

	move	#50,PrintX
	move	#screeny+4,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	clr.l	d1
	move	Sante,d1
	lea	DoomStbarR0,a1
	bsr	PrintNb3

	move.l	DoomStbarPcent,a0
	bsr	PrintLumpAdress

	; --- Frag/Arms

	move	#104,PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	move.l	DoomArms,a0
	bsr	PrintLumpAdress

	; Premiere ligne : 2-3-4

	move	#111,PrintX
	move	#screeny+4,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	move	Armes,d1
	lsr	#2,d1
	moveq	#3-1,d2
	moveq	#2,d3
.Armes_bcl1
	move.l	(DoomStbarG0.l,d3.w*8),a0
	btst	#0,d1
	beq.s	.Armes_no1
	move.l	(DoomStbarJ0.l,d3.w*8),a0
.Armes_no1	
	bsr	PrintLumpAdress
	add	#12,PrintX
	lsr	#1,d1
	addq	#1,d3
	dbra	d2,.Armes_bcl1	

	; Seconde ligne : 5-6-7
	
	move	#111,PrintX
	move	#screeny+14,d0
	sub	StbarHeight,d0
	move	d0,PrintY
	
	moveq	#3-1,d2
	moveq	#5,d3
.Armes_bcl2
	move.l	(DoomStbarG0.l,d3.w*8),a0
	btst	#0,d1
	beq.s	.Armes_no2
	move.l	(DoomStbarJ0.l,d3.w*8),a0
.Armes_no2	
	bsr	PrintLumpAdress
	add	#12,PrintX
	lsr	#1,d1
	addq	#1,d3
	dbra	d2,.Armes_bcl2

	; --- Couleur/Face

	move	#143,PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	move.l	DoomFond,a0
	bsr	PrintLumpAdress

	move	#149,PrintX
	move	#screeny+1,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	move.l	DoomFace,a0
	bsr	PrintLumpAdress

	; --- Armure (%)

	move	#179,PrintX
	move	#screeny+4,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	clr.l	d1
	move	Armure,d1
	lea	DoomStbarR0,a1
	bsr	PrintNb3

	move.l	DoomStbarPcent,a0
	bsr	PrintLumpAdress

	; --- Clefs (normales/squelettes)

	move	#239,PrintX
	move	#screeny+4,d0
	sub	StbarHeight,d0
	move	d0,PrintY

	moveq	#3-1,d0
	lea	DoomKeyBlue,a1
	move	Clefs,d1
.Clefs_bcl
	btst	#0,d1
	beq.s	.Clefs_no

	move.l	(a1),a0
	bsr	PrintLumpAdress
.Clefs_no
	lsr	#1,d1
	add	#10,PrintY
	addq	#8,a1
	dbra	d0,.Clefs_bcl

	; --- Munitions (bullets,shells,rockets,cells)

	move	#screeny+5,d0
	sub	StbarHeight,d0
	move	d0,d2

	moveq	#4-1,d0
	lea	Balles,a2
	lea	DoomStbarJ0,a1
.Munitions_bcl1
	move	#278,PrintX
	moveq	#0,d1
	move	(a2)+,d1	; Nombre  afficher
	move	d2,PrintY
	bsr	PrintNb3
	addq	#6,d2
	dbra	d0,.Munitions_bcl1

	; --- Maximum des munitions

	move	#screeny+5,d0
	sub	StbarHeight,d0
	move	d0,d2

	moveq	#4-1,d0
	lea	MaxBalles,a2
	lea	DoomStbarJ0,a1
.Munitions_bcl2
	move	#300,PrintX
	moveq	#0,d1
	move	(a2)+,d1	; Nombre  afficher
	move	d2,PrintY
	bsr	PrintNb3
	addq	#6,d2
	dbra	d0,.Munitions_bcl2
DoomStbar_stop
	rts

	BSS

Balles	ds.w	1	; Balles de pistolets
Cartouches	ds.w	1	; Cartouches de fusil
Roquettes	ds.w	1	; Roquettes
Cellules	ds.w	1	; Cellules

MaxBalles	ds.w	1
MaxCartouches	ds.w	1
MaxRoquettes	ds.w	1
MaxCellules	ds.w	1

; -------------	Cherche l'adresse de la barre avant de l'afficher

	TEXT
DoomInitStbar
	move.l	dir_start,a1
	move.l	dir_end,a2

	lea	DoomStbar,a6
	move	#(1+2+3*10+3+1+2)-1,d0
Doom_stbar_bcl
	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)

	addq	#8,a6
	dbra	d0,Doom_stbar_bcl

	; Hauteur de la barre de status

	move.l	DoomStbar,a0
	move.l	(a0),a0
	addq	#2,a0
	INVERSE_MOT2	a0,d0
	move	d0,StbarHeight

	move.l	#DoomDispStatusBar,StatusBarRout

	move	#50,Balles
	move	#0,Cartouches
	move	#0,Roquettes
	move	#0,Cellules

	move	#100,MaxBalles
	move	#50,MaxCartouches
	move	#25,MaxRoquettes
	move	#200,MaxCellules

	move	#100,Sante
	move	#0,Armure	

	move	#%000111,Clefs
	move	#%11111100,Armes
	rts

	DATA
DoomStbar	dc.b	"STBAR",0,0,0

DoomStbarMoins	dc.b	"STTMINUS"	; Grands chiffres rouges
DoomStbarPcent	dc.b	"STTPRCNT"	; (Munitions courantes,
DoomStbarR0	dc.b	"STTNUM0",0	; Sant,Frag,Armure)
DoomStbarR1	dc.b	"STTNUM1",0
DoomStbarR2	dc.b	"STTNUM2",0
DoomStbarR3	dc.b	"STTNUM3",0
DoomStbarR4	dc.b	"STTNUM4",0
DoomStbarR5	dc.b	"STTNUM5",0
DoomStbarR6	dc.b	"STTNUM6",0
DoomStbarR7	dc.b	"STTNUM7",0
DoomStbarR8	dc.b	"STTNUM8",0
DoomStbarR9	dc.b	"STTNUM9",0

DoomStbarJ0	dc.b	"STYSNUM0"	; Petits chiffres jaunes
DoomStbarJ1	dc.b	"STYSNUM1"	; (Armes disponibles)
DoomStbarJ2	dc.b	"STYSNUM2"
DoomStbarJ3	dc.b	"STYSNUM3"
DoomStbarJ4	dc.b	"STYSNUM4"
DoomStbarJ5	dc.b	"STYSNUM5"
DoomStbarJ6	dc.b	"STYSNUM6"
DoomStbarJ7	dc.b	"STYSNUM7"
DoomStbarJ8	dc.b	"STYSNUM8"
DoomStbarJ9	dc.b	"STYSNUM9"

DoomStbarG0	dc.b	"STGNUM0",0	; Petits chiffres gris
DoomStbarG1	dc.b	"STGNUM1",0	; (Munitions)
DoomStbarG2	dc.b	"STGNUM2",0
DoomStbarG3	dc.b	"STGNUM3",0
DoomStbarG4	dc.b	"STGNUM4",0
DoomStbarG5	dc.b	"STGNUM5",0
DoomStbarG6	dc.b	"STGNUM6",0
DoomStbarG7	dc.b	"STGNUM7",0
DoomStbarG8	dc.b	"STGNUM8",0
DoomStbarG9	dc.b	"STGNUM9",0

DoomKeyBlue	dc.b	"STKEYS0",0
DoomKeyYellow	dc.b	"STKEYS1",0
DoomKeyRed	dc.b	"STKEYS2",0

DoomArms	dc.b	"STARMS",0,0

DoomFond	dc.b	"STFB0",0,0,0
DoomFace	dc.b	"STFST01",0
