; ------------------------------
;	Gestion des menus
; ------------------------------

	TEXT
HerInitMenus
	move.l	dir_start,a1
	move.l	dir_end,a2

	lea	HerMenu_Her,a6
	move	#10-1,d0
.boucle
	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)

	addq	#8,a6
	dbra	d0,.boucle

	clr	MenuActif
	move.l	#HerMenu_table,MenuTable
	move.l	HerMenu_fonte,MenuFonte

	move.l	HerMenu_SelL,CurseurGauche
	move.l	HerMenu_SelR,CurseurDroit
	move.l	HerMenu_SelM1,CurseurMil1
	move.l	HerMenu_SelM2,CurseurMil2
	move.l	HerMenu_SelCur,CurseurSprite
	
	move.l	HerMenu_Select1,Selector1
	move.l	HerMenu_Select2,Selector2
	
	clr.l	FieldLeft
	move.l	HerMenu_center,FieldCenter
	clr.l	FieldRight
	
	rts

	DATA

HerMenu_table	dc.l	HerMenu0,0	; Adresse, position dans menu
	dc.l	HerMenu1,0
	dc.l	HerMenu2,0
	dc.l	HerMenu3,0
	dc.l	HerMenu4,0
	dc.l	HerMenu5,0
	dc.l	HerMenu6,0
	dc.l	HerMenu7,0

HerMenu_Her	dc.b	"M_HTIC",0,0
HerMenu_fonte	dc.b	"FONTB_S",0
HerMenu_SelL	dc.b	"M_SLDLT",0
HerMenu_SelM1	dc.b	"M_SLDMD1"
HerMenu_SelM2	dc.b	"M_SLDMD2"
HerMenu_SelR	dc.b	"M_SLDRT",0
HerMenu_SelCur	dc.b	"M_SLDKB",0
HerMenu_Select1	dc.b	"M_SLCTR1"
HerMenu_Select2	dc.b	"M_SLCTR2"
HerMenu_center	dc.b	"M_FSLOT",0

; 	1 Logo
;	2 New game
;	3 Load game
;	4 Save game
;	5 Options
;	6 Info
;	7 End game
;	8 Quit game

HerMenu_Ngame	dc.b	"NEW GAME",0
HerMenu_Lgame	dc.b	"LOAD GAME",0
HerMenu_Sgame	dc.b	"SAVE GAME",0
HerMenu_Option	dc.b	"OPTIONS",0
HerMenu_Rdthis	dc.b	"INFO",0
HerMenu_Egame	dc.b	"END GAME",0
HerMenu_Quit	dc.b	"QUIT GAME",0	

;	1 New game
;	2 Which epi?
;	3 City of the damned
;	4 Hell's maw
;	5 The dome of d'sparil

HerMenu_Which	dc.b	"WHICH EPISODE ?",0
HerMenu_Epi1	dc.b	"CITY OF THE DAMNED",0
HerMenu_Epi2	dc.b	"HELL'S MAW",0
HerMenu_Epi3	dc.b	"THE DOME OF D'SPARIL",0

;	1 New game
;	2 skill level
;	3 Thou needeth a wet-nurse
;	4 Bringest them oneth
;	5 Thou art a smite-meister
;	6 Gamblack plague posseses thee

HerMenu_Skill	dc.b	"SKILL LEVEL",0
HerMenu_Skill1	dc.b	"THOU NEEDETH A WET-NURSE",0
HerMenu_Skill2	dc.b	"YELLOWBELLIES-R-US",0
HerMenu_Skill3	dc.b	"BRINGEST THEM ONETH",0
HerMenu_Skill4	dc.b	"THOU ART A SMITE-MEISTER",0
HerMenu_Skill5	dc.b	"BLACK PLAGUE POSSESES THEE",0

;	1 Options		M_OPTTTL
;	2 Messages		M_MESSG
;	3 on/off		M_MSG ON/OFF
;	4 Mouse sensitivity	M_MSENS
;	5 Display		M_DISP
;	6 Sound volume		M_SVOL

HerMenu_option	dc.b	"OPTIONS",0
HerMenu_msg	dc.b	"MESSAGES:",0
HerMenu_msgon	dc.b	"ON",0
HerMenu_msgoff	dc.b	"OFF",0
HerMenu_mouse	dc.b	"MOUSE SENSITIVITY",0
HerMenu_disp	dc.b	"DISPLAY OPTIONS",0
HerMenu_sound	dc.b	"SOUND OPTIONS",0

;	1 Display options	M_DISOPT
;	2 Graphic detail	M_DETAIL
;	3 high/low		M_GD HIGH/LOW
;	4 Screen size		M_SCRNSZ

HerMenu_detail	dc.b	"GRAPHIC DETAIL:",0
HerMenu_low	dc.b	"LOW",0
HerMenu_high	dc.b	"HIGH",0
HerMenu_size	dc.b	"SCREEN SIZE",0

;	1 Sound volume		M_SVOL
;	2 Sfx volume		M_SFXVOL
;	3 Music volume		M_MUSVOL

HerMenu_sfx	dc.b	"SFX VOLUME",0
HerMenu_music	dc.b	"MUSIC VOLUME",0

;	Sauvegarde

HerMenu_lgame	dc.b	"LOAD GAME",0
HerMenu_sgame	dc.b	"SAVE GAME",0
	
; -------------	Menus

	even
HerMenu0
	DEF_MENU	89,8,HerMenu_Her,MENUTYPE_LUMP,0,MENU_UNSEL,0,0
	DEF_MENU	100,70,HerMenu_Ngame,MENUTYPE_STRING,0,MENU_SEL,SelectNewEpisode,0
	DEF_MENU	100,90,HerMenu_Lgame,MENUTYPE_STRING,0,MENU_SEL,SelectLoadGame,0
	DEF_MENU	100,110,HerMenu_Sgame,MENUTYPE_STRING,0,MENU_SEL,SelectSaveGame,0
	DEF_MENU	100,130,HerMenu_Option,MENUTYPE_STRING,0,MENU_SEL,SelectOptions,0
	DEF_MENU	100,150,HerMenu_Rdthis,MENUTYPE_STRING,0,MENU_SEL,0,0
;	DEF_MENU	100,170,HerMenu_Egame,MENUTYPE_STRING,0,MENU_SEL,0,0
	DEF_MENU	100,170,HerMenu_Quit,MENUTYPE_STRING,0,MENU_SEL,SelectQuit,0
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu1
	DEF_MENU	100,15,HerMenu_Ngame,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,60,HerMenu_Which,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,100,HerMenu_Epi1,MENUTYPE_STRING,0,MENU_SEL,SelectEpisode1,SelectGeneral
	DEF_MENU	50,120,HerMenu_Epi2,MENUTYPE_STRING,0,MENU_SEL,SelectEpisode2,SelectGeneral
	DEF_MENU	50,140,HerMenu_Epi3,MENUTYPE_STRING,0,MENU_SEL,SelectEpisode3,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu2
	DEF_MENU	100,15,HerMenu_Ngame,MENUTYPE_STRING,0,MENU_UNSEL,0,0
;	DEF_MENU	50,60,HerMenu_Skill,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	32,80,HerMenu_Skill1,MENUTYPE_STRING,0,MENU_SEL,SelectSkill1,SelectNewEpisode
	DEF_MENU	32,100,HerMenu_Skill2,MENUTYPE_STRING,0,MENU_SEL,SelectSkill2,SelectNewEpisode
	DEF_MENU	32,120,HerMenu_Skill3,MENUTYPE_STRING,0,MENU_SEL,SelectSkill3,SelectNewEpisode
	DEF_MENU	32,140,HerMenu_Skill4,MENUTYPE_STRING,0,MENU_SEL,SelectSkill4,SelectNewEpisode
	DEF_MENU	32,160,HerMenu_Skill5,MENUTYPE_STRING,0,MENU_SEL,SelectSkill5,SelectNewEpisode
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu3
	DEF_MENU	100,15,HerMenu_option,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,60,HerMenu_msg,MENUTYPE_STRING,0,MENU_SEL,SelectMessages,SelectGeneral
HerMenu_Msg	DEF_MENU	160,60,HerMenu_msgon,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,80,HerMenu_mouse,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,100,MouseSense,MENUTYPE_VAR,256,MENU_SEL,0,SelectGeneral
	DEF_MENU	50,120,HerMenu_disp,MENUTYPE_STRING,0,MENU_SEL,SelectDisplay,SelectGeneral
	DEF_MENU	50,140,HerMenu_sound,MENUTYPE_STRING,0,MENU_SEL,SelectSound,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu4
	DEF_MENU	70,15,HerMenu_disp,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,60,HerMenu_detail,MENUTYPE_STRING,0,MENU_SEL,SelectDetail,SelectOptions
HerMenu_Detail	DEF_MENU	220,60,HerMenu_high,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,80,HerMenu_size,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,100,ScreenSize,MENUTYPE_VAR,8,MENU_SEL,0,SelectOptions
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu5
	DEF_MENU	70,15,HerMenu_sound,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,60,HerMenu_sfx,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,80,SfxVolume,MENUTYPE_VAR,256,MENU_SEL,0,SelectOptions
	DEF_MENU	50,100,HerMenu_music,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	50,120,MusVolume,MENUTYPE_VAR,256,MENU_SEL,0,SelectOptions
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu6
	DEF_MENU	100,8,HerMenu_lgame,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	64,30,NameGame+8*0,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,50,NameGame+8*1,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,70,NameGame+8*2,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,90,NameGame+8*3,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,110,NameGame+8*4,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,130,NameGame+8*5,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,150,NameGame+8*6,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,170,NameGame+8*7,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
HerMenu7
	DEF_MENU	100,8,HerMenu_sgame,MENUTYPE_STRING,0,MENU_UNSEL,0,0
	DEF_MENU	64,30,NameGame+8*0,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,50,NameGame+8*1,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,70,NameGame+8*2,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,90,NameGame+8*3,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,110,NameGame+8*4,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,130,NameGame+8*5,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,150,NameGame+8*6,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	64,170,NameGame+8*7,MENUTYPE_FIELD,0,MENU_SEL,0,SelectGeneral
	DEF_MENU	0,0,0,0,0,0,0,0
