; ------------------------------
;	Liste des objets de Heretic
; ------------------------------

; -------------	Tester si un objet est pendu au plafond
;	d1 numero de l'objet
;	-> d0=0/OVNI, 1/sol, 2/plafond

	TEXT
HereticGravite
	cmp	#5,d1
	beq.s	.Gravite0
	cmp	#6,d1
	beq.s	.Gravite0
	cmp	#17,d1
	beq.s	.Gravite2

	cmp	#24,d1
	bmi.s	.GraviteSuite2
	cmp	#26+1,d1
	bmi.s	.Gravite2
.GraviteSuite2
	cmp	#28,d1
	beq.s	.Gravite2
	cmp	#39,d1
	beq.s	.Gravite2
	cmp	#40,d1
	beq.s	.Gravite2

	cmp	#48,d1
	bmi.s	.GraviteSuite3
	cmp	#51+1,d1
	bmi.s	.Gravite2
.GraviteSuite3
	cmp	#52,d1
	beq.s	.Gravite0
	cmp	#66,d1
	beq.s	.Gravite0
	cmp	#74,d1
	beq.s	.Gravite0
	
	cmp	#94,d1
	bmi.s	.GraviteSuite4
	cmp	#96+1,d1
	bmi.s	.Gravite0
.GraviteSuite4

.Gravite1	moveq	#1,d0
	rts

.Gravite0	moveq	#0,d0
	rts

.Gravite2	moveq	#2,d0
	rts

; -------------	Recherche d'un nom dans une des listes
;	d0 numero du THING
;	-> a4 liste ou chercher

	TEXT
HereticSearchObjectAdress
	cmp	#4000,d0
	bpl.s	.SearchObjectNumber4000
	cmp	#2030,d0
	bpl.s	.SearchObjectNumber2030
	cmp	#2000,d0
	bpl.s	.SearchObjectNumber2000
	cmp	#1200,d0
	bpl.s	.SearchObjectNumber1200

.SearchObjectNumber0000
	lea	HereticObj0000,a4
	rts

.SearchObjectNumber1200
	sub	#1200,d0
	lea	HereticObj1200,a4
	rts

.SearchObjectNumber2000
	sub	#2000,d0
	lea	HereticObj2000,a4
	rts

.SearchObjectNumber2030
	sub	#2030,d0
	lea	HereticObj2030,a4
	rts

.SearchObjectNumber4000
	sub	#4000,d0
	lea	HereticObj4000,a4
	rts

; -------------	Subtilit de HERETIC
;	94,95,96

	BSS
HereticGizmo	ds.w	5	; X,Y,Angle,Type,Attrib

; -------------	Liste des objets de HERETIC

	DATA

HereticObj0000	DEF_SPRITE	0
	DEF_SPRITE	"PLAY","A0",0,ObjTurnAround,40,16,100,-1	; Player 1 start
	DEF_SPRITE	0			; Player 2 start
	DEF_SPRITE	0			; Player 3 start
	DEF_SPRITE	0			; Player 4 start
	DEF_SPRITE	"IMPX","A0",0,ObjTurnAround,32,20,100,-1	; IMP/GARGOYLE LEADER
	DEF_SPRITE	"HEAD","A0",0,ObjTurnAround,64,20,100,-1	; HEAD
	DEF_SPRITE	"SRCR","A0",0,ObjTurnAround,96,20,100,-1	; SORCERER
	DEF_SPRITE	"BAGH","A0",0,0,8,20,0,0		; A Bag of holding
	DEF_SPRITE	"MNTR","A0",0,ObjTurnAround,96,40,1000,-1	; MINOTAUR

	DEF_SPRITE	"PTN1","A0",3,ObjAnimed,8,20,0,0	; B Crystal vial (h+10)
;10	DEF_SPRITE	"AMG1","A0",0,0,8,20,0,0		; A Wand Crystal (15)
	DEF_SPRITE	0			; Deathmatch start
	DEF_SPRITE	"AMG2","A0",3,ObjAnimed,8,20,0,0	; A Crystal geode (75)
	DEF_SPRITE	"AMM1","A0",0,0,8,20,0,0		; A Mace spheres (30)
	DEF_SPRITE	0			; T Teleport landing
	DEF_SPRITE	"WZRD","A0",0,ObjTurnAround,48,32,100,-1	; WIZARD
	DEF_SPRITE	"AMM2","A0",0,0,8,20,0,0		; A Mace spheres (150)
	DEF_SPRITE	"SKH1","A0",0,0,8,16,0,0		; O Skull hang	
	DEF_SPRITE	"AMC1","A0",0,0,8,20,0,0		; A Ethereal arrows (7)
	DEF_SPRITE	"AMC2","A0",3,ObjAnimed,8,20,0,0	; A Ethereal quiver (30)

	DEF_SPRITE	"AMS1","A0",2,ObjAnimed,8,20,0,0	; A Lesser runes (30)
	DEF_SPRITE	"AMS2","A0",2,ObjAnimed,8,20,0,0	; A Greater runes (150)
	DEF_SPRITE	"AMB2","A0",3,ObjAnimed,8,20,0,0	; A Inferno orb (15)
	DEF_SPRITE	"AMB1","A0",3,ObjAnimed,8,20,0,0	; A Flame orb (1)
	DEF_SPRITE	"SKH2","A0",0,0,8,16,0,0		; O Skull hang 60
	DEF_SPRITE	"SKH3","A0",0,0,8,16,0,0		; O Skull hang 45
	DEF_SPRITE	"SKH4","A0",0,0,8,16,0,0		; O Skull hang 35
	DEF_SPRITE	"SRTC","A0",3,ObjAnimed,8,16,0,0	; O Serpent torch
	DEF_SPRITE	"CHDL","A0",3,ObjAnimed,8,16,0,0	; O Candelar
	DEF_SPRITE	"SMPL","A0",0,0,8,16,0,0		; O Small pillar

	DEF_SPRITE	"EGGM","A0",5,ObjAnimed,8,20,0,0	; B Morph ovum (egg)
	DEF_SPRITE	"SHD2","A0",0,0,8,20,0,0		; B Shield (a+200)
	DEF_SPRITE	"SPHL","A0",0,0,8,20,0,0		; B Mystic urn (h+100)
	DEF_SPRITE	"TRCH","A0",3,ObjAnimed,8,20,0,0	; B Torch
	DEF_SPRITE	"FBMB","A0",5,ObjAnimed,8,20,0,0	; B Time bomb
	DEF_SPRITE	"SPMP","A0",0,0,8,20,0,0		; B Map scroll
	DEF_SPRITE	"ATLP","A0",0,0,8,20,0,0		; B Chaos device
	DEF_SPRITE	"STGS","A0",0,0,8,16,0,0		; O Small stalagmite
	DEF_SPRITE	"STGL","A0",0,0,8,16,0,0		; O Large stalagmite
	DEF_SPRITE	"STCS","A0",0,0,8,16,0,0		; O Small stalagtite

	DEF_SPRITE	"STCL","A0",0,0,8,16,0,0		; O Large stalagtite
	DEF_SPRITE	0			; N Waterfall
	DEF_SPRITE	0			; N Wind
	DEF_SPRITE	0			; D Gas bag generator
	DEF_SPRITE	"BARL","A0",0,0,8,16,0,0		; O Barrel
	DEF_SPRITE	"MUMM","A0",0,ObjTurnAround,56,20,200,-1	; MUMMY LEADER
	DEF_SPRITE	"MUMM","A0",0,ObjTurnAround,56,20,200,-1	; MUMMY LEADER GHOST
	DEF_SPRITE	"BRPL","A0",0,0,8,16,0,0		; O Brown pillar
	DEF_SPRITE	"MOS1","A0",0,0,8,16,0,0		; O Moss 1
	DEF_SPRITE	"MOS2","A0",0,0,8,16,0,0		; O Moss 2

	DEF_SPRITE	"WTRH","A0",3,ObjAnimed,8,16,0,0	; O Wall torch
	DEF_SPRITE	"HCOR","A0",0,0,8,16,0,0		; O Hanging corpse
	DEF_SPRITE	"TGLT","F0",5,ObjAnimed,8,20,0,0	; T Glitter (exit/blue)
	DEF_SPRITE	"WBLS","A0",0,0,8,20,0,0		; W Dragon claw
	DEF_SPRITE	"AMP1","A0",3,ObjAnimed,8,20,0,0	; A Claw orb (15)
	DEF_SPRITE	"AMP2","A0",3,ObjAnimed,8,20,0,0	; A Energy orb (37)
	DEF_SPRITE	0			; SORCERER SPOT
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"KNIG","A0",0,ObjTurnAround,64,20,100,-1	; KNIGHT
	DEF_SPRITE	"KNIG","A0",0,ObjTurnAround,64,20,100,-1	; KNIGHT GHOST
	DEF_SPRITE	"IMPX","A0",0,ObjTurnAround,32,20,100,-1	; IMP/GARGOYLE
	DEF_SPRITE	0
	DEF_SPRITE	"MUMM","A0",0,ObjTurnAround,64,32,100,-1	; MUMMY
	DEF_SPRITE	"MUMM","A0",0,ObjTurnAround,64,32,100,-1	; MUMMY GHOST

	DEF_SPRITE	"BEAS","A0",0,ObjTurnAround,80,48,500,-1	; BEAST
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"AKYY","A0",10,ObjAnimed,12,20,0,0	; K Green key
	DEF_SPRITE	"TGLT","A0",5,ObjAnimed,8,20,0,0	; T Glitter (enter/red)
	DEF_SPRITE	0			; B Shadow sphere
	DEF_SPRITE	"KFR1","A0",8,ObjAnimed,8,16,0,0	; O Fire brazier
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"BKYY","A0",10,ObjAnimed,12,20,0,0	; K Blue key

	DEF_SPRITE	"CKYY","A0",9,ObjAnimed,12,20,0,0	; K Yellow key
	DEF_SPRITE	"PTN1","A0",3,ObjAnimed,8,20,0,0	; B Crystal vial (h+10)
	DEF_SPRITE	"PTN2","A0",3,ObjAnimed,8,20,0,0	; B Quartz flask (h+25)
	DEF_SPRITE	"SOAR","A0",3,ObjAnimed,8,20,0,0	; B Wings of wrath
	DEF_SPRITE	"INVU","A0",4,ObjAnimed,8,20,0,0	; B Invulnerability ring
	DEF_SPRITE	"SHLD","A0",0,0,8,20,0,0		; B Shield (a+100)
	DEF_SPRITE	"PWBK","A0",0,0,8,20,0,0		; B Tome of power
	DEF_SPRITE	"VLCO","A0",5,ObjAnimed,8,16,0,0	; O Volcano
	DEF_SPRITE	0
	DEF_SPRITE	0

	DEF_SPRITE	"CLNK","A0",0,ObjTurnAround,64,20,200,-1	; E CLINK
	DEF_SPRITE	0
	DEF_SPRITE	"SNKE","A0",0,ObjTurnAround,56,20,200,-1	; E SNAKE
	DEF_SPRITE	0
	DEF_SPRITE	"KGZB","A0",0,0,8,16,0,0		; O Key gizmo blue
	DEF_SPRITE	"KGZG","A0",0,0,8,16,0,0		; O Key gizmo green
	DEF_SPRITE	"KGZY","A0",0,0,8,16,0,0		; O Key gizmo yellow
	DEF_SPRITE	"KGZ1","A0",0,0,8,16,0,0		; O Gizmo (*)
	DEF_SPRITE	0
	DEF_SPRITE	0

HereticObj1200	DEF_SPRITE	0			; N Scream
	DEF_SPRITE	0			; N Squish
	DEF_SPRITE	0			; N Drops
	DEF_SPRITE	0			; N Slow footsteps
	DEF_SPRITE	0			; N Heartbeat
	DEF_SPRITE	0			; N Bells
	DEF_SPRITE	0			; N Growl
	DEF_SPRITE	0			; N Magic
	DEF_SPRITE	0			; N Laughter
	DEF_SPRITE	0			; N Fast footsteps

HereticObj2000	DEF_SPRITE	0
	DEF_SPRITE	"WBOW","A0",0,0,8,20,0,0		; W Ethereal crossbow	
	DEF_SPRITE	"WMCE","A0",0,0,8,20,0,0		; W Firemace
	DEF_SPRITE	"WPHX","A0",0,0,8,20,0,0		; W Phoenix rod
	DEF_SPRITE	"WSKL","A0",0,0,8,20,0,0		; W Hellstaff
	DEF_SPRITE	"WGNT","A0",0,0,8,20,0,0		; W Gauntlets
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

HereticObj2030	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"PPOD","A0",0,0,16,16,50,-1		; D Gas bag
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

HereticObj4000	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,16,100,-1	; Poulet
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,16,100,-1	; Baton
	DEF_SPRITE	"FX01","A0",0,0,40,16,100,-1		; Baton cristal
	DEF_SPRITE	"FX03","A0",0,ObjTurnAround,40,16,100,-1	; Arbalte
	DEF_SPRITE	"FX17","A0",0,0,40,16,100,-1		; Dragon claw
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,16,100,-1	; Gauntlets
	DEF_SPRITE	"FX02","A0",0,0,40,16,100,-1		; FireMace
	DEF_SPRITE	"FX00","A0",0,0,40,16,100,-1		; Hellstaff
	DEF_SPRITE	"FX04","A0",0,ObjTurnAround,40,16,100,-1	; Phoenix rod
	DEF_SPRITE	0			; Tir de IMPX

	DEF_SPRITE	0			; Tir de WIZARD
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
