; ------------------------------
;	Affiche la barre de status
; ------------------------------

	TEXT
HereticDispStatusBar

	; --- Bord suprieurs

	tst	maponscreen	; Afficher si carte
	bne.s	Heretic_Horns
	
	move	reszoom,d0
	beq	HereticStbar_start

	; si reszoom=1 alors on raffiche
	
;	cmp	#1,d0
;	beq.s	Heretic_Horns
	
	; si reszoom>1 alors faire si redraw

;	tst	StbarSemaphore
;	bmi	HereticStbar_start
	
	; Cote gauche
Heretic_Horns	
	move.l	HereticHautL,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	
	clr	PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
	sub	PrintTY,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY
	
	move.l	a1,a0
	bsr	PrintLumpAdress

	; Cote droit
	
	move.l	HereticHautR,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	
	move	#screenx,d0
	sub	PrintTX,d0
	move	d0,PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
	sub	PrintTY,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY
	
	move.l	a1,a0
	bsr	PrintLumpAdress

	; --- Barre de status

HereticStbar_start
	subq.w	#1,StbarSemaphore
	bmi	HereticStbar_stop

	tst	maponscreen
	bne.s	HereticStbar_yes

	tst	reszoom
	beq	HereticStbar_stop
HereticStbar_yes

	clr	PrintX
	move	#screeny,d0
	sub	StbarHeight,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	move.l	HereticStbar,a0
	bsr	PrintLumpAdress

	; --- Barre normale

	move	#35,PrintX
	move	#screeny+2,d0
	sub	StbarHeight,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	move.l	HereticLife,a0
	bsr	PrintLumpAdress

	; --- Sant

	move	#64,PrintX
	move	#screeny+13,d0
	sub	StbarHeight,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	clr.l	d1
	move	Sante,d1
	lea	HereticIN0,a1
	bsr	PrintNb3
	
	; --- Armure

	move	#231,PrintX
	move	#screeny+13,d0
	sub	StbarHeight,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	clr.l	d1
	move	Armure,d1
	lea	HereticIN0,a1
	bsr	PrintNb3

	; --- Clefs
	
	move	#154,PrintX
	move	#screeny+6,d0
	sub	StbarHeight,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	moveq	#3-1,d0
	lea	HereticBKey,a1
	move	Clefs,d1
.Clefs_bcl
	btst	#0,d1
	beq.s	.Clefs_no

	move.l	(a1),a0
	bsr	PrintLumpAdress
.Clefs_no
	lsr	#1,d1
;	IFEQ	DOUBLE_PIXEL
	addq.w	#8,PrintY
;	ELSE
;	addq.w	#4,PrintY
;	ENDC
	addq	#8,a1
	dbra	d0,.Clefs_bcl
	
	; --- Chaine en bas
	
	; Chaine

	move.l	HereticChain,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo

	move	Sante,d1
	cmp	#100,d1
	bmi.s	.SanteOk1
	move	#100,d1
.SanteOk1
	move.l	#270-22,d0
	mulu	d1,d0
	divu	#100-0,d0
	add	#22+2,d0
	ext.l	d0
	divu	#17,d0
	swap	d0
	move	d0,PrintX

	move	#screeny-1,d0
	sub	PrintTY,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	move.l	a1,a0
	bsr	PrintLumpAdress
	
	; Cote gauche

	move.l	HereticBasL,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo

	clr	PrintX
	move	#screeny,d0
	sub	PrintTY,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY
	
	move.l	a1,a0
	bsr	PrintLumpAdress
	
	; Cote droit

	move.l	HereticBasR,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo

	move	#screenx,d0
	sub	PrintTX,d0
	move	d0,PrintX
	move	#screeny,d0
	sub	PrintTY,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY
	
	move.l	a1,a0
	bsr	PrintLumpAdress

	; Gemme de vie
	; 100 -> 270
	; 0 -> 22
	
	lea	HereticLife0,a0

	move	Sante,d1
	cmp	#100,d1
	bmi.s	.SanteOk
	move	#100,d1
.SanteOk
	move	d1,d2
	ext.l	d2
	divu	#26,d2
	lsl	#3,d2
	add	d2,a0

	move.l	#270-22,d0
	mulu	d1,d0
	divu	#100-0,d0
	add	#22,d0
	move	d0,PrintX
	
	move	#screeny-9,d0
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY

	move.l	(a0),a0
	bsr	PrintLumpAdress
	
	; --- Fin
HereticStbar_stop
	rts

; -------------	Cherche l'adresse de la barre avant de l'afficher

	TEXT
HereticInitStbar
	move.l	dir_start,a1
	move.l	dir_end,a2

	lea	HereticStbar,a6
	move	#(3+10+4+3+4)-1,d0
Heretic_stbar_bcl
	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)

	addq	#8,a6
	dbra	d0,Heretic_stbar_bcl

	; Hauteur de la barre de status

	move.l	HereticStbar,a0
	move.l	(a0),a0
	addq	#2,a0
	INVERSE_MOT2	a0,d0
	move	d0,StbarHeight

	move.l	#HereticDispStatusBar,StatusBarRout

	; Inits
	
	move	#100,Sante
	move	#0,Armure

	move	#%111,Clefs
	rts

	DATA
HereticStbar	dc.b	"BARBACK",0
HereticLife	dc.b	"LIFEBAR",0
HereticChain	dc.b	"CHAIN",0,0,0

HereticIN0	dc.b	"IN0",0,0,0,0,0
HereticIN1	dc.b	"IN1",0,0,0,0,0
HereticIN2	dc.b	"IN2",0,0,0,0,0
HereticIN3	dc.b	"IN3",0,0,0,0,0
HereticIN4	dc.b	"IN4",0,0,0,0,0
HereticIN5	dc.b	"IN5",0,0,0,0,0
HereticIN6	dc.b	"IN6",0,0,0,0,0
HereticIN7	dc.b	"IN7",0,0,0,0,0
HereticIN8	dc.b	"IN8",0,0,0,0,0
HereticIN9	dc.b	"IN9",0,0,0,0,0

HereticHautL	dc.b	"LTFCTOP",0
HereticHautR	dc.b	"RTFCTOP",0
HereticBasL	dc.b	"LTFACE",0,0
HereticBasR	dc.b	"RTFACE",0,0

HereticBKey	dc.b	"BKEYICON"
HereticYKey	dc.b	"YKEYICON"
HereticGKey	dc.b	"GKEYICON"

HereticLife0	dc.b	"LIFEGEM2"
HereticLife1	dc.b	"LIFEGEM1"
HereticLife2	dc.b	"LIFEGEM0"
HereticLife3	dc.b	"LIFEGEM3"
