; ---------------------------------------------
;	Gestion des interruptions
;	et hardware
; ---------------------------------------------

; -----------------------------	
;	Init
; -----------------------------	

	TEXT
Interrupts_init
	move	#$2700,sr

	move.l	$fffffa06.w,_mask_inter
	clr.l	$fffffa06.w

	bsr	IT_Timer35hz_init
	bsr	IT_ikbd_init
	bsr	IT_video_init
	bsr	IT_music_init

	move	#$2300,sr
	rts

	BSS
_mask_inter	ds.l	1

; -----------------------------	
;	Restauration
; -----------------------------	

	TEXT
Interrupts_restaure
	move	#$2700,sr

	move.l	_mask_inter,$fffffa06.w

	bsr	IT_Timer35hz_restaure
	bsr	IT_ikbd_restaure
	bsr	IT_video_restaure
	bsr	IT_music_restaure
	
	move	#$2300,sr
	rts
