; ------------------------------
;	L'arme est un objet de la scne
; ------------------------------

; -------------	Init les armes
;	a6 Adresse des donnes des armes

	TEXT
InitWeapons
	move.l	snames_start,a1
	move.l	snames_end,a2
	move.l	WeaponsList,a6

	REPT	9
	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)
	addq	#8,a6
	ENDR

	clr	current_weapon
	rts

	BSS
current_weapon	ds.w	1

; -------------	Changement des armes

TEST_WEAPON	MACRO	touche,numero
	tst.b	\1+clavier
	beq.s	.no_weapon\@
	clr.b	\1+clavier
	move	\2,current_weapon
	move	#2,StbarSemaphore
.no_weapon\@
	ENDM

	TEXT
ChangeWeapons
	TEST_WEAPON	K_1A,#0
	TEST_WEAPON	K_2A,#1
	TEST_WEAPON	K_3A,#2
	TEST_WEAPON	K_4A,#3
	TEST_WEAPON	K_5A,#4
	TEST_WEAPON	K_6A,#5
	TEST_WEAPON	K_7A,#6
	TEST_WEAPON	K_8A,#7
	TEST_WEAPON	K_9A,#8

	rts

; -------------	Affiche l'arme comme objet de la scene
;	d6	player_x
;	d7	player_y
;	a2	Observateur
;	a5	element de la pile
;	a6	$ffffa202.w

	TEXT
AfficheArmeScene
	movem.l	d6-d7,-(sp)

	; Envoie les donnes du SECTOR de l'observateur

	move	OBJET_SSECTOR(a2),d0
	mulu	#SIZEOF_SSECTOR,d0
	move.l	(SSECTOR_SECTOR,[adr_ssectors],d0.l),a4

	move	SECTOR_CEILING(a4),d0
	ext.l	d0
	move	SECTOR_FLOOR(a4),d1
	ext.l	d1
	move	SECTOR_BRIGHT(a4),d2
	ext.l	d2

	DSPWAITINPUT	(a6)
	move.l	#"SEC",2(a6)
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; local_ceiling1
	DSPWAITINPUT	(a6)
	move.l	d1,2(a6)	; local_floor1
	DSPWAITINPUT	(a6)
	move.l	d2,2(a6)	; local_bright

	; Envoie l'arme

	move.l	WeaponsList,a0
	move	current_weapon,d0
	lsl	#3,d0
	move.l	(a0,d0.w),a0
	cmp.l	#0,a0
	beq	AAS_stop
	move.l	(a0),a0

	move.l	a0,DRAW_OBJ_ADR(a5)
	clr	DRAW_OBJ_SYM(a5)

	; Calcul positions X et Y

	move.l	#screenx/2,d6
	move.l	d6,d7

	move	OBJET_A(a2),d0

	muls.l	([cosinus],d0.w),d6
	add.l	OBJET_X(a2),d6
	swap	d6
	ext.l	d6

	muls.l	([sinus],d0.w),d7
	add.l	OBJET_Y(a2),d7
	swap	d7
	ext.l	d7

	; Calcul position Z

	move	StbarHeight,d2

	move	OBJET_Z(a2),d0
	add	OBJET_H(a2),d0
	add	ecr_ligne,d0
	sub	resy,d0
;	move.l	#screeny/2,d4
;	divu	ScreenRatioY,d4

;	move	reszoom,d1
;	beq.s	AffArmSce_offy1
;	sub	d2,d4
;	move	d2,d3
;	lsr	#1,d3
;	sub	d3,d0
;	cmp	#2,d1
;	bmi.s	AffArmSce_offy1
;	lsl	#3,d1
;	sub	d1,d4
;AffArmSce_offy1
;	sub	d4,d0

	move	current_weapon,d1
	cmp	#3,game_type
	beq.s	AffArmSce_offy2_heretic

	cmp	#5,d1
	bmi.s	AffArmSce_offy2_done
	cmp	#7,d1
	bne.s	AffArmSce_offy2_yes
	lsr	#1,d2
	bra.s	AffArmSce_offy2_yes
AffArmSce_offy2_heretic
	cmp	#4,d1
	beq.s	AffArmSce_offy2_yes
	lsr	#1,d2
	cmp	#1,d1
	beq.s	AffArmSce_offy2_yes
	cmp	#6,d1
	beq.s	AffArmSce_offy2_yes
	bra.s	AffArmSce_offy2_done

AffArmSce_offy2_yes
	sub	d2,d0
AffArmSce_offy2_done

	; On envoie tout

	DSPWAITINPUT	(a6)
	move.l	#"THI",2(a6)

	DSPWAITINPUT	(a6)
	move.l	d6,2(a6)	; position x
	DSPWAITINPUT	(a6)
	move.l	d7,2(a6)	; position y
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; position z

	INVERSE_MOT2	a0,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; taille x
	
	INVERSE_MOT2	a0,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; taille y

	move	#screenx/2,d0
	INVERSE_MOT2	a0,d1
	add	d1,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; offset x
	
	INVERSE_MOT2	a0,d0
	ext.l	d0
	DSPWAITINPUT	(a6)
	move.l	d0,2(a6)	; offset y

	DSPWAITOUTPUT	(a6)
	tst	4(a6)
	bne.s	AAS_stop
	
	; Ajouter dans la pile
	
	lea	SIZEOF_DRAW(a5),a5
	addq.w	#1,draw_sprites
	cmp	#MAX_SPRITES,draw_sprites
	bmi.s	AAS_stop
	move	#-1,sprites_flag
AAS_stop
	movem.l	(sp)+,d6-d7
	rts
