; ------------------------------
;	Gestion d'un menu
; ------------------------------

	TEXT
DisplayMenu
	move	MenuActif,d0
	lea	([MenuTable],d0.w*8),a1
	move	4(a1),d7	; n ieme option slectionnable
	move.l	(a1),a1	; a1 adresse menu
	move.l	a1,a4
DisplayMenu_bcl
	cmp.l	#0,MENU_TITLE(a1)
	beq	DisplayMenu_stop

; -------------	Slectionnable ?

	cmp	#MENU_SEL,MENU_SELECTABLE(a1)
	bne.s	.NotSelectable
	subq.w	#1,d7
	bpl.s	.NotSelectable
	move.l	a1,a4
	move	#$7fff,d7
.NotSelectable

; -------------	Affichage d'un sprite

DisplayMenu_lump?
	cmp	#MENUTYPE_LUMP,MENU_TYPE(a1)
	bne.s	DisplayMenu_string?
	
	move	MENU_X(a1),PrintX
;	IFEQ	DOUBLE_PIXEL
	move	MENU_Y(a1),PrintY
;	ELSE
;	move	MENU_Y(a1),d0
;	lsr	#1,d0
;	move	d0,PrintY
;	ENDC
	move.l	MENU_TITLE(a1),a0
	move.l	(a0),a0
	bsr	PrintLumpAdress
	bra	DisplayMenu_next

; -------------	Affichage d'une chaine de caractres

DisplayMenu_string?
	cmp	#MENUTYPE_STRING,MENU_TYPE(a1)
	bne.s	DisplayMenu_flag?

	move	MENU_X(a1),PrintX
;	IFEQ	DOUBLE_PIXEL
	move	MENU_Y(a1),PrintY
;	ELSE
;	move	MENU_Y(a1),d0
;	lsr	#1,d0
;	move	d0,PrintY
;	ENDC

	move.l	MENU_TITLE(a1),a3
	move.l	MenuFonte,a2
DMstring_bcl
	clr	d0
	move.b	(a3)+,d0
	beq	DisplayMenu_next
	moveq	#8,d1
	sub	#32,d0
	beq.s	DMstring_next
	bmi.s	DMstring_next
	cmp	#59,d0
	bpl.s	DMstring_next
	lsl	#4,d0	
	lea	(a2,d0.w),a0

	bsr	PrintLumpAdress

	move	PrintTX,d1
	addq	#1,d1
DMstring_next	add	d1,PrintX
	bra	DMstring_bcl
	
; -------------	Affichage d'un flag

DisplayMenu_flag?
	cmp	#MENUTYPE_FLAG,MENU_TYPE(a1)
	bne.s	DisplayMenu_field?
	bra	DisplayMenu_next

; -------------	Affichage d'un champ ditable

DisplayMenu_field?
	cmp	#MENUTYPE_FIELD,MENU_TYPE(a1)
	bne	DisplayMenu_cursor?

	move	MENU_X(a1),PrintX
	move	MENU_Y(a1),d0

	cmp	#3,game_type
	beq.s	DM_field_heretic
	add	#12,d0
DM_field_heretic
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	move	d0,PrintY
	
	; Affichage cote gauche

	moveq	#0,d0
	tst.l	FieldLeft
	beq.s	DM_fieldcenter
	moveq	#15,d0
	move.l	FieldLeft,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d1,PrintX

	; Affichage centre

DM_fieldcenter	tst.l	FieldCenter
	beq.s	DM_fieldright
.boucle	move.l	FieldCenter,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d1,PrintX
	dbra	d0,.boucle

	; Affichage cote droit

DM_fieldright	tst.l	FieldRight
	beq.s	DM_fieldcont
	move.l	FieldRight,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d1,PrintX

	; Affichage du contenu
DM_fieldcont
	bra	DisplayMenu_next
	
; ------------- Affichage d'un curseur

DisplayMenu_cursor?
	cmp	#MENUTYPE_VAR,MENU_TYPE(a1)
	bne	DisplayMenu_next

	move	MENU_X(a1),PrintX
;	IFEQ	DOUBLE_PIXEL
	move	MENU_Y(a1),PrintY
;	ELSE
;	move	MENU_Y(a1),d0
;	lsr	#1,d0
;	move	d0,PrintY
;	ENDC

	; Affiche cote gauche

	moveq	#0,d4	; Dcalage pour curseur
	cmp	#3,game_type
	beq.s	CurHeretic
	moveq	#-1,d4
CurHeretic

	move.l	CurseurGauche,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d4,d1
	add	d1,PrintX
	move	PrintX,d2	; Minimal pour le curseur

	; Affiche centre

	moveq	#11,d0
.boucle
	move.l	CurseurMil1,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d4,d1
	add	d1,PrintX

	move.l	CurseurMil2,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d4,d1
	add	d1,PrintX

	dbra	d0,.boucle
	move	PrintX,d3	; Maximum pour le curseur

	; Affiche cote droit

	move.l	CurseurDroit,a0
	bsr	PrintLumpAdress
	move	PrintTX,d1
	add	d1,PrintX

	; Affiche curseur

	; X = d2+(valeur/max)*(d3-d2)

	move	d3,d1
	sub	d2,d1
	
	move.l	MENU_TITLE(a1),a0	; Adresse variable
	move	(a0),d0		; Variable
	mulu	d1,d0
	divu	MENU_MAX(a1),d0
	add	d2,d0
	move	d0,PrintX

	moveq	#7,d0
	cmp	#3,game_type
	beq.s	CurHeretic1
;	IFNE	DOUBLE_PIXEL
;	moveq	#2,d0
;	ELSE
	moveq	#0,d0
;	ENDC
CurHeretic1

;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d0
;	ENDC
	add	d0,PrintY
	move.l	CurseurSprite,a0
	bsr	PrintLumpAdress
;	bra.s	DisplayMenu_next

DisplayMenu_next
	lea	SIZEOF_MENU(a1),a1
	bra	DisplayMenu_bcl
DisplayMenu_stop

; -------------	Affichage du slecteur
;	a4	adresse de l'option ou se trouve le selecteur

	move	MENU_X(a4),d0
	sub	#32,d0
	move	d0,PrintX

;	IFEQ	DOUBLE_PIXEL
	move	MENU_Y(a4),PrintY
;	ELSE
;	move	MENU_Y(a4),d0
;	lsr	#1,d0
;	move	d0,PrintY
;	ENDC

	move.l	Selector1,a0
	move.l	game_timer,d0
	btst	#4,d0
	beq.s	.NotSel2
	move.l	Selector2,a0
.NotSel2
	bsr	PrintLumpAdress
	rts

	BSS
display_menu	ds.w	1	; Affichage ou non du menu ?
