; ---------------------------------------------
;	Affichage du plafond
; ---------------------------------------------
	
	ORG	p:
RenderPlafond
	clr	b	x:xe1,a
	move	b,l:ligne_scoef
	move	b,l:ligne_ecoef
	
	move	a,l:ligne_start
	move	x:xe2,a
	move	a,l:ligne_end
	
	move	x:local_plafond11,a
	move	a,x:ligne_fin
	move	x:local_plafond12,b
	
	sub	a,b	#>128*2,y1
	jeq	<fin_calcul_coef_plafond
	jpl	<ye1_sup_ye2_plafond
ye2_sup_ye1_plafond
	move	x:xe1,a
	move	a,l:ligne_end
	move	x:local_longueur,x0
	mpy	y1,x0,a	b,x1
	jsr	<division_entiere
	rep	#8-2
	asr	a
	asr	a	x:local_plafond11,b
	asr	a	b,x:ligne_fin
	move	a,l:ligne_ecoef

	jmp	<fin_calcul_coef_plafond
ye1_sup_ye2_plafond
	move	x:xe2,a
	move	a,l:ligne_start
	move	x:local_longueur,x0
	mpy	-y1,x0,a	b,x1
	jsr	<division_entiere
	rep	#8-2
	asr	a
	asr	a	x:local_plafond12,b
	asr	a	b,x:ligne_fin
	move	a,l:ligne_scoef
fin_calcul_coef_plafond

; -------------	Inits de l'affichage
;	0<=ligne<ecr_ligne

;	move	#>0,y0
	move	x:ecr_ligne,y1

	move	x:ye1,a
;	cmp	y0,a
;	tlt	y0,a
	cmp	y1,a	x:ligne_fin,b
	tgt	y1,a

;	cmp	y0,b
;	tlt	y0,b
	cmp	y1,b	#>1,x0
	tgt	y1,b

	WRITEHOST	a
	WRITEHOST	b
	
	sub	a,b	a,x:ligne_encours
	jmi	<fin_trace_plafond
	add	x0,b	b,x:sauvegarde
	move	b,x:ligne_dy

; -------------	Recalcule points de depart en fonction de ligne_depart

	clr	a	l:ligne_scoef,y
	move	y0,a0
	asr	a	x:sauvegarde,x0
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b	l:ligne_ecoef,y
	add	b,a	l:ligne_start,b
	add	a,b	l:ligne_scoef,a
	neg	a	b,l:ligne_start

	clr	a	a,l:ligne_scoef
	move	y0,a0
	asr	a	x:sauvegarde,x0
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	l:ligne_end,b
	add	a,b	l:ligne_ecoef,a
	neg	a	b,l:ligne_end
	move	a,l:ligne_ecoef

; -------------	Calcul des coefs pour le mapping

	move	x:local_ceiling1,a
	neg	a	x:sinus,x0
	move	a,x:ligne_hauteur
	move	a,y0

	mpy	x0,y0,a	y0,x:sauvegarde
	asr	a	x:cosinus,x0
	
	mpy	x0,y0,a	a,l:ligne_xc
	asr	a	x:resx,b
	
	neg	b	a,l:ligne_yc
	asr	b	x:sinus,a
	move	b,x0		; x0 = -resx/2

	move	x:cosinus,b
	sub	b,a
	move	a,x1
	mpy	x1,y0,b
	asr	b
	clr	a
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	x:cosinus,b
	move	a,l:ligne_xs
	
	move	x:sinus,a
	add	b,a	x:sauvegarde,y0
	move	a,x1
	mpy	x1,y0,b
	asr	b
	clr	a
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	x:ligne_dy,b
	move	a,l:ligne_ys

; -------------	Affichage du plafond

	do	b,fin_trace_plafond

	move	x:xe2,y1

	move	x:ligne_start,a
	cmp	y1,a	x:xe1,y0
	jgt	<plafond_horsecran
	cmp	y0,a	x:ligne_end,b
	tmi	y0,a

	cmp	y0,b	a,x1
	jmi	<plafond_horsecran
	cmp	y1,b
	tpl	y1,b
	
	cmp	a,b	b,x0
	jmi	<plafond_horsecran

	WRITEHOST	a
	WRITEHOST	b
	
	move	x,l:sauvegarde

; -------------	Calcul du mapping pour la ligne en cours

	move	#>$020000,x1
	move	x:ratiox,y0
	mpy	x1,y0,a	x:ratioy,x1
;	clr	a	x:ratioy,x1
;	move	#>$040000,a0
	jsr	<division_entiere
	move	a,y0

	clr	a	x:ligne_encours,b
	move	x:ecr_ligne,x0
	sub	x0,b	y0,a0
	move	b,x0
	and	#$fe,ccr
	rep	#24
	div	x0,a		; 1/y
	move	a0,a
	neg	a	l:ligne_xc,b	; Calcul coef x
;	move	a,x0

	rep	#16-1
	asr	b
	asr	b	a,x0
	clr	a	#>$ffff,n0
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	l:ligne_yc,b	; Calcul coef y

	rep	#16
	asr	b
	clr	a	a,l:ligne_xc1
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	l:ligne_xs,b	; Calcul depart x

	rep	#16
	asr	b
	clr	a	a,l:ligne_yc1
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b	x:sauvegarde,x1
	add	b,a	l:ligne_xc1,y

	clr	a	a,l:ligne_xs1
	move	y0,a0
	asr	a
	mpy	x1,y1,b	a0,y0
	mpy	x1,y0,a	b0,b
	asr	b
	add	b,a	l:ligne_xs1,b
	add	b,a	l:player_x,b
	add	b,a	l:ligne_ys,b	; Calcul depart y

	rep	#16
	asr	b
	clr	a	a,l:ligne_xs1
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b	x:sauvegarde,x1
	add	b,a	l:ligne_yc1,y

	clr	a	a,l:ligne_ys1
	move	y0,a0
	asr	a
	mpy	x1,y1,b	a0,y0
	mpy	x1,y0,a	b0,b
	asr	b
	add	b,a	l:ligne_ys1,b
	add	b,a	l:player_y,b
	sub	b,a
	move	a,l:ligne_ys1

	; Calcul lumiere

	move	x:ligne_hauteur,x1
	move	x:resy,y0
	mpy	x1,y0,b
	clr	a
	move	b0,a0
	asr	a	b1,y1
	mpy	x0,y1,b	a0,y0
	mpy	x0,y0,a	b0,b
	asr	b
	add	b,a	#>160,x1
	rep	#9
	asr	a
	jsr	<division_entiere
	move	a,x:mur_ymapping
	
	CALCUL_LUMIERE
	WRITEHOST	x:to030_lum

	move	l:ligne_xs1,a
	rep	#7
	asr	a
	asr	a	l:ligne_ys1,b
	WRITEHOST	a0
	rep	#7
	asr	b
	asr	b	l:ligne_xc1,a
	WRITEHOST	b0
	rep	#7
	asr	a
	asr	a	l:ligne_yc1,b
	WRITEHOST	a0
	rep	#8
	asr	b
	WRITEHOST	b0
	jmp	<fin_trace_ligne_plafond

plafond_horsecran
	WRITEHOST	#>-1
fin_trace_ligne_plafond
	move	l:ligne_start,a		; Affichage
	move	l:ligne_scoef,x
	add	x,a	l:ligne_end,b
	move	l:ligne_ecoef,y
	add	y,b	a,l:ligne_start

	move	#>1,x0
	move	x:ligne_encours,a
	add	x0,a	b,l:ligne_end
	move	a,x:ligne_encours
fin_trace_plafond
	jmp	<attente
