; ------------------------------
;	Affichage d'un sprite
; ------------------------------
;	seg_x1	thing_tx
;	seg_y1	thing_ty
;	seg_x2	thing_ox
;	seg_y2	thing_oy

	ORG	X:
sprite_symetrie	ds	1

	ORG	P:
RenderSprite
	move	#>128*256,x0

	move	x:local_ceiling2,x1
	mpy	-x0,x1,a	x:local_floor2,y1
	mpy	-x0,y1,b	a,x:colonne_start
	move	b,x:colonne_end
	
	move	#>trace_K,r4
	move	x:xe1,n4
	nop
	lua	(r4)+n4,r4

	; Calcul du dnominateur

	move	x:seg_orig_x2,b
	move	x:seg_orig_x1,y0	; b=(16:32)
	move	x:seg_orig_y2,a
	move	x:seg_orig_y1,x0
	sub	x0,a	x:(r4),x1
	sub	y0,b	a,y1
	mpy	-x1,y1,a		; (8:16)*(16:8)=(24:24)
	rep	#8-4
	asl	a		; a=(16:32)
	asl	a	x:seg_orig_x1,x0
	asl	a	x:seg_orig_y1,y0
	asl	a	x:seg_orig_x2,x1
	add	a,b	x:seg_orig_y2,y1

	; Calcul du numrateur
	
	mpy	y0,x1,a	b,x1	; y1*x2
	mac	-x0,y1,a	x:lumiere_const,x0	; y1*x2-x1*y2 (32:16)
	
	; Calcul de Y
	
	jsr	<division_signee
	
; -------------	Calcul de distance

	move	a,x1
	mpy	x0,x1,a	a,x:mur_ymapping
	rep	#8+1
	asr	a
	move	a0,x:to030_ycoef

	CALCUL_LUMIERE

; -------------	Taille X du sprite

	move	#>sprite_symetrie,r0
	READHOST	x:(r0)

	WRITEHOST	x:to030_ycoef
	WRITEHOST	x:to030_lum

; -------------	Boucle colonne

	move	x:local_longueur,b
	do	b,fin_trace_sprite

	; Calcul de X

	move	x:mur_ymapping,x1
	move	x:(r4),x0
	mpy	x0,x1,a
	rep	#8-2
	asl	a
	asl	a	x:seg_orig_x1,b
	sub	b,a	a,x:mur_xmapping
	rep	#8-1
	asr	a
	asr	a	x:seg_x1,b
	move	a,x:to030_x

	; Symetrie ?

	jclr	#15,x:(r0),sprite_yes_symetrie
	tfr	a,b	b,a
	sub	b,a
;	move	a,x:to030_x
sprite_yes_symetrie

	; si en dehors : fin_trace_col_sprite_out

	tst	a	x:seg_x1,b
	jmi	<fin_trace_col_sprite_out
	cmp	b,a	a,x:to030_x
	jpl	<fin_trace_col_sprite_out

	; Envoie les donnes de la colonne

	WRITEHOST	x:to030_x

	; Attends les donnes d'un morceau de la colonne
sprite_lire_col
	move	#>"OUT",a
	READHOST	y0		; Ligne de depart dans sprite
	cmp	y0,a	x:to030_ycoef,x1
	jeq	<fin_trace_col_sprite
	READHOST	y1		; Nb de lignes  tracer

;	move	x:to030_ycoef,x1

	; ecran=ecr_ligne+(player_h-hauteur_mur)/ycoef

;	move	x:ecr_ligne,x0

	; Point de depart ecran

	move	x:colonne_start,a
	add	y0,a
	rep	#7-2
	asr	a
	asr	a	y0,x:to030_y	; Numro de ligne de dpart dans sprite
	asr	a	x:ecr_ligne,x0
	jsr	<division_entiere
;	tst	a	#>1,b
;	jle	<_mur_debme1
;	add	b,a
;_mur_debme1
	add	x0,a
	move	a,x:to030_colstart

	; Point d'arrivee ecran

	move	x:colonne_start,a
	add	y0,a
	add	y1,a
	rep	#7
	asr	a
	jsr	<division_entiere
;	tst	a	#>1,b
;	jge	<_mur_finp1
;	sub	b,a
;_mur_finp1
	add	x0,a	x:ye2,y1
	move	a,x:to030_colend

	; Clipping ecran

;	move	x:ye2,y1
	move	x:to030_colstart,a
	move	a,x0
	
	cmp	y1,a	x:ye1,y0
	jpl	<sprite_col_out
	cmp	y0,a	x:to030_colend,b
	tmi	y0,a

	cmp	y0,b
	jmi	<sprite_col_out
	cmp	y1,b	a,x:to030_colstart ; Y de depart
	tgt	y1,b
	
	cmp	a,b	b,x:to030_colend   ; Y de fin
	jmi	<sprite_col_out

	; Point de depart Y

	sub	x0,a	x:to030_ycoef,x1
	move	a,x0
	mpy	x0,x1,a	#>128*256,y1
	asr	a	x:to030_y,x1
;	mac	-x1,y1,a
	move	a0,x:to030_y		; (8:16)

	; Envoi du morceau

	WRITEHOST	x:to030_colstart
	WRITEHOST	x:to030_colend
	WRITEHOST	x:to030_y
	jmp	<fin_sprite_lire_col

sprite_col_out
	WRITEHOST	#>-1
fin_sprite_lire_col
	jmp	<sprite_lire_col

; -------------	Colonne suivante

fin_trace_col_sprite_out
	WRITEHOST	#>-1
fin_trace_col_sprite
	lua	(r4)+,r4	; Colonne suivante
fin_trace_sprite
	jmp	<attente
