; ----------------------------------------------
;	Animations des textures
; ----------------------------------------------

ANIM_SPEED	=	10

; -------------	Initialise les animations

	TEXT
init_animations
	; Init walls

	clr	anim_wall_max
	lea	wall_anim_names,a0
	lea	anim_wall_nb,a1
	moveq	#15-1,d7
init_anim_bcl
	bsr	cherche_texnum
	move	d0,d6
	bmi.s	inan_bcl_next
	
	addq	#8,a0
	bsr	cherche_texnum
	subq	#8,a0
	move	d0,d5
	bmi.s	inan_bcl_next

	addq.w	#1,anim_wall_max
	move	d6,(a1)+
	sub	d6,d5
	move	d5,(a1)+
inan_bcl_next
	lea	16(a0),a0
	dbra	d7,init_anim_bcl

	; Init flats

	clr	anim_flat_max
	lea	flat_anim_names,a6
	lea	anim_flat_nb,a5
	move.l	fnames_start,a1
	move.l	fnames_end,a2
	moveq	#15-1,d0
init_flat_bcl
	move.l	a6,a0
	bsr	cherche_adresse
	cmp.l	#0,a0
	beq.s	init_flat_nxt
	move.l	a0,d7
	
	lea	8(a6),a0
	bsr	cherche_adresse
	cmp.l	#0,a0
	beq.s	init_flat_nxt
	move.l	a0,d6

	addq.w	#1,anim_flat_max
	
	move.l	d7,(a5)+
	sub.l	d7,d6
	lsr.l	#4,d6
	move.l	d6,(a5)+
init_flat_nxt
	lea	16(a6),a6
	dbra	d0,init_flat_bcl
	rts

	DATA
wall_anim_names	dc.b	"BLODGR1",0	; animation 1	DOOM 1
	dc.b	"BLODGR4",0
	dc.b	"BLODRIP1"	; animation 2
	dc.b	"BLODRIP4"
	dc.b	"FIREBLU1"	; animation 3
	dc.b	"FIREBLU2"
	dc.b	"FIRELAV3"	; animation 4
	dc.b	"FIRELAVA"
	dc.b	"FIREMAG1"	; animation 5
	dc.b	"FIREMAG3"
	dc.b	"FIREWALA"	; animation 6
	dc.b	"FIREWALL"
	dc.b	"GSTFONT1"	; animation 7
	dc.b	"GSTFONT3"
	dc.b	"ROCKRED1"	; animation 8
	dc.b	"ROCKRED3"
	dc.b	"SLADRIP1"	; animation 9
	dc.b	"SLADRIP3"

	dc.b	"BFALL1",0,0	; animation 10	DOOM 2
	dc.b	"BFALL4",0,0
	dc.b	"SFALL1",0,0	; animation 11
	dc.b	"SFALL4",0,0
	dc.b	"WFALL1",0,0	; animation 12
	dc.b	"WFALL4",0,0
	dc.b	"DBRAIN1",0	; animation 13
	dc.b	"DBRAIN4",0

	dc.b	"LAVAFL1",0	; animation 14 HERETIC
	dc.b	"LAVAFL3",0
	dc.b	"WATRWAL1"	; animation 15
	dc.b	"WATRWAL3"

flat_anim_names	dc.b	"NUKAGE1",0	; animation 1	DOOM 1
	dc.b	"NUKAGE3",0
	dc.b	"FWATER1",0	; animation 2
	dc.b	"FWATER4",0
	dc.b	"SWATER1",0	; animation 3
	dc.b	"SWATER4",0
	dc.b	"LAVA1",0,0,0	; animation 4
	dc.b	"LAVA4",0,0,0
	dc.b	"BLOOD1",0,0	; animation 5
	dc.b	"BLOOD3",0,0

	dc.b	"RROCK05",0	; animation 6	DOOM 2
	dc.b	"RROCK08",0
	dc.b	"SLIME01",0	; animation 7
	dc.b	"SLIME04",0
	dc.b	"SLIME05",0	; animation 8
	dc.b	"SLIME08",0
	dc.b	"SLIME09",0	; animation 9
	dc.b	"SLIME12",0

	dc.b	"FLTWAWA1"	; animation 10	HERETIC
	dc.b	"FLTWAWA3"
	dc.b	"FLTSLUD1"	; animation 11
	dc.b	"FLTSLUD3"
	dc.b	"FLTFLWW1"	; animation 12
	dc.b	"FLTFLWW3"
	dc.b	"FLTTELE1"	; animation 13
	dc.b	"FLTTELE4"
	dc.b	"FLTLAVA1"	; animation 14
	dc.b	"FLTLAVA4"
	dc.b	"FLATHUH1"	; animation 15
	dc.b	"FLATHUH4"

	BSS
anim_wall_max	ds.w	1	; Nb de murs  animer
anim_wall_nb	ds.w	2*15	; txt debut, longueur

anim_flat_max	ds.w	1	; Nb de sols  animer
anim_flat_nb	ds.l	2*15	; adr debut, longueur
	
; -------------	Animer

	TEXT
animation_textures
	move.l	game_timer,d0
	sub.l	anim_vbl,d0

	cmp.l	#ANIM_SPEED,d0
	bmi.s	animation_textures_fin
	move.l	game_timer,anim_vbl

	move	anim_wall_max,d0
	beq.s	animation_wall_fin
	subq	#1,d0
	lea	anim_wall_nb,a0
	move.l	texture_cmalloc,a1
anitex_bcl
	move	(a0)+,d1	; premiere texture
	move	(a0)+,d2	; longueur
	subq	#1,d2
	lea	(a1,d1.w*2),a2
	move	(a2),d3	; sauver la premiere
anitex_bclswp	move	2(a2),(a2)+
	dbra	d2,anitex_bclswp
	move	d3,(a2)
	dbra	d0,anitex_bcl	
animation_wall_fin
	
	move	anim_flat_max,d0
	beq.s	animation_flat_fin
	subq	#1,d0
	lea	anim_flat_nb,a0
anifla_bcl
	move.l	(a0)+,a1	; adr premier flat
	move.l	(a0)+,d1	; Nb de flats
	subq	#1,d1
	move.l	(a1),d2
anifla_bclswp	move.l	16(a1),(a1)
	lea	16(a1),a1
	dbra	d1,anifla_bclswp
	move.l	d2,(a1)
	dbra	d0,anifla_bcl
animation_flat_fin

animation_textures_fin
	rts
	
	BSS
anim_vbl	ds.l	1	; Nb de vbls depuis le dernier appel
