; -----------------------------
;	Calcul ARCTAN
; -----------------------------
;	ATN d'une valeur positive
; x,y,a,b utiliss
; Valeur renvoye dans A

ARCTAN	MACRO	valeur
	move	valeur,a
	abs	a	a,x:>arctan_x
	move	a,x:>arctan_absx

	clr	a	x:>arctan_absx,x0
	move	#>1,x1
	mpy	x0,x1,a
	rep	#3
	asr	a
	mpy	x0,x0,b	a0,a
	asr	b
	asr	b	#>$200000,x1
	add	x1,b
	move	b,x1
	jsr	<division_entiere
	move	a,x:>arctan_a		; A=x/(1+x^2)

	move	x:>arctan_absx,x0
	mpy	x0,x0,a	#>1,x0
	move	a,b
	addl	b,a		; B=3*x^2

	move	a,y0
	mpy	x0,y0,a	#>0,x1
	rep	#4
	asr	a
	tfr	a,b	#>$100000,x0
	sub	x,a	#>$300000,x0
	add	x,b	a0,a
	move	b0,x1
	jsr	<division_entiere
	move	a,x0	; (b-1)/(b+3)

	move	x:>arctan_a,y0
	mpy	x0,y0,a	#>1,x0
	move	a,y0
	mpy	x0,y0,a
	add	x0,a	x:>arctan_a,x0
	asr	a	x:>arctan_absx,y0
	mpy	x0,y0,a	a0,x0
	move	a,y0
	mpy	x0,y0,a	#>1,x0
	move	a,y0
	mpy	x0,y0,a
	add	x0,a
	asr	a
	asr	a	x:>arctan_a,x0
	move	a0,y0
	mpy	x0,y0,a
	asl	a	x:>arctan_x,x0

	jclr	#23,x0,arctan_positif
	neg	a
arctan_positif
	ENDM

	ORG	x:
arctan_x	ds	1	; x	1,23
arctan_absx	ds	1	; abs(x)
arctan_a	ds	1	; x/(1+x^2)	1,23
