; -----------------------------------------------
;	Rception de la taille de l'ecran
; -----------------------------------------------

	ORG	p:
BuildScene
	move	x:resx,a
	move	a,x:resx_old

	READHOST	x:time
;	asr	a
;	asr	a
;	move	a,x:time

	READHOST	x:ciel_offset
	
	READHOST	x:resx
	READHOST	x:resy
	READHOST	x:ratiox
	READHOST	x:ratioy

	READHOST	x:player_x
	READHOST	x:player_y
	READHOST	x:player_a
	READHOST	x:player_h

	READHOST	x:ecr_ligne

	READHOST	x:sinus	; Pour le sol/plafond
	READHOST	x:cosinus

	READHOST	x:node_cos	; Pour les nodes
	READHOST	x:node_sin

	READHOST	x:seg_cosinus	; Pour les segs
	READHOST	x:seg_sinus

	clr	a	x:resx,x1
	move	#>320*200*2,a0
	jsr	<division_entiere
	move	a,y1
	move	x:ratioy,x1
	mpy	x1,y1,a
	move	a0,x:lumiere_const

	clr	a	x:ratiox,x1
	move	x:resx,a0
	asl	a
	jsr	<division_entiere
	move	a,x:resx

; -------------	Premiere et derniere colonne libre

	clr	a	#>1,x0
	move	x:resx,b
	sub	x0,b	a,x:trace_free1
	move	b,x:trace_free2

; -------------	Init des tableaux

	move	a,x:trace_deja
	move	#>trace_flag,r0
	move	#>trace_ymin,r1
	move	#>trace_ymax,r2
	move	x:resy,b
	sub	x0,b	x:resx,x0

	do	x0,init_tableau
	move	a,x:(r0)+
	move	a,x:(r1)+
	move	b,x:(r2)+
init_tableau

	move	x:resx,a
	move	x:resx_old,b
	cmp	a,b
	jeq	<init_tables_fin

; -------------	Init table du ciel

	move	#>ciel_table,r0
	
	asr	a
	neg	a	x:resx,b
	move	a,x0

	do	b,init_ciel_fin

	move	x0,a
	asl	a	x:resx,x1
	jsr	<division_entiere
	
	move	x0,x:sauvegarde

	ARCTAN	a1

	move	a,x0
	move	#$00a2f9,y0		; (512/PI)*256
	mpy	x0,y0,a	#>1,b
	move	a,x:(r0)+

	move	x:sauvegarde,x0
	move	x0,a
	add	b,a
	move	a,x0
init_ciel_fin

; -------------	Init table K

	move	#>trace_K,r0
	move	x:resx,b
	clr	a	#>1,x0
	sub	x0,b	a,y0
	add	x0,b	b,x:sauvegarde
	do	b,init_tableK_fin

	move	y0,a
	move	x:sauvegarde,b	; resx-1

	asl	a
	sub	b,a	b,x1	; a=2*xe-(resx-1)
	rep	#8-2
	asr	a
	asr	a
	jsr	<division_entiere
;	move	a1,x:(r0)+		; OK

	move	y0,b
	add	x0,b	a,x:(r0)+
	move	b,y0
init_tableK_fin

; -------------	Init de la pile

init_tables_fin
	move	#>drawstack,x0	; Donnes des objets
	move	x0,x:draw_start

	move	#>sort_table,x0	; Index des objets
	move	x0,x:sort_tstart

	move	#>sort_maxy,x0	; Ymax des objets
	move	x0,x:sort_ystart

	clr	a	; Nb objet actuel
	move	a,x:sort_current

	jmp	<attente

	ORG	x:

time	ds	1	; (24:0) Temps pour scrolling
ciel_offset	ds	1	; (16:8) Dcalage pour le ciel

player_x	ds	1	; (24:0) Position du joueur
player_y	ds	1	; (24:0)
player_a	ds	1	; (16:8) Angle de vue
player_h	ds	1	; (16:8) Hauteur de vue

resx_old	ds	1
resx	ds	1	; Taille x de l'ecran
resy	ds	1	; Taille y de l'ecran
ratiox	ds	1	; Ratio X
ratioy	ds	1	; Ratio Y
ecr_ligne	ds	1	; Ligne de vision horizontale
lumiere_const	ds	1	; 320*200/(resx/2)
sinus	ds	1	; sin(player_a) pour "mode7" du sol/plafond
cosinus	ds	1	; cos(player_a)
