; ---------------------------------------------
;	Calcul du SEG clipp
; ---------------------------------------------

; -------------	Variables pour le calcul d'un SEG

	ORG	x:
	
seg_sinus	ds	1
seg_cosinus	ds	1

seg_K	ds	1	; (8:16)
seg_Kinc	ds	1	; (8:16)

; -------------	La routine de calcul d'un SEG

	ORG	p:
EmpileSeg
	move	x:player_x,x0
	READHOST	b
	sub	x0,b	x:player_y,y0
	READHOST	a
	sub	y0,a	b,x:seg_orig_x1
	READHOST	b
	sub	x0,b	a,x:seg_orig_y1
	READHOST	a
	sub	y0,a	b,x:seg_orig_x2
	move	a,x:seg_orig_y2

; -------------	Calcul rotation dans repere observateur

	move	x:seg_sinus,x1
	move	x:seg_cosinus,y1

	move	x:seg_orig_x1,x0
	mpy	x0,y1,a	x:seg_orig_y1,y0
	mac	y0,x1,a
	rep	#8+1
	asr	a
	mpy	-x0,x1,b	a0,x:seg_orig_x1
	mac	y0,y1,b	x:seg_orig_x2,x0
	rep	#8
	asr	b

	asr	b	x:seg_orig_y2,y0
	mpy	x0,y1,a	b0,x:seg_orig_y1
	mac	y0,x1,a
	rep	#8+1
	asr	a
	mpy	-x0,x1,b	a0,x:seg_orig_x2
	mac	y0,y1,b
	rep	#8+1
	asr	b
	move	b0,x:seg_orig_y2

	jsr	<ClippingSegment
	tst	a	x:xe2,a
	jmi	<seg_horsecran

; -------------	Teste si toutes les colonnes de ce mur ont ete faites
;	= si au moins une colonne  zero

	move	x:trace_free1,x0
	move	x:trace_free2,x1
	move	x:xe1,b

	cmp	x0,a	#>trace_flag,r0	; si noeud_xe2<prem col libre alors stop
	jmi	<seg_horsecran
	cmp	x1,b	#>1,x0	; si noeud_xe1>dern col libre alors stop
	jgt	<seg_horsecran

	sub	b,a	b,n0
	add	x0,a
	lua	(r0)+n0,r0
	clr	b	a,x0	; nb de colonnes libres
	
	move	x:(r0)+,a
	do	x0,compte_seg
	tst	a
	jne	<addonecol
	enddo
	jmp	<SegClipping
addonecol	
	move	x:(r0)+,a
compte_seg
seg_horsecran
	WRITEHOST	#>-1
	jmp	<attente

; -------------	Clipper le seg xe1-xe2 par tfe1-tfe2

SegClipping
	move	x:trace_free1,x0
	move	x:xe1,a
	move	x:trace_free2,x1
;	move	x:xe2,b

	; si xe1<tfe1 alors xe1=tfe1

	cmp	x0,a	x:xe2,b
	tmi	x0,a

	; si xe2>tfe2 alors xe2=tfe2

	cmp	x1,b	a,x:xe1
	tgt	x1,b
;	move	b,x:xe2

	; Recalculer distance entre xe1-xe2
	
	sub	a,b	b,x:xe2
	jmi	<seg_horsecran

; -------------	xe1 : premiere colonne libre
	
	move	#>1,y0	
	
	move	#>trace_flag,r0
	tfr	b,a	x:xe1,n0
	add	y0,a	n0,b
	lua	(r0)+n0,r0
	move	a,x0
	
	move	x:(r0)+,a
	do	x0,compte_seg_free1
	tst	a
	jne	<cs_free1
	enddo
cs_free1
	add	y0,b	x:(r0)+,a	; Colonne courante
compte_seg_free1
	sub	y0,b	x:xe2,a
	move	b,x:xe1

;	move	x:xe2,a
	sub	b,a	a,n0
	jmi	<seg_horsecran
	jeq	<seg_horsecran
	
; -------------	xe2 : derniere colonne libre

	move	#>trace_flag,r0
	add	y0,a	n0,b
	lua	(r0)+n0,r0
	move	a,x0
	
	move	x:(r0)-,a
	do	x0,compte_seg_free2
	tst	a
	jne	<cs_free2
	enddo
cs_free2
	sub	y0,b	x:(r0)-,a
compte_seg_free2
	add	y0,b	x:xe1,a
;	move	b,x:xe2

;	move	x:xe1,a
	sub	a,b	b,x:xe2
	jmi	<seg_horsecran

;	jmp	<attente

; -------------	Recalculer seg_[xy][12] en fonction de xe1 et xe2

;	move	#>$d5,x0
;	move	x0,x:xe1
;	move	#>$13f,x0
;	move	x0,x:xe2
;	move	#>320,x0
;	move	x0,x:resx

;	move	#>$002000,x0
;	move	x0,x:seg_orig_x1
;	move	x0,x:seg_x1
;	move	x0,x:seg_orig_x2
;	move	x0,x:seg_x2
;	move	x0,x:seg_orig_y2
;	move	x0,x:seg_y2
;	move	#>$006000,x0
;	move	x0,x:seg_orig_y1
;	move	x0,x:seg_y1

	move	#>1,n0

	; Recalcul pour xe1

	move	x:xe1,a
	move	#>seg_x1,r0
	jsr	<RecalculSeg
	
	; Recalcul pour xe2

	move	x:xe2,a
	move	#>seg_x2,r0
	jsr	<RecalculSeg

	; Calcul de local_longueur

	move	x:xe2,b
	move	x:xe1,a
	sub	a,b	#>1,x0
	jmi	<seg_horsecran
	add	x0,b
	move	b,x:local_longueur

	WRITEHOST	#>0
	jmp	<attente

; -------------	Recalcul des extrmits du segment en fonction du nouveau xe
;	R=resx-1
;	xe1=(((R*seg_x1)/seg_y1)+R)/2
;	xe2=(((R*seg_x2)/seg_y2)+R)/2

;	K=(2xe-1)/(resx-1)

;	    K(y1x2-x1y2)	     y1x2-x1y2
;	x=----------------	y=----------------
;	  (x2-x1)-K(y2-y1)	  (x2-x1)-K(y2-y1)

RecalculSeg

	; Calcul de K

	move	x:resx,b

	asl	a	#>1,x0
	sub	x0,b
	sub	b,a	b,x1	; a=2*xe-(resx-1)
	rep	#8-1
	asr	a
	jsr	<division_entiere
	move	a,x:seg_K		; OK

	; Calcul du dnominateur

	move	x:seg_orig_x2,b
	move	x:seg_orig_x1,x0	; b=(16:32)
	sub	x0,b	a,x1	; x1=K
	move	x:seg_orig_y2,a
	move	x:seg_orig_y1,x0
	sub	x0,a	
	move	a,y1
	mpy	-x1,y1,a		; (8:16)*(16:8)=(24:24)
	rep	#8-4
	asl	a		; a=(16:32)
	asl	a	x:seg_orig_x1,x0
	asl	a	x:seg_orig_y1,y0
	asl	a	x:seg_orig_x2,x1
	add	a,b	x:seg_orig_y2,y1

	; Calcul du numrateur
	
	mpy	y0,x1,a		; y1*x2
	mac	-x0,y1,a	b,x1	; y1*x2-x1*y2 (32:16)
	
	; Calcul de Y
	
	jsr	<division_signee
	move	a,x:(r0+n0)
	
	; Calcul de X

	move	x:seg_K,x0
	move	a,x1
	mpy	x0,x1,a	; (24:24)
	rep	#8-1
	asl	a
	move	a,x:(r0)

	rts
