; ------------------------------
;	Controle d'un menu
; ------------------------------
;	Menu
;	Monter	Haut,Souris haut
;	Descendre	Bas,Souris bas
; F	Changer	Gauche/Droite,Souris gauche/droite
; C	Augmenter	Droite,Souris droite
; C	Diminuer	Gauche,Souris gauche
;	Valider	Entre,Espace,Bouton gauche
;	Annuler	Esc,Bouton droit

	TEXT
ControleMenu
	movem.l	d0-d7/a0-a3,-(sp)
	lea	clavier,a3

	move	MenuActif,d0
	lea	([MenuTable],d0.w*8),a0

;	(a0).l contient adresse du menu
;	4(a0).w contient l'option courant active
	
	; Chercher la derniere option

	move.l	(a0),a1
	moveq	#-1,d2
.boucle	cmp.l	#0,MENU_TITLE(a1)
	beq.s	.boucle_stop
	cmp	#MENU_UNSEL,MENU_SELECTABLE(a1)
	beq.s	.boucle_next
	addq	#1,d2
.boucle_next	lea	SIZEOF_MENU(a1),a1
	bra.s	.boucle
.boucle_stop

	; Haut ?

	tst.b	K_UP(a3)
	beq.s	.Not_up1
	clr.b	K_UP(a3)
	bra.s	.Yes_up
.Not_up1
	cmp	#-32,mousey
	bge.s	.Not_up
	clr	mousey
.Yes_up	
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	move	4(a0),d1
	subq	#1,d1
	bpl.s	.Up_ok
	move	d2,d1
.Up_ok	move	d1,4(a0)
.Not_up

	; Bas ?
	
	tst.b	K_DOWN(a3)
	beq.s	.Not_down1
	clr.b	K_DOWN(a3)
	bra.s	.Yes_down
.Not_down1
	cmp	#32,mousey
	ble.s	.Not_down
	clr	mousey
.Yes_down
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	move	4(a0),d1
	addq	#1,d1
	cmp	d1,d2
	bpl.s	.Down_ok
	moveq	#0,d1
.Down_ok	move	d1,4(a0)
.Not_down	

	; Gauche ?
	
	tst.b	K_LEFT(a3)
	beq.s	.Not_left1
	clr.b	K_LEFT(a3)
	moveq	#1,d2
	bra.s	.Yes_left
.Not_left1
	move	mousex,d2
	ext.l	d2
	cmp	#-32,d2
	bge.s	.Not_left
	clr	mousex
	divs	#-32,d2
.Yes_left
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	bsr	SearchCurrentOption
	cmp	#MENUTYPE_VAR,MENU_TYPE(a1)
	bne.s	.Not_left
	move	d2,d1
	cmp	#8,MENU_MAX(a1)
	beq.s	.NotMax8_left
	lsl	#4,d1
.NotMax8_left
	move.l	MENU_ADRVAR(a1),a1
	sub	d1,(a1)
	bpl.s	.Not_left
	clr	(a1)
.Not_left	

	; Droite ?

	tst.b	K_RIGHT(a3)
	beq.s	.Not_right1
	clr.b	K_RIGHT(a3)
	moveq	#1,d2
	bra.s	.Yes_right
.Not_right1
	move	mousex,d2
	ext.l	d2
	cmp	#32,d2
	ble.s	.Not_right
	clr	mousex
	divu	#32,d2
.Yes_right
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	bsr	SearchCurrentOption
	cmp	#MENUTYPE_VAR,MENU_TYPE(a1)
	bne.s	.Not_right
	move	d2,d1
	cmp	#8,MENU_MAX(a1)
	beq.s	.NotMax8_right
	lsl	#4,d1
.NotMax8_right
	move.l	MENU_ADRVAR(a1),a2
	add	(a2),d1
	cmp	MENU_MAX(a1),d1
	bmi.s	.Not_rightmax
	move	MENU_MAX(a1),d1
.Not_rightmax	move	d1,(a2)
.Not_right	

	; Valider : Entre, Espace, Bouton gauche
	
	tst.b	K_SPACE(a3)
	beq.s	.Not_Select1
	clr.b	K_SPACE(a3)
	bra.s	.Yes_Select
.Not_Select1
	tst.b	K_RETURN(a3)
	beq.s	.Not_Select2
	clr.b	K_RETURN(a3)
	bra.s	.Yes_Select
.Not_Select2
	btst.b	#1,mouseb
	beq.s	.Not_Select
	bclr.b	#1,mouseb
.Yes_Select
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	bsr	SearchCurrentOption	
	move.l	MENU_SELECT(a1),a1
	cmp.l	#0,a1
	beq.s	.Not_Select
	jsr	(a1)
.Not_Select

	; Annuler : Esc,bouton droit

	tst.b	K_ESC(a3)
	beq.s	.Not_Cancel1
	clr.b	K_ESC(a3)
	tst	MenuActif
	beq.s	.All_Cancel
	bra.s	.Yes_Cancel
.Not_Cancel1
	btst.b	#0,mouseb
	beq	.Not_Cancel
	bclr.b	#0,mouseb
	tst	MenuActif
	bne.s	.Yes_Cancel
.All_Cancel	
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	clr	display_menu
	clr	mousex
	clr	mousey
	clr	mouseb
	move.l	ControlePrec,ControleVbl
	bra.s	.Not_Cancel
.Yes_Cancel
	move	#2,TitleSemaphore
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	move	#2,InterSemaphore
	bsr	SearchCurrentOption
	move.l	MENU_CANCEL(a1),a1
	cmp.l	#0,a1
	beq.s	.Not_Cancel
	jsr	(a1)
.Not_Cancel
	movem.l	(sp)+,d0-d7/a0-a3
	rts

	BSS
ControlePrec	ds.l	1

; ------------------------------
;	Chercher option courante
; ------------------------------
;	a0 	Menu
;	-> a1	Option slectionne

	TEXT
SearchCurrentOption
	move	4(a0),d1
	move.l	(a0),a1
.SCO_boucle	cmp.l	#0,MENU_TITLE(a1)
	beq.s	.SCO_No
	cmp	#MENU_SEL,MENU_SELECTABLE(a1)
	bne.s	.SCO_next
	subq.w	#1,d1
	bmi.s	.SCO_Yes
.SCO_next	lea	SIZEOF_MENU(a1),a1
	bra.s	.SCO_boucle
.SCO_Yes
.SCO_No	rts

; ------------------------------
;	Options de menu slectionnable
; ------------------------------

SelectGeneral	clr	MenuActif
	rts

SelectNewEpisode
	move	#1,MenuActif
	rts

SelectEpisode1	move.l	#"E1M1",game_level
	clr.l	game_level+4
	move	#2,MenuActif
	rts
SelectEpisode2	move.l	#"E2M1",game_level
	clr.l	game_level+4
	move	#2,MenuActif
	rts
SelectEpisode3	move.l	#"E3M1",game_level
	clr.l	game_level+4
	move	#2,MenuActif
	rts
SelectEpisode4	move.l	#"E4M1",game_level
	clr.l	game_level+4
	move	#2,MenuActif
	rts

SelectNewSkill	move	#2,MenuActif
	rts

SelectSkill1	move	#1,game_skill
	bra.s	Select_startgame
SelectSkill2	move	#2,game_skill
	bra.s	Select_startgame
SelectSkill3	move	#3,game_skill
	bra.s	Select_startgame
SelectSkill4	move	#4,game_skill
	bra.s	Select_startgame
SelectSkill5	move	#5,game_skill
;	bra.s	Select_startgame

Select_startgame
	cmp	#2,game_type
	bne.s	.NotDoom2
	move.l	#"MAP0",game_level
	move.l	#"1"<<24,game_level+4
.NotDoom2
	clr	maponscreen
	clr	display_menu
	clr	mousex
	clr	mousey
	clr	mouseb
	clr	MenuActif
	move.l	#ControleNone,ControleVbl
	move.l	#BoucleChargerNiveau0,BouclePrincipale
	rts

SelectOptions	move	#3,MenuActif
	rts

SelectDisplay	move	#4,MenuActif
	rts

SelectMessages	move.b	#-1,K_F8(a3)
	rts

SelectDetail	move.b	#-1,K_F5(a3)
	rts

SelectSound	move.b	#-1,K_F4(a3)
	rts

SelectLoadGame	move.b	#-1,K_F3(a3)
	rts

SelectSaveGame	move.b	#-1,K_F2(a3)
	rts

SelectQuit	move.b	#-1,K_F10(a3)
	rts
	