; ------------------------------
;	Controle d'un objet
; ------------------------------

	TEXT
ControleObjet
	movem.l	d0-d7/a0-a1,-(sp)
	lea	clavier,a1

	move.l	obj_observateur,a0

	move	OBJET_A(a0),d0
	and	#-4,d0
	move.l	([cosinus],d0.w),d1
	move.l	([sinus],d0.w),d2

	moveq	#0,d3
	tst.b	K_LSHIFT(a1)	; left
	bne.s	vbl_yesshift
	tst.b	K_RSHIFT(a1)	; right
	beq.s	vbl_noshift
vbl_yesshift	moveq	#-1,d3
vbl_noshift

; -------------	Avancer

	tst.b	K_UP(a1)	; Up ?
	bne.s	yes_avance

	tst.b	K_ALTERNATE(a1)
	bne.s	no_avance
	btst.b	#1,mouseb	; Left button ?
	beq.s	no_avance

yes_avance	move.l	d1,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	avance_x2
	add.l	d7,d7
avance_x2	add.l	d7,OBJET_X1(a0)

	move.l	d2,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	avance_y2
	add.l	d7,d7
avance_y2	add.l	d7,OBJET_Y1(a0)
no_avance

; -------------	Reculer

	tst.b	K_DOWN(a1)	; Down ?
	bne.s	yes_recule

	tst.b	K_ALTERNATE(a1)
	bne.s	no_recule
	btst.b	#0,mouseb	; Right button ?
	beq.s	no_recule

yes_recule	move.l	d1,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	recule_x2
	add.l	d7,d7
recule_x2	sub.l	d7,OBJET_X1(a0)

	move.l	d2,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	recule_y2
	add.l	d7,d7
recule_y2	sub.l	d7,OBJET_Y1(a0)
no_recule

; -------------	Strafe
	
	tst.b	K_LEFT(a1)	; Left ?
	beq.s	no_stepleft

	move.l	d1,d5
	move.l	d2,d6

	move.l	d6,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	stepleft_x2
	add.l	d7,d7
stepleft_x2	sub.l	d7,OBJET_X1(a0)

	move.l	d5,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	stepleft_y2
	add.l	d7,d7
stepleft_y2	add.l	d7,OBJET_Y1(a0)
	
no_stepleft
	tst.b	K_RIGHT(a1)	; Right ?
	beq.s	no_stepright

	move.l	d1,d5
	move.l	d2,d6

	move.l	d6,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	stepright_x2
	add.l	d7,d7
stepright_x2	add.l	d7,OBJET_X1(a0)

	move.l	d5,d7
	add.l	d7,d7
	add.l	d7,d7
	tst	d3
	beq.s	stepright_y2
	add.l	d7,d7
stepright_y2	sub.l	d7,OBJET_Y1(a0)
	
no_stepright
	tst.b	K_RIGHT(a1)
	bne.s	no_stepmouse
	tst.b	K_LEFT(a1)
	bne.s	no_stepmouse
	tst.b	K_ALTERNATE(a1)
	beq.s	no_stepmouse

	move.l	d1,d5
	move.l	d2,d6

	move	mousex,d0
	ext.l	d0
	tst	d3
	beq.s	stepmouse_x2
	add	d0,d0
stepmouse_x2	muls.l	d0,d5
	muls.l	d0,d6	
	add.l	d6,OBJET_X1(a0)
	sub.l	d5,OBJET_Y1(a0)

	move.l	d1,d5
	move.l	d2,d6

	move	mousey,d0
	ext.l	d0
	tst	d3
	beq.s	stepmouse_y2
	add	d0,d0
stepmouse_y2	muls.l	d0,d5
	muls.l	d0,d6	
	sub.l	d5,OBJET_X1(a0)
	sub.l	d6,OBJET_Y1(a0)
no_stepmouse

; -------------	Turn left/right

	move	#1<<8,d0
	tst	d3
	beq.s	turn_a2
	add	d0,d0
turn_a2	
	tst.b	K_INSERT(a1)	; Insert ?
	beq.s	no_turnleft
	add	d0,OBJET_A1(a0)
no_turnleft
	tst.b	K_CLR(a1)	; Clr Home ?
	beq.s	no_turnright
	sub	d0,OBJET_A1(a0)
no_turnright

	tst.b	K_INSERT(a1)
	bne.s	no_turn_alt
	tst.b	K_CLR(a1)
	bne.s	no_turn_alt
	tst.b	K_ALTERNATE(a1)
	bne.s	no_turn_alt
	asr	#2,d0
	mulu	mousex,d0
	sub	d0,OBJET_A1(a0)
no_turn_alt

; -------------	Pencher la tete

	IFNE	PENCHER_TETE

	tst.b	K_ALTERNATE(a1)
	bne.s	no_penchertete

	move	ecr_ligne1,d0
	add	mousey,d0

	move	#128,d1

	cmp	d1,d0
	bmi.s	my_max
	move	d1,d0
my_max	neg	d1
	cmp	d1,d0
	bpl.s	my_min
	move	d1,d0
my_min	
	move	d0,ecr_ligne1
no_penchertete
	ENDC

; -------------	Feu ?

;	tst.b	K_CONTROL(a1)
;	beq.s	.Not_Control
;	clr.b	K_CONTROL(a1)
;	movem.l	a0-a6,-(sp)
;	move.l	a0,a2
;	lea	ProjMissile,a0
;	move	OBJET_X(a2),THING_X(a0)
;	move	OBJET_Y(a2),THING_Y(a0)
;	move	OBJET_A(a2),THING_ANGLE(a0)
;	bsr	CreateObject
;	movem.l	(sp)+,a0-a6
;.Not_Control

; -------------	Appui sur ESC ?

	tst.b	K_ESC(a1)
	beq.s	.Not_Esc
	clr.b	K_ESC(a1)
	move	#-1,display_menu
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
.Not_Esc
	clr	mousex
	clr	mousey
	movem.l	(sp)+,d0-d7/a0-a1
ControleNone
	rts
