; ------------------------------
;	Table des actions de DOOM
; ------------------------------

	DATA
DoomActivateTable
;  0   -     -    -     -     -  -   -
	DEF_NOACTION
;  1   mDoor nSRm door  med   4  -   open/close
	DEF_MANUALDOOR	COND_S,SPD_MED,SCT_OPENCLOSE,REPEAT_YES
;  2   rDoor  W1  door  med   -  -   open
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;  3   rDoor  W1  door  med   -  -   close
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILDN,SCT_CEILING,REPEAT_NO
;  4   rDoor  W1  door  med   4  -   open,close
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_NO
;  5   Floor  W1  mover slow  -  -   up to LIC
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LIC,REPEAT_NO
;  6   Crush  W1& crush med   0  -   start crushing, fast hurt
	DEF_CRUSHCEIL	COND_W,SPD_MED,REPEAT_YES
;  7   Stair  S1  mover slow  -  -   stairs
	DEF_STAIR	COND_S,SPD_SLOW,REPEAT_NO
;  8   Stair  W1  mover slow  -  -   stairs
	DEF_STAIR	COND_W,SPD_SLOW,REPEAT_NO
;  9   Floor  S1  mover slow  -  NXP donut (see note 12 above)
	DEF_DONUT	COND_S,REPEAT_NO
; 10   Lift   W1  lift  fast  3  -   lift
	DEF_LIFT	COND_W,SPD_FAST,REPEAT_NO
; 11   Exit  nS-  clunk -     -  -   End level, go to next level
	DEF_EXIT	COND_S
; 12   Light  W1  -     -     -  -   HE (light level)
	DEF_LIGHT	COND_W,LIMIT_HE,REPEAT_NO
; 13   Light  W1  -     -     -  -   255
	DEF_LIGHT	COND_W,LIMIT_255,REPEAT_NO
; 14   Floor  S1& mover slow  -  TX  up 32
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP32,REPEAT_YES
; 15   Floor  S1& mover slow  -  TX  up 24
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_YES
; 16   rDoor  W1  door  med   30 -   close, then opens
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILDN,SCT_CLOSEOPEN,REPEAT_NO
; 17   Light  W1  -     -     -  -   Light blinks (see [4-9-1] type 3)
	DEF_LIGHT	COND_W,LIMIT_BLINK,REPEAT_NO
; 18   Floor  S1  mover slow  -  -   up to nhEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_NO
; 19   Floor  W1  mover slow  -  -   down to HEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEF,LIMIT_FLOOR,REPEAT_NO
; 20   Floor  S1& mover slow  -  TX  up to nhEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
; 21   Lift   S1  lift  fast  3  -   lift
	DEF_LIFT	COND_S,SPD_FAST,REPEAT_NO
; 22   Floor  W1& mover slow  -  TX  up to nhEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_NO
; 23   Floor  S1  mover slow  -  -   down to LEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_NO
; 24   Floor  G1  mover slow  -  -   up to LIC
	DEF_FLOOR	COND_G,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LIC,REPEAT_NO
; 25   Crush  W1& crush med   0  -   start crushing, slow hurt
	DEF_CRUSHCEIL	COND_W,SPD_MED,REPEAT_NO
; 26   mDoor nSR  door  med   4  -   open/close BLUE KEY
	DEF_MANUALDOOR	COND_BS,SPD_MED,SCT_OPENCLOSE,REPEAT_YES
; 27   mDoor nSR  door  med   4  -   open/close YELLOW KEY
	DEF_MANUALDOOR	COND_YS,SPD_MED,SCT_OPENCLOSE,REPEAT_YES
; 28   mDoor nSR  door  med   4  -   open/close RED KEY
	DEF_MANUALDOOR	COND_RS,SPD_MED,SCT_OPENCLOSE,REPEAT_YES
; 29   rDoor  S1  door  med   4  -   open,close
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_NO
; 30   Floor  W1  mover slow  -  -   up ShortestLowerTexture
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORPSLT,REPEAT_NO
; 31   mDoor nS1  door  med   -  -   open
	DEF_MANUALDOOR	COND_S,SPD_MED,SCT_CEILING,REPEAT_NO
; 32   mDoor nS1  door  med   -  -   open BLUE KEY
	DEF_MANUALDOOR	COND_BS,SPD_MED,SCT_CEILING,REPEAT_NO
; 33   mDoor nS1  door  med   -  -   open RED KEY
	DEF_MANUALDOOR	COND_RS,SPD_MED,SCT_CEILING,REPEAT_NO
; 34   mDoor nS1  door  med   -  -   open YELLOW KEY
	DEF_MANUALDOOR	COND_YS,SPD_MED,SCT_CEILING,REPEAT_NO
; 35   Light  W1  -     -     -  -   0
	DEF_LIGHT	COND_W,LIMIT_0,REPEAT_NO
; 36   Floor  W1  mover fast  -  -   down to HEF + 8
	DEF_FLOOR	COND_W,SPD_FAST,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEFP8,LIMIT_FLOOR,REPEAT_NO
; 37   Floor  W1  mover slow  -  NXP down to LEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_NO
; 38   Floor  W1  mover slow  -  -   down to LEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_NO
; 39   Telpt  W1m tport -     -  -   Teleport
	DEF_TELEPORT	COND_W,REPEAT_NO
; 40   Ceil   W1  mover slow  -  -   up to HEC
	DEF_MOVINGCEIL	COND_W,SCM_CEILUP,LIMIT_CEILING,LIMIT_HEC,REPEAT_NO
; 41   Ceil   S1  mover slow  -  -   down to floor
	DEF_MOVINGCEIL	COND_S,SCM_CEILDN,LIMIT_FLOOR,LIMIT_CEILING,REPEAT_NO
; 42   rDoor  SR  door  med   -  -   close
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILDN,SCT_CEILING,REPEAT_YES
; 43   Ceil   SR  mover slow  -  -   down to floor
	DEF_MOVINGCEIL	COND_S,SCM_CEILDN,LIMIT_FLOOR,LIMIT_CEILING,REPEAT_YES
; 44   Ceil   W1  mover slow  -  -   down to floor + 8
	DEF_MOVINGCEIL	COND_W,SCM_CEILDN,LIMIT_FLOORP8,LIMIT_CEILING,REPEAT_NO
; 45   Floor  SR  mover slow  -  -   down to HEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEF,LIMIT_FLOOR,REPEAT_YES
; 46   mDoor nGR  door  med   -  -   open
	DEF_MANUALDOOR	COND_G,SPD_MED,SCT_CEILING,REPEAT_YES
; 47   Floor  G1& mover slow  -  TX  up to nhEF
	DEF_FLOOR	COND_G,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
; 48   Spec  n--  -     -     -  -   Scrolling wall
	DEF_NOACTION
; 49   Ceil   S1  mover slow  -  -   down to floor + 8
	DEF_MOVINGCEIL	COND_S,SCM_CEILDN,LIMIT_FLOORP8,LIMIT_CEILING,REPEAT_NO
; 50   rDoor  S1  door  med   -  -   close
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILDN,SCT_CEILING,REPEAT_NO
; 51   Exit  nS-  clunk -     -  -   End level, go to secret level
	DEF_EXIT	COND_S
; 52   Exit  nW-  clunk -     -  -   End level, go to next level
	DEF_EXIT	COND_W
; 53   MvFlr  W1& lift  slow  3  -   start moving floor
	DEF_MOVINGFLOOR	COND_W,REPEAT_YES
; 54   MvFlr  W1& -     -     -  -   stop moving floor
	DEF_STOPMOVINGF	COND_W,REPEAT_YES
; 55   Floor  S1  mover slow  -  -   up to LIC - 8, CRUSH
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LICM8,REPEAT_NO
; 56   Floor  W1& mover slow  -  -   up to LIC - 8, CRUSH
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LICM8,REPEAT_YES
; 57   Crush  W1& -     -     -  -   stop crush
	DEF_STOPCRUSHC	COND_W,REPEAT_YES
; 58   Floor  W1  mover slow  -  -   up 24
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_NO
; 59   Floor  W1& mover slow  -  TXP up 24
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_YES
; 60   Floor  SR  mover slow  -  -   down to LEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_YES
; 61   rDoor  SR  door  med   -  -   open
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILUP,SCT_CEILING,REPEAT_YES
; 62   Lift   SR  lift  fast  3  -   lift
	DEF_LIFT	COND_S,SPD_FAST,REPEAT_YES
; 63   rDoor  SR  door  med   4  -   open,close
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_YES
; 64   Floor  SR  mover slow  -  -   up to LIC
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LIC,REPEAT_YES
; 65   Floor  SR  mover slow  -  -   up to LIC - 8, CRUSH
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LICM8,REPEAT_YES
; 66   Floor  SR& mover slow  -  TX  up 24
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_YES
; 67   Floor  SR& mover slow  -  TX  up 32
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP32,REPEAT_YES
; 68   Floor  SR& mover slow  -  TX  up to nhEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
; 69   Floor  SR  mover slow  -  -   up to nhEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
; 70   Floor  SR  mover fast  -  -   down to HEF + 8
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEFP8,LIMIT_FLOOR,REPEAT_YES
; 71   Floor  S1  mover fast  -  -   down to HEF + 8
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEFP8,LIMIT_FLOOR,REPEAT_NO
; 72   Ceil   WR  mover slow  -  -   down to floor + 8
	DEF_MOVINGCEIL	COND_W,SCM_CEILDN,LIMIT_FLOORP8,LIMIT_CEILING,REPEAT_YES
; 73   Crush  WR& crush slow  0  -   start crushing, slow hurt
	DEF_CRUSHCEIL	COND_W,SPD_SLOW,REPEAT_YES
; 74   Crush  WR& -     -     -  -   stop crush
	DEF_STOPCRUSHC	COND_W,REPEAT_YES
; 75   rDoor  WR  door  med   -  -   close
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILDN,SCT_CEILING,REPEAT_YES
; 76   rDoor  WR  door  med   30 -   close, then opens
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILDN,SCT_CLOSEOPEN,REPEAT_YES
; 77   Crush  WR& crush med   0  -   start crushing, fast hurt
	DEF_CRUSHCEIL	COND_W,SPD_MED,REPEAT_YES
; 78   -      -   -     -     -  -   -
	DEF_NOACTION
; 79   Light  WR  -     -     -  -   0
	DEF_LIGHT	COND_W,LIMIT_0,REPEAT_YES
; 80   Light  WR  -     -     -  -   HE (light level)
	DEF_LIGHT	COND_W,LIMIT_HE,REPEAT_YES
; 81   Light  WR  -     -     -  -   255
	DEF_LIGHT	COND_W,LIMIT_255,REPEAT_YES
; 82   Floor  WR  mover slow  -  -   down to LEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_YES
; 83   Floor  WR  mover slow  -  -   down to HEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEF,LIMIT_FLOOR,REPEAT_YES
; 84   Floor  WR  mover slow  -  NXP down to LEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LEF,LIMIT_FLOOR,REPEAT_YES
; 85   -      -   -     -     -  -   -
	DEF_NOACTION
; 86   rDoor  WR  door  med   -  -   open
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILUP,SCT_CEILING,REPEAT_YES
; 87   MvFlr  WR& lift  slow  3  -   start moving floor
	DEF_MOVINGFLOOR	COND_W,REPEAT_YES
; 88   Lift   WRm lift  fast  3  -   lift
	DEF_LIFT	COND_W,SPD_FAST,REPEAT_YES
; 89   MvFlr  WR& -     -     -  -   stop moving floor
	DEF_STOPMOVINGF	COND_W,REPEAT_YES
; 90   rDoor  WR  door  med   4  -   open,close
	DEF_REMOTEDOOR	COND_W,SPD_MED,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_YES
; 91   Floor  WR  mover slow  -  -   up to LIC
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LIC,REPEAT_YES
; 92   Floor  WR  mover slow  -  -   up 24
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_YES
; 93   Floor  WR& mover slow  -  TXP up 24
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP24,REPEAT_YES
; 94   Floor  WR& mover slow  -  -   up to LIC - 8, CRUSH
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LICM8,REPEAT_YES
; 95   Floor  WR& mover slow  -  TX  up to nhEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
; 96   Floor  WR  mover slow  -  -   up ShortestLowerTexture
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORPSLT,REPEAT_YES
; 97   Telpt  WRm tport -     -  -   Teleport
	DEF_TELEPORT	COND_W,REPEAT_YES
; 98   Floor  WR  mover fast  -  -   down to HEF + 8
	DEF_FLOOR	COND_W,SPD_FAST,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEFP8,LIMIT_FLOOR,REPEAT_YES
; 99 * rDoor  SR  blaze turbo -  -   open BLUE KEY
	DEF_REMOTEDOOR	COND_BS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_YES
;100 * Stair  W1  mover turbo -  -   stairs (each up 16 not 8) + crush
	DEF_STAIR	COND_W,SPD_TURBO,REPEAT_NO
;101   Floor  S1  mover slow  -  -   up to LIC
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_LIC,REPEAT_NO
;102   Floor  S1  mover slow  -  -   down to HEF
	DEF_FLOOR	COND_S,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_HEF,LIMIT_FLOOR,REPEAT_NO
;103   rDoor  S1  door  med   -  -   open
	DEF_REMOTEDOOR	COND_S,SPD_MED,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;104   Light  W1  -     -     -  -   LE (light level)
	DEF_LIGHT	COND_W,LIMIT_LE,REPEAT_NO
;105 * rDoor  S1  blaze turbo 4  -   open,close
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_NO
;106 * rDoor  WR  blaze turbo -  -   open
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_YES
;107 * rDoor  WR  blaze turbo -  -   close
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILDN,SCT_CEILING,REPEAT_YES
;108 * rDoor  W1  blaze turbo 4  -   open,close
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_NO
;109 * rDoor  W1  blaze turbo -  -   open
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;110 * rDoor  W1  blaze turbo -  -   close
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILDN,SCT_CEILING,REPEAT_NO
;111 * rDoor  WR  blaze turbo 4  -   open,close
	DEF_REMOTEDOOR	COND_W,SPD_TURBO,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_YES
;112 * rDoor  S1  blaze turbo -  -   open
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;113 * rDoor  S1  blaze turbo -  -   close
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILDN,SCT_CEILING,REPEAT_NO
;114 * rDoor  SR  blaze turbo 4  -   open,close
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILUP,SCT_OPENCLOSE,REPEAT_YES
;115 * rDoor  SR  blaze turbo -  -   open
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_YES
;116 * rDoor  SR  blaze turbo -  -   close
	DEF_REMOTEDOOR	COND_S,SPD_TURBO,SCM_CEILDN,SCT_CEILING,REPEAT_YES
;117 * mDoor nSR  blaze turbo 4  -   open/close
	DEF_MANUALDOOR	COND_S,SPD_TURBO,SCT_OPENCLOSE,REPEAT_YES
;118 * mDoor nS1  blaze turbo -  -   open
	DEF_MANUALDOOR	COND_S,SPD_TURBO,SCT_CEILING,REPEAT_NO
;119 * Floor  W1  mover slow  -  -   up to nhEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_NO
;120 * Lift   WR  lift  turbo 3  -   lift
	DEF_LIFT	COND_W,SPD_TURBO,REPEAT_YES
;121 * Lift   W1  lift  turbo 3  -   lift
	DEF_LIFT	COND_W,SPD_TURBO,REPEAT_NO
;122 * Lift   S1  lift  turbo 3  -   lift
	DEF_LIFT	COND_S,SPD_TURBO,REPEAT_NO
;123 * Lift   SR  lift  turbo 3  -   lift
	DEF_LIFT	COND_S,SPD_TURBO,REPEAT_YES
;124 * Exit  nW-  clunk -     -  -   End level, go to secret level
	DEF_EXIT	COND_W
;125 * Telpt  W1m tport -     -  -   Teleport monsters only
	DEF_TELEPORT	COND_W,REPEAT_NO
;126 * Telpt  WRm tport -     -  -   Teleport monsters only
	DEF_TELEPORT	COND_W,REPEAT_YES
;127 * Stair  S1  mover turbo -  -   stairs (each up 16 not 8) + crush
	DEF_STAIR	COND_S,SPD_TURBO,REPEAT_NO
;128 * Floor  WR  mover slow  -  -   up to nhEF
	DEF_FLOOR	COND_W,SPD_SLOW,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
;129 * Floor  WR  mover turbo -  -   up to nhEF
	DEF_FLOOR	COND_W,SPD_TURBO,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
;130 * Floor  W1  mover turbo -  -   up to nhEF
	DEF_FLOOR	COND_W,SPD_TURBO,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_NO
;131 * Floor  S1  mover turbo -  -   up to nhEF
	DEF_FLOOR	COND_S,SPD_TURBO,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_NO
;132 * Floor  SR  mover turbo -  -   up to nhEF
	DEF_FLOOR	COND_S,SPD_TURBO,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_NHEF,REPEAT_YES
;133 * rDoor  S1  blaze turbo -  -   open BLUE KEY
	DEF_REMOTEDOOR	COND_BS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;134 * rDoor  SR  blaze turbo -  -   open RED KEY
	DEF_REMOTEDOOR	COND_RS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_YES
;135 * rDoor  S1  blaze turbo -  -   open RED KEY
	DEF_REMOTEDOOR	COND_RS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;136 * rDoor  SR  blaze turbo -  -   open YELLOW KEY
	DEF_REMOTEDOOR	COND_YS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_YES
;137 * rDoor  S1  blaze turbo -  -   open YELLOW KEY
	DEF_REMOTEDOOR	COND_YS,SPD_TURBO,SCM_CEILUP,SCT_CEILING,REPEAT_NO
;138 * Light  SR  clunk -     -  -   255
	DEF_LIGHT	COND_S,LIMIT_255,REPEAT_YES
;139 * Light  SR  clunk -     -  -   0
	DEF_LIGHT	COND_S,LIMIT_0,REPEAT_YES
;140 * Floor  S1  mover med   -  -   up 512
	DEF_FLOOR	COND_S,SPD_MED,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOORP512,REPEAT_NO
;141 * Crush  W1& none? slow  0  -   start crushing, slow hurt "Silent"
	DEF_CRUSHCEIL	COND_W,SPD_SLOW,REPEAT_YES
