; ---------------------------------------------
;	Le clavier
; ---------------------------------------------

; ------------------------------
;	Init
; ------------------------------

	TEXT
IT_ikbd_init
	move.l	$118.w,_old_ikbd
	move.l	#ikbd,$118.w
	bset	#6,$fffffa09.w
	bset	#6,$fffffa15.w
	move.b	#8,$fffffc02.w

	bset	#3,$fffffa17.w	; soft end of interrupt

	; Vidage du buffer clavier
	
	clr	mousex
	clr	mousey
	clr	mouseb
	lea	clavier,a0
	move	#128/4-1,d0
initialise_kbd	clr.l	(a0)+
	dbra	d0,initialise_kbd

	rts

	BSS
_old_ikbd	ds.l	1

; ------------------------------
;	Restauration
; ------------------------------

	TEXT
IT_ikbd_restaure
	move.l	_old_ikbd,$118.w
	
vide_kbd	btst	#0,$fffffc00.w
	beq.s	ikbd_restaure_fin
	move.b	$fffffc02.w,d0
	bra.s	vide_kbd
ikbd_restaure_fin
	rts

; ------------------------------
;	Routine
; ------------------------------

	TEXT

ikbd	movem.l	d0-d1/a0,-(sp)
	lea	clavier,a0
	move.b	$fffffc02.w,d0
	move	d0,d1
	and	#$7f,d1
	tas	d0
	spl	(a0,d1.w)

	cmp.b	#$f8,d0
	bmi.s	ikbd_no_ms
	cmp.b	#$fb,d0
	bpl.s	ikbd_no_ms
ikbd_yes_ms	and	#3,d0
	move.b	d0,mouseb
	move.l	#ikbd_mousex,$118.w

ikbd_no_ms	movem.l	(sp)+,d0-d1/a0
	bclr	#6,$fffffa11.w
	rte

ikbd_mousex	move.l	d0,-(sp)
	move.b	$fffffc02.w,d0
	ext.w	d0
	add	d0,mousex
	move.l	#ikbd_mousey,$118.w
	move.l	(sp)+,d0
	bclr	#6,$fffffa11.w
	rte

ikbd_mousey	move.l	d0,-(sp)
	move.b	$fffffc02.w,d0
	ext.w	d0
	add	d0,mousey
	move.l	#ikbd,$118.w
	move.l	(sp)+,d0
	bclr	#6,$fffffa11.w
	rte

	BSS
	
mouseb	ds.w	1
mousex	ds.w	1
mousey	ds.w	1
clavier	ds.b	128
