; ------------------------------
;	Affiche le cadre
; ------------------------------

	TEXT
AfficheCadre
	subq.w	#1,CadreSemaphore
	bmi	AfficheCadre_fini

	move	reszoom,d0
	cmp	#2,d0
	bmi	AfficheCadre_fini

	tst.l	fond_adresse
	beq	AfficheCadre_fini

	move.l	fond_adresse,a0
	move.l	palette,a3
	moveq	#0,d5

; -------------	Quelques calculs

	move	ScreenSize,d0
	lea	(Resolutions,d0.w*4),a1
	move	(a1),cadre_resx
	move	2(a1),cadre_resy

	move	#screeny-6,d0
	sub	StbarHeight,d0
	sub	cadre_resy,d0
	lsr	#1,d0
	move	d0,hauteur_bord

	move	#screenx-6,d0
	sub	cadre_resx,d0
	lsr	#1,d0
	move	d0,largeur_bord

	BSS

largeur_bord	ds.w	1
hauteur_bord	ds.w	1
cadre_resx	ds.w	1
cadre_resy	ds.w	1

; -------------	Bordure suprieure
	
	TEXT

	move.l	affiche1,a1
	clr	d2
	move	hauteur_bord,d0
	subq	#1,d0
cadrehaut_y
	move	#screenx-1,d1
	moveq	#0,d3
	lea	(a0,d2.w),a2
	move.l	a1,a4
cadrehaut_x
	move.b	(a2,d3.w),d5
	move	(a3,d5.w*4),(a4)+
	addq	#1,d3
	and	#63,d3
	dbra	d1,cadrehaut_x
	lea	screenx*2(a1),a1
	add	#1<<6,d2
	and	#63<<6,d2
	dbra	d0,cadrehaut_y

; -------------	Bordure infrieure
	
	move.l	affiche1,a1
	move	hauteur_bord,d0
	add	cadre_resy,d0
	addq	#6,d0
	move	d0,d2
	and	#63,d2
	lsl	#6,d2
	move	d0,d3
	mulu	#screenx*2,d3
	add.l	d3,a1
	move	hauteur_bord,d0
	subq	#1,d0
cadrebas_y
	move	#screenx-1,d1
	moveq	#0,d3
	lea	(a0,d2.w),a2
	move.l	a1,a4
cadrebas_x
	move.b	(a2,d3.w),d5
	move	(a3,d5.w*4),(a4)+
	addq	#1,d3
	and	#63,d3
	dbra	d1,cadrebas_x
	lea	screenx*2(a1),a1
	add	#1<<6,d2
	and	#63<<6,d2
	dbra	d0,cadrebas_y
	
; -------------	Bordure gauche

	move.l	affiche1,a1
	move	hauteur_bord,d0
	move	d0,d2
	and	#63,d2
	lsl	#6,d2
	mulu	#screenx*2,d0
	add.l	d0,a1
	move	cadre_resy,d0
	addq	#2*3-1,d0
cadregauche_y
	move	largeur_bord,d1
	subq	#1,d1
	moveq	#0,d3
	lea	(a0,d2.w),a2
	move.l	a1,a4
cadregauche_x
	move.b	(a2,d3.w),d5
	move	(a3,d5.w*4),(a4)+
	addq	#1,d3
	and	#63,d3
	dbra	d1,cadregauche_x
	lea	screenx*2(a1),a1
	add	#1<<6,d2
	and	#63<<6,d2
	dbra	d0,cadregauche_y

; -------------	Bordure droite

	move.l	affiche1,a1
	move	#screenx,d6
	sub	largeur_bord,d6
	lea	(a1,d6.w*2),a1
	and	#63,d6
	move	hauteur_bord,d0
	move	d0,d2
	and	#63,d2
	lsl	#6,d2
	mulu	#screenx*2,d0
	add.l	d0,a1
	move	cadre_resy,d0
	addq	#6-1,d0
cadredroite_y
	move	largeur_bord,d1
	subq	#1,d1
	move	d6,d3
	lea	(a0,d2.w),a2
	move.l	a1,a4
cadredroite_x
	move.b	(a2,d3.w),d5
	move	(a3,d5.w*4),(a4)+
	addq	#1,d3
	and	#63,d3
	dbra	d1,cadredroite_x
	lea	screenx*2(a1),a1
	add	#1<<6,d2
	and	#63<<6,d2
	dbra	d0,cadredroite_y

; -------------	Affichage du cadre

	moveq	#5,d2	; Dcalage bordure haut
	cmp	#3,game_type
	bne.s	.NotHeretic
	moveq	#0,d2
.NotHeretic

	; coin haut gauche

	move	largeur_bord,PrintX

	move	hauteur_bord,d0
	sub	d2,d0
	move	d0,PrintY

	move.l	cadre_hg,a0
	bsr	PrintLumpAdress

	; bord haut

	move.l	cadre_h,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	move	PrintTX,d1

	move	largeur_bord,d0
	addq	#3,d0
	move	d0,PrintX

	move	hauteur_bord,d0
	sub	d2,d0
	move	d0,PrintY

	moveq	#0,d0
	move	resx,d0
	divu	d1,d0
	subq	#1,d0
	move.l	a1,a0
cadre_bordhaut
	bsr	PrintLumpAdress
	add	d1,PrintX
	dbra	d0,cadre_bordhaut

	; coin haut droit

	move	#screenx,d0
	sub	largeur_bord,d0
	subq	#3,d0
	move	d0,PrintX

	move	hauteur_bord,d0
	sub	d2,d0
	move	d0,PrintY

	move.l	cadre_hd,a0
	bsr	PrintLumpAdress

	; bord gauche

	move.l	cadre_g,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	move	PrintTY,d1

	move	largeur_bord,PrintX

	move	hauteur_bord,d0
	addq	#3,d0
	move	d0,PrintY

	moveq	#0,d0
	move	cadre_resy,d0
	divu	d1,d0
	subq	#1,d0
	move.l	a1,a0
cadre_bordgauche
	bsr	PrintLumpAdress
	add	d1,PrintY
	dbra	d0,cadre_bordgauche

	; bord droit

	move.l	cadre_d,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	move	PrintTY,d1

	move	#screenx,d0
	sub	largeur_bord,d0
	subq	#3,d0
	move	d0,PrintX

	move	hauteur_bord,d0
	addq	#3,d0
	move	d0,PrintY

	moveq	#0,d0
	move	cadre_resy,d0
	divu	d1,d0
	subq	#1,d0
	move.l	a1,a0
cadre_borddroit
	bsr	PrintLumpAdress
	add	d1,PrintY
	dbra	d0,cadre_borddroit

	; coin bas gauche

	move	largeur_bord,PrintX

	move	#screeny,d0
	sub	StbarHeight,d0
	sub	hauteur_bord,d0
	subq	#3,d0
	move	d0,PrintY

	move.l	cadre_bg,a0
	bsr	PrintLumpAdress

	; bord bas

	move.l	cadre_b,a1
	move.l	(a1),a0
	bsr	PrintLumpInfo
	move	PrintTX,d1

	move	largeur_bord,d0
	addq	#3,d0
	move	d0,PrintX
	
	move	#screeny,d0
	sub	StbarHeight,d0
	sub	hauteur_bord,d0
	subq	#3,d0
	move	d0,PrintY

	moveq	#0,d0
	move	resx,d0
	divu	d1,d0
	subq	#1,d0
	move.l	a1,a0
cadre_bordbas
	bsr	PrintLumpAdress
	add	d1,PrintX
	dbra	d0,cadre_bordbas

	; coin bas droit

	move	#screenx,d0
	sub	largeur_bord,d0
	subq	#3,d0
	move	d0,PrintX
	
	move	#screeny,d0
	sub	StbarHeight,d0
	sub	hauteur_bord,d0
	subq	#3,d0
	move	d0,PrintY

	move.l	cadre_bd,a0
	bsr	PrintLumpAdress

; -------------	Fin affichage cadre

AfficheCadre_fini
	rts

	BSS
CadreSemaphore	ds.w	1

; -------------	Cherche l'adresse des morceaux du cadre

	TEXT

CADRE_ELEMENT	MACRO
	lea	\1,a0
	bsr	cherche_adresse
	move.l	a0,\1
	ENDM

InitCadre	move.l	dir_start,a1
	move.l	dir_end,a2
	
	CADRE_ELEMENT	cadre_hg
	CADRE_ELEMENT	cadre_h
	CADRE_ELEMENT	cadre_hd
	CADRE_ELEMENT	cadre_g
	CADRE_ELEMENT	cadre_d
	CADRE_ELEMENT	cadre_bg
	CADRE_ELEMENT	cadre_b
	CADRE_ELEMENT	cadre_bd

	rts

	BSS
NameCadre
cadre_hg	ds.l	2
cadre_h	ds.l	2
cadre_hd	ds.l	2
cadre_g	ds.l	2
cadre_d	ds.l	2
cadre_bg	ds.l	2
cadre_b	ds.l	2
cadre_bd	ds.l	2
