; -----------------------------------
;	Affichage de la carte
; -----------------------------------

CARTE_ROTATION	=	0
CARTE_MIX	=	0

	TEXT
AfficheCarte
	; Effacer l'cran ?
	
	move.l	affiche1,a0
	move	ScreenRatioY,d2
	subq	#1,d2
	move	#screeny,d1
	sub	StbarHeight,d1
	lsr	d2,d1
	subq	#1,d1
clr_bcly	move.l	a0,a1
	move	#screenx/8-1,d0
clr_bclx	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,clr_bclx
	add	ScreenLineLen,a0
	dbra	d1,clr_bcly

	; Limites d'affichage
	
	move	#screeny,d1
	sub	StbarHeight,d1
	move	d1,clip_maxy

	move	#screenx,d0
	move	d0,clip_maxx

	; Afficher les lignes

	move.l	adr_linedefs,a0
	move.l	num_linedefs,d0
	subq	#1,d0
carte_bcl_ldf
	movem.l	d0/a0,-(sp)
	bsr	carte_linedef
	movem.l	(sp)+,d0/a0
	lea	SIZEOF_LINEDEF(a0),a0
	dbra	d0,carte_bcl_ldf

	; Afficher le nom du niveau
	
	move	game_type,d0
	lea	HereticLevels,a0
	cmp	#3,d0
	beq.s	CarteNameFound
	lea	Doom2Levels,a0
	cmp	#2,d0
	beq.s	CarteNameFound
	lea	Doom1Levels,a0
CarteNameFound
	cmp	#2,game_type
	beq.s	CarteNameMAPxy
CarteNameExMy
	clr	d0
	move.b	game_level+1,d0	; d0= [123]
	sub.b	#"1",d0	; d0 =[012]
	clr	d1
	move.b	game_level+3,d1
	sub.b	#"1",d1
	mulu	#9,d0
	add	d1,d0
	bra.s	CarteNameOk
CarteNameMAPxy
	clr	d0
	move.b	game_level+3,d0
	sub.b	#"0",d0
	clr	d1
	move.b	game_level+4,d1
	sub.b	#"0",d1
	mulu	#10,d0
	add	d1,d0
	subq.w	#1,d0
CarteNameOk	
	move.l	(a0,d0.w*4),a1	; a1 adresse de la chaine

	clr	PrintX
	move	#screeny-10,d0
	sub	StbarHeight,d0
	move	d0,PrintY
	
	move.l	TextFonte,a0
	bsr	PrintStringAdress
	rts

	BSS

map_zoom	ds.w	1

clip_maxx	ds.w	1
clip_maxy	ds.w	1

; -------------	Affiche un LINEDEF

MAP_ROUGE	=	(31<<11)
MAP_VERT	=	(47<<5)
MAP_BLEU	=	(31<<5+31)
MAP_ROSE	=	(25<<11+42<<5+15)
MAP_JAUNE	=	(31<<11+63<<5)

	TEXT
carte_linedef
	btst.b	#NOT_ON_MAP,LINEDEF_ATTRIB+1(a0)
	beq.s	carte_linedef_done0
	rts
carte_linedef_done0
	move.l	#(MAP_ROUGE)<<16+MAP_ROUGE,d4	; Rouge
	btst.b	#ALREADY_ON_MAP-8,LINEDEF_ATTRIB(a0)
	bne.s	carte_linedef_done1
	rts
carte_linedef_done1
	btst.b	#TWO_SIDED,LINEDEF_ATTRIB+1(a0)
	beq	carte_linedef_done

	move	LINEDEF_RSIDE(a0),d6
	mulu	#SIZEOF_SIDEDEF,d6
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d6.l),d6
	mulu	#SIZEOF_SECTOR,d6
	move	(SECTOR_CEILING,[adr_sectors],d6.l),d6

	move	LINEDEF_LSIDE(a0),d7
	mulu	#SIZEOF_SIDEDEF,d7
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d7.l),d7
	mulu	#SIZEOF_SECTOR,d7
	move	(SECTOR_CEILING,[adr_sectors],d7.l),d7
	
	move.l	#MAP_JAUNE<<16+MAP_JAUNE,d4
	cmp	d6,d7
	bne.s	carte_linedef_done3

	move	LINEDEF_RSIDE(a0),d6
	mulu	#SIZEOF_SIDEDEF,d6
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d6.l),d6
	mulu	#SIZEOF_SECTOR,d6
	move	(SECTOR_FLOOR,[adr_sectors],d6.l),d6

	move	LINEDEF_LSIDE(a0),d7
	mulu	#SIZEOF_SIDEDEF,d7
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d7.l),d7
	mulu	#SIZEOF_SECTOR,d7
	move	(SECTOR_FLOOR,[adr_sectors],d7.l),d7

	move.l	#MAP_ROSE<<16+MAP_ROSE,d4
	cmp	d6,d7
	bne.s	carte_linedef_done3
	rts
carte_linedef_done3
	btst.b	#SECRET,LINEDEF_ATTRIB+1(a0)
	beq.s	carte_linedef_done
	move.l	#MAP_ROUGE<<16+MAP_ROUGE,d4	
carte_linedef_done

;	btst.b	#WALL_COLLISION-8,LINEDEF_ATTRIB(a0)
;	beq.s	carte_linedef_done12
;	move.l	#MAP_VERT<<16+MAP_VERT,d4	
;carte_linedef_done12

	move.l	d4,carte_couleur

	BSS
carte_couleur	ds.l	1

; -------------	Calcule le SEG rotat

	TEXT

	move.l	obj_observateur,a2

	move.l	adr_vertexes,a1
	move	OBJET_X(a2),d6
	move	OBJET_Y(a2),d7
	move	map_zoom,d5

	move	SEG_VERTEX1(a0),d4
	move	VERTEX_X(a1,d4.w*SIZEOF_VERTEX),d0
	sub	d6,d0
	muls	d5,d0
	asr.l	#8,d0
	move	VERTEX_Y(a1,d4.w*SIZEOF_VERTEX),d1
	sub	d7,d1
	neg	d1
	muls	d5,d1
	asr.l	#8,d1

	move	SEG_VERTEX2(a0),d4
	move	VERTEX_X(a1,d4.w*SIZEOF_VERTEX),d2
	sub	d6,d2
	muls	d5,d2
	asr.l	#8,d2
	move	VERTEX_Y(a1,d4.w*SIZEOF_VERTEX),d3
	sub	d7,d3
	neg	d3
	muls	d5,d3
	asr.l	#8,d3

; -------------	Rotation magique

	IFNE	CARTE_ROTATION

	move	OBJET_A(a2),d6
	lea	([cosinus],d6.w),a6
	lea	([sinus],d6.w),a5

	move.l	d0,d4
	move.l	d1,d5
	muls.l	(a5),d0	; d0 = x*cos a
	muls.l	(a6),d4	; d4 = x*sin a
	muls.l	(a5),d1	; d1 = y*cos a
	muls.l	(a6),d5	; d5 = y*sin a
	add.l	d5,d0	; d0 = x*cos a + y*sin a
	sub.l	d4,d1	; d4 =-x*sin a + y*cos a

	move.l	d2,d4
	move.l	d3,d5
	muls.l	(a5),d2	; d2 = x*cos a
	muls.l	(a6),d4	; d4 = x*sin a
	muls.l	(a5),d3	; d3 = y*cos a
	muls.l	(a6),d5	; d5 = y*sin a
	add.l	d5,d2	; d2 = x*cos a + y*sin a
	sub.l	d4,d3	; d3 =-x*sin a + y*cos a

	swap	d0
	swap	d1
	swap	d2
	swap	d3

	ENDC

	move	clip_maxx,d5
	lsr	#1,d5
	move	clip_maxy,d6
	lsr	#1,d6

	add	d5,d0
	add	d6,d1
	add	d5,d2
	add	d6,d3

; -------------	Affiche une ligne
;	d0,d1	x1,y1
;	d2,d3	x2,y2
;	d4	couleur

	move.l	carte_couleur,d4

	; Clipping

	bsr	ligne_clipping
	tst	d7
	bne	fin_carte_ligne

	; Rduire si zoom y *2
	
	move	ScreenRatioY,d7
	subq	#1,d7
	lsr	d7,d1
	lsr	d7,d3

	; Affichage

	move.l	affiche1,a0
	move	d1,d7
	mulu	ScreenLineLen,d7
	add.l	d7,a0
	lea	(a0,d0.w*2),a0

	move	ScreenLineLen,carte_dy
	move	#2,carte_dx

	move	d3,d7
	sub	d1,d7
	bpl.s	carlig_absy
	neg	d7
	neg	carte_dy
carlig_absy	
	move	d2,d6
	sub	d0,d6
	bpl.s	carlig_absx
	neg	d6
	neg	carte_dx
carlig_absx
	BSS

carte_dx	ds.w	1
carte_dy	ds.w	1

	TEXT
	
	move	carte_dx,d5
	move	carte_dy,d1
	
	cmp	d6,d7
	bpl.s	ligne_y
ligne_x
	move	d6,d2
	lsr	#1,d2
	move	d6,d0
lignex_bcl	
	IFEQ	CARTE_MIX
	move	d4,(a0)
	ELSE
	or	d4,(a0)
	ENDC
	sub	d7,d2
	bpl.s	lignex_nonxtp
	add	d6,d2
	add	d1,a0
lignex_nonxtp	add	d5,a0
	dbra	d0,lignex_bcl
	bra.s	fin_carte_ligne
ligne_y
	move	d7,d2
	lsr	#1,d2
	move	d7,d0
ligney_bcl	
	IFEQ	CARTE_MIX
	move	d4,(a0)
	ELSE
	or	d4,(a0)
	ENDC
	sub	d6,d2
	bpl.s	ligney_nonxtp
	add	d7,d2
	add	d5,a0
ligney_nonxtp	add	d1,a0
	dbra	d0,ligney_bcl

fin_carte_ligne
	rts

; -------------	Clipping

CLIP_NEW_X	MACRO	x,y,nx
	move	d3,d7	; (y2-y1)
	sub	d1,d7
	move	\3,d6
	sub	d0,d6	; (NX-x1)
	muls	d6,d7
	move	d2,d6
	sub	d0,d6	; (x2-x1)
	divs	d6,d7
	add	d1,d7	; y=y1+(y2-y1)*(NX-x1)/(x2-x1)
	move	d7,\2
	move	\3,\1
	ENDM

CLIP_NEW_Y	MACRO	x,y,ny
	move	d2,d7
	sub	d0,d7	; (x2-x1)
	move	\3,d6
	sub	d1,d6	; (NY-y1)
	muls	d6,d7
	move	d3,d6
	sub	d1,d6	; (y2-y1)
	divs	d6,d7
	add	d0,d7
	move	d7,\1	; x=x1+(x2-x1)*(NY-y1)/(y2-y1)
	move	\3,\2
	ENDM


ligne_clipping
	; Point 1
	
	tst	d0
	bpl.s	liclip1_1
	tst	d2
	bmi	liclip_erreur
	CLIP_NEW_X	d0,d1,#0
liclip1_1
	move	clip_maxx,d5
	cmp	d5,d0
	bmi.s	liclip1_2
	cmp	d5,d2
	bpl	liclip_erreur
	subq	#1,d5
	CLIP_NEW_X	d0,d1,d5
liclip1_2
	tst	d1
	bpl.s	liclip1_3
	tst	d3
	bmi	liclip_erreur
	CLIP_NEW_Y	d0,d1,#0
liclip1_3
	move	clip_maxy,d5
	cmp	d5,d1
	bmi.s	liclip1_4
	cmp	d5,d3
	bpl	liclip_erreur
	subq	#1,d5
	CLIP_NEW_Y	d0,d1,d5
liclip1_4

	; Point 2
	
	tst	d2
	bpl.s	liclip2_1
	tst	d0
	bmi	liclip_erreur
	CLIP_NEW_X	d2,d3,#0
liclip2_1
	move	clip_maxx,d5
	cmp	d5,d2
	bmi.s	liclip2_2
	cmp	d5,d0
	bpl.s	liclip_erreur
	subq	#1,d5
	CLIP_NEW_X	d2,d3,d5
liclip2_2
	tst	d3
	bpl.s	liclip2_3
	tst	d1
	bmi.s	liclip_erreur
	CLIP_NEW_Y	d2,d3,#0
liclip2_3
	move	clip_maxy,d5
	cmp	d5,d3
	bmi.s	liclip2_4
	cmp	d5,d1
	bpl.s	liclip_erreur
	subq	#1,d5
	CLIP_NEW_Y	d2,d3,d5
liclip2_4
	
	; Fin clipping

fin_liclip	moveq	#0,d7
	rts
liclip_erreur
	moveq	#-1,d7
	rts
