; ------------------------------
;	Touches de fonction
; ------------------------------

	TEXT
TestFunctions
	move	DoFunctions,d0
	clr	DoFunctions

; -------------	F1 - Snapshot

TF_F1?	btst	#FUNC_SNAPSHOT,d0
	beq.s	TF_F2?
	bra	TF_stop

; -------------	F2 - Save game

TF_F2?	btst	#FUNC_SAVEGAME,d0
	beq.s	TF_F3?
	move	#-1,display_menu
	move	#7,MenuActif
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
	bra	TF_stop

; -------------	F3 - Load game

TF_F3?	btst	#FUNC_LOADGAME,d0
	beq.s	TF_F4?
	move	#-1,display_menu
	move	#6,MenuActif
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
	bra	TF_stop

; -------------	F4 - Sound menu

TF_F4?	btst	#FUNC_SOUND,d0
	beq.s	TF_F5?
	move	#-1,display_menu
	move	#5,MenuActif
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
	bra	TF_stop

; -------------	F5 - Graphic detail

TF_F5?	btst	#FUNC_DETAIL,d0
	beq	TF_F6?
	btst	#FUNC_SHIFT,d0
	bne.s	yes_SF5

	; Changement ratio X
yes_F5
	move	#2,CadreSemaphore
	move	ScreenRatioX,d1
	moveq	#3,d2
	eor	d2,d1
	move	d1,ScreenRatioX
	cmp	#3,game_type
	beq.s	.F5_Heretic
	lea	DoomMenu_Detail,a0
	lea	DoomMenu_high,a1
	cmp	#1,d1
	beq.s	.F5_end
	lea	DoomMenu_low,a1
	bra.s	.F5_end
.F5_Heretic	lea	HerMenu_Detail,a0
	lea	HerMenu_high,a1
	cmp	#1,d1
	beq.s	.F5_end
	lea	HerMenu_low,a1
;	bra.s	.F5_end
	
.F5_end	move.l	a1,MENU_ADRVAR(a0)
	bra.s	no_F5

	; Changement ratio Y
yes_SF5
	move	ScreenRatioY,d1
	moveq	#3,d2
	eor	d2,d1
	move	d1,ScreenRatioY
no_F5
;	cmp	#2,v_monitor	; Si VGA : pas de zoom y
;	beq	chg_RatioY_VGA

	move	$ffff8210.w,d2
	add	d2,d2
	cmp	#1,ScreenRatioY
	beq.s	.chg_RatioY
	add	d2,d2
.chg_RatioY	move	d2,ScreenLineLen
	bra	TF_stop

; -------------	F6 - Quick save

TF_F6?	btst	#FUNC_QUICKSAVE,d0
	beq.s	TF_F7?
	move	#-1,display_menu
	move	#7,MenuActif
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
	bra	TF_stop

; -------------	F7 - End game

TF_F7?	btst	#FUNC_ENDGAME,d0
	beq.s	TF_F8?
	bra	TF_stop

; -------------	F8 - Messages on/off

TF_F8?	btst	#FUNC_MESSAGES,d0
	beq.s	TF_F9?
	not	display_msg

	cmp	#3,game_type
	beq.s	.F8_Heretic
	lea	DoomMenu_Msg,a0
	lea	DoomMenu_msgoff,a1
	tst	display_msg
	beq.s	.F8_end
	lea	DoomMenu_msgon,a1
	bra.s	.F8_end
.F8_Heretic	lea	HerMenu_Msg,a0
	lea	HerMenu_msgoff,a1
	tst	display_msg
	beq.s	.F8_end
	lea	HerMenu_msgon,a1
;	bra.s	.F8_end
	
.F8_end	move.l	a1,MENU_ADRVAR(a0)
	bra	TF_stop

; -------------	F9 - Quick load

TF_F9?	btst	#FUNC_QUICKLOAD,d0
	beq.s	TF_F10?
	move	#-1,display_menu
	move	#6,MenuActif
	move.l	#ControleObjet,ControlePrec
	move.l	#ControleMenu,ControleVbl
	bra	TF_stop

; -------------	F10 - Quit game

TF_F10?	btst	#FUNC_QUIT,d0
	beq.s	TF_stop
	move	#-1,QuitGame
;	bra	TF_stop

; -------------	Fin

TF_stop	rts

	BSS
DoFunctions	ds.w	1
