; ------------------------------
;	Gestion des messages
; ------------------------------

MAX_MESSAGES	=	8

; -------------	Init des messages

	TEXT
InitMessages
	lea	Messages_adr,a0
	REPT	MAX_MESSAGES
	clr.l	(a0)+
	ENDR
	move.l	#AfficheMessages,DisplayMessages
	rts

; -------------	Affichage des messages
;	TextFonte	Fonte  utiliser

	TEXT
AfficheMessagesLimit
	move.l	game_timer,d0	; Si plus de 2 secondes
	sub.l	MessagesTime,d0	; on dcale pour faire de la place
	cmp.l	#2*GAME_TIMER_FREQ,d0
	bmi.s	AFM_ok

	tst.l	Messages_adr
	beq.s	AML_NoRedraw
	move	#2,CadreSemaphore
AML_NoRedraw
	move.l	game_timer,MessagesTime
	lea	Messages_adr,a0
	moveq	#MAX_MESSAGES-2,d0
.AFM_boucle1	move.l	4(a0),(a0)+
	dbra	d0,.AFM_boucle1
	clr.l	(a0)
AFM_ok
	; Affichage

AfficheMessages
	moveq	#0,d1	; PrintY
	cmp	#3,game_type
	bne.s	.NotHeretic
;	IFEQ	DOUBLE_PIXEL
	moveq	#2,d1
;	ELSE
;	moveq	#1,d1
;	ENDC
.NotHeretic	
	lea	Messages_adr,a2
	moveq	#MAX_MESSAGES-1,d0
.AFM_boucle	tst.l	(a2)
	beq.s	.AFM_stop
	clr	PrintX
	move	d1,PrintY
	move.l	(a2)+,a1
	move.l	TextFonte,a0
	bsr	PrintStringAdress
;	IFEQ	DOUBLE_PIXEL
	addq.w	#8,d1
;	ELSE
;	addq.w	#4,d1
;	ENDC
	dbra	d0,.AFM_boucle
.AFM_stop	rts

	BSS
DisplayMessages	ds.l	1	; Routine d'affichage des messages

; -------------	Ajout d'un message
;	a0	Adresse message  ajouter
;	Ajouter en dernier. Si plus de place on dcale

	TEXT
AjoutMessage
	; Chercher s'il reste une place libre
	
	lea	Messages_adr,a1
	moveq	#0,d1	; Message courant
	moveq	#-1,d2	; Message libre
	moveq	#MAX_MESSAGES-1,d0
.AM_boucle	tst.l	(a1)+
	bne.s	.AM_next
	move	d1,d2
	bra.s	.AM_stop
.AM_next	addq	#1,d1
	dbra	d0,.AM_boucle
.AM_stop
	; Si d2=-1 : plus de place : on dcale

	tst	d2
	bpl.s	.AM_Place
	lea	Messages_adr,a1
	moveq	#MAX_MESSAGES-1,d0
.AM_boucle1	move.l	4(a1),(a1)+
	dbra	d0,.AM_boucle1
	moveq	#MAX_MESSAGES-1,d2
.AM_Place

	; Mettre le message  l'endroit attribu
	
	lea	Messages_adr,a1
	move.l	a0,(a1,d2.w*4)

	rts

	BSS
display_msg	ds.w	1
MessagesTime	ds.l	1	; Temps depuis dernier ajout de message
Messages_adr	ds.l	8	; 8 Messages simultans
