; ---------------------------------------------------
;	Chargement des WADs
; ---------------------------------------------------

	TEXT
charger_wad
	FGETDTA
	move.l	d0,old_dta
	FSETDTA	#my_dta
	clr	game_type

	BSS

old_dta	ds.l	1
my_dta	ds.b	44
name_iwad	=	my_dta+30

; ----------------------------------------
;	DOOM ?
; ----------------------------------------

	TEXT
charger_iwad_doom?
	FSFIRST	#wad_to_search,#0
	tst.l	d0
	bmi	charger_iwad_heretic?
	FSETDTA	old_dta

	; Init le nom du niveau

	move	#1,game_type
	
	move.l	#"E1M1",game_level
	clr.l	game_level+4

	lea	name_iwad,a0

;	cmp.b	#"1",4(a0)
;	bne.s	gametype_notdoom1
;	move	#1,game_type
;gametype_notdoom1
	cmp.b	#"2",4(a0)
	bne.s	gametype_notdoom2
	move.l	#"MAP0",game_level
	move.l	#"1"<<24,game_level+4
	move	#2,game_type
gametype_notdoom2

	move.l	#DoomInitStbar,InitStbarRout
	move.l	#DoomArmes,WeaponsList
	move.l	#DoomSearchObjectAdress,SrchObjAdrRout
	move.l	#DoomGravite,GraviteRout
	move.l	#DoomInitMenus,InitMenuRout
	move.l	#DoomInitTitlePic,InitTitlePic
	move.l	#DoomInitTextFont,InitTextFont
	move.l	#DoomActivateTable,ActivateTable
	move	#141+1,ActivateMax
	move.l	#DoomInitInter,InitInterRout

	; Nom du cadre
	
	lea	NameCadre,a0
	move.l	#"BRDR",d0

	move.l	d0,(a0)+
	move.l	#"_TL"<<8,(a0)+
	move.l	d0,(a0)+
	move.l	#"_T"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"_TR"<<8,(a0)+
	move.l	d0,(a0)+
	move.l	#"_L"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"_R"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"_BL"<<8,(a0)+
	move.l	d0,(a0)+
	move.l	#"_B"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"_BR"<<8,(a0)+

	bra	charger_iwad_trouve

	DATA
wad_to_search	dc.b	"doom*.wad",0
	even

; ----------------------------------------
;	Heretic ?
; ----------------------------------------

	TEXT
charger_iwad_heretic?	
	FSFIRST	#wad_to_search1,#0
	tst.l	d0
	bmi	charger_iwad_erreur
	FSETDTA	old_dta

	; Init le nom du niveau

	clr	game_type
	
	move.l	#"E1M1",game_level
	clr.l	game_level+4

	lea	name_iwad,a0

;	cmp.b	#"1",7(a0)
;	bne.s	gametype_notheretic1
	move	#3,game_type
;gametype_notheretic1

	move.l	#HereticInitStbar,InitStbarRout
	move.l	#HereticArmes,WeaponsList
	move.l	#HereticSearchObjectAdress,SrchObjAdrRout
	move.l	#HereticGravite,GraviteRout
	move.l	#HereticInitTitlePic,InitTitlePic
	move.l	#HerInitMenus,InitMenuRout
	move.l	#HerInitTextFont,InitTextFont
	move.l	#HereticActivateTable,ActivateTable
	move	#107+1,ActivateMax
	move.l	#HereticInitInter,InitInterRout

	; Nom du cadre
	
	lea	NameCadre,a0
	move.l	#"BORD",d0

	move.l	d0,(a0)+
	move.l	#"TL"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"T"<<24,(a0)+
	move.l	d0,(a0)+
	move.l	#"TR"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"L"<<24,(a0)+
	move.l	d0,(a0)+
	move.l	#"R"<<24,(a0)+
	move.l	d0,(a0)+
	move.l	#"BL"<<16,(a0)+
	move.l	d0,(a0)+
	move.l	#"B"<<24,(a0)+
	move.l	d0,(a0)+
	move.l	#"BR"<<16,(a0)+
	
	DATA
wad_to_search1	dc.b	"heretic*.wad",0
	even

; ------------------------------
;	Charger le IWAD
; ------------------------------

	TEXT
charger_iwad_trouve
	clr.l	dir_malloc

	CCONWS	#loading_wads
	CCONWS	#name_iwad
	CCONWS	#string_nxt_line

	XazFopen	#name_iwad,#XAZ_READONLY
	move.l	d0,a5
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	charger_iwad_erreur		

	move.l	d0,a0
	cmp.l	#"IWAD",(a0)
	bne	charger_iwad_erreur

	lea	4(a0),a1
	INVERSE_LONG2	a1,d0
	move.l	d0,dir_length
	INVERSE_LONG2	a1,d0
	lea	(a0,d0.l),a4

	move.l	dir_length,d0
	lsl.l	#4,d0
	move.l	d0,dir_size

	XazMxalloc	dir_size,#XAZ_PREFTTRAM

	move.l	d0,dir_malloc
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	charger_iwad_erreur		

	move.l	a4,a0
	move.l	dir_malloc,a1
	move.l	dir_length,d0
	subq.l	#1,d0
iwad_clear_dir
	INVERSE_LONG2	a0,d1
	add.l	a5,d1
	move.l	d1,(a1)+	; Adresse du fichier
	INVERSE_LONG2	a0,d2	; Longueur du fichier
	move.l	d2,(a1)+
	move.l	(a0)+,(a1)+	; Nom du fichier
	move.l	(a0)+,(a1)+
	dbra	d0,iwad_clear_dir

	move.l	dir_malloc,dir_start
	move.l	dir_malloc,d0
	add.l	dir_size,d0
	move.l	d0,dir_end

	DATA
loading_wads	dc.b	"Loading ",0
	even

	BSS
	
dir_length	ds.l	1	; Nb de fichiers du directory
dir_malloc	ds.l	1	; Adresse RAM du directory
dir_size	ds.l	1	; Longueur bloc

dir_start	ds.l	1	; Adr depart du directory
dir_end	ds.l	1	; Adr de fin

; -------------------------------
;	Charger les PWAD
; -------------------------------

; -------------	Cherche "-file" dans la ligne de commande

	TEXT

	move	_argc,d1
	subq	#2,d1
	bmi	charger_pwad_fin
	lea	(4,[_argv.l]),a0	; char *argv[]
cherche_mfile
	move.l	(a0)+,d0
	beq.s	stop_cherche_mfile
	strcmp	d0,#wadload_param1
	tst	d0
	bne.s	cherche_mfile_nxt
cherche_nxt_file
	subq	#1,d1
	bmi.s	stop_cherche_mfile
	
	move.l	(a0)+,d2
	movem.l	d1/a0,-(sp)
	move.l	d2,a0
	bsr.s	charger_pwad
	movem.l	(sp)+,d1/a0
	tst	d0
	bmi	charger_iwad_erreur	
	
	move.l	(a0),a1
	cmp.l	#0,a1
	beq.s	stop_cherche_mfile
	cmp.b	#"-",(a1)
	bne.s	cherche_nxt_file
cherche_mfile_nxt
	dbra	d1,cherche_mfile
stop_cherche_mfile
	bra	charger_pwad_fin

	DATA
wadload_param1	dc.b	"-file",0
	even

; -------------	Ajout du PWAD dans le directory
;	a0 nom du fichier

	DATA
adding_pwad	dc.b	"Adding ",0
	even

	TEXT
charger_pwad
	move.l	a0,-(sp)
	CCONWS	#adding_pwad
	move.l	(sp),a0
	CCONWS	a0
	CCONWS	#string_nxt_line
	move.l	(sp)+,a0

	XazFopen	a0,#XAZ_READONLY
	move.l	d0,pwad_adress
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	charger_pwad_erreur		

	move.l	d0,a0
	cmp.l	#"PWAD",(a0)
	bne	charger_pwad_erreur

	lea	4(a0),a1
	INVERSE_LONG2	a1,d0
	move.l	d0,dir_length1
	INVERSE_LONG2	a1,d0
	lea	(a0,d0.l),a4
	move.l	a4,dir_adr1

; -------------	On malloc un nouveau directory

	move.l	dir_length1,d0
	add.l	dir_length,d0
	lsl.l	#4,d0
	XazMxalloc	d0,#XAZ_PREFTTRAM
	move.l	d0,dir_malloc1
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	charger_pwad_erreur

	clr	pwad_levelfound

	BSS
pwad_adress	ds.l	1
dir_length1	ds.l	1	
dir_adr1	ds.l	1	; adr virtuelle du PWAD directory
dir_malloc1	ds.l	1	; Adr nouveau directory

pwad_levelfound	ds.w	1	; Nouveau niveau trouv ?

; -------------	On recopie les donnes de l'ancien dans le nouveau

	TEXT
	
	move.l	dir_malloc,a0
	move.l	dir_malloc1,a1
	move.l	dir_length,d0
	subq	#1,d0
pwad_copy_iwad_bcl
	move.l	(a0)+,(a1)+	; Adresse
	move.l	(a0)+,(a1)+	; Longueur
	move.l	(a0)+,(a1)+	; Nom
	move.l	(a0)+,(a1)+
	dbra	d0,pwad_copy_iwad_bcl

; ------------------------------
;	On y ajoute les donnes du PWAD
; ------------------------------
;	pwad_adress	Adresse du PWAD
;	dir_malloc1	Rpertoire IWAD+(PWAD)
;	dir_length	Nb entres IWAD
;	dir_adr1	Rpertoire PWAD
;	dir_length1	Nb entres PWAD

	move.l	dir_malloc1,a2
	move.l	a2,dir_start1
	move.l	dir_length,d0
	lsl.l	#4,d0
	add.l	d0,a2
	move.l	a2,dir_end1

	move.l	dir_adr1,a6
	move.l	dir_length1,d0
	subq.l	#1,d0
PwadRecopy_bcl

; -------------	Si le nom 8(a0) est dans le IWAD

	lea	8(a6),a0
	move.l	dir_start1,a1
	move.l	dir_end1,a2
	bsr	cherche_adresse
	cmp.l	#0,a0	; a0 adresse dans IWAD
	beq	PR_NotFound

; -------------	Si c'est une marque (len=0)

	tst.l	4(a0)
	bne	PR_NotMark
		
	; --- Si c'est un niveau
	;       remplacer niveau

PR_EXMY?	cmp.b	#"E",8(a0)
	bne.s	PR_MAP?
	cmp.b	#"M",10(a0)
	beq.s	PR_YesLevel
	bra	PR_NotMark
PR_MAP?
	cmp	#"MA",8(a0)
	bne	PR_NotMark
	cmp.b	#"P",10(a0)
	bne	PR_NotMark
PR_YesLevel
	tst	pwad_levelfound
	bne.s	PR_NoNewLevel
	not	pwad_levelfound
	move.l	8(a0),game_level
	move.l	12(a0),game_level+4
PR_NoNewLevel
	lea	16(a0),a5	; Entre suivante du IWAD
PR_CopyLevel_bcl
	lea	16(a6),a6	; Entre suivante du PWAD
	subq.w	#1,d0	
	bmi	PwadRecopy_stop
	movem.l	8(a6),d1-d2	

PR_THINGS?	cmp.l	#"THIN",d1
	bne.s	PR_LINEDEFS?
	cmp.l	#"GS"<<16,d2
	beq	Pwad_IsInLevel

PR_LINEDEFS?	cmp.l	#"LINE",d1
	bne.s	PR_SIDEDEFS?
	cmp.l	#"DEFS",d2
	beq.s	Pwad_IsInLevel

PR_SIDEDEFS?	cmp.l	#"SIDE",d1
	bne.s	PR_VERTEXES?
	cmp.l	#"DEFS",d2
	beq.s	Pwad_IsInLevel

PR_VERTEXES?	cmp.l	#"VERT",d1
	bne.s	PR_SEGS?
	cmp.l	#"EXES",d2
	beq.s	Pwad_IsInLevel

PR_SEGS?	cmp.l	#"SEGS",d1
	beq.s	Pwad_IsInLevel

PR_SSECTORS?	cmp.l	#"SSEC",d1
	bne.s	PR_NODES?
	cmp.l	#"TORS",d2
	beq.s	Pwad_IsInLevel

PR_NODES?	cmp.l	#"NODE",d1
	bne.s	PR_SECTORS?
	cmp.l	#"S"<<24,d2
	beq.s	Pwad_IsInLevel

PR_SECTORS?	cmp.l	#"SECT",d1
	bne.s	PR_REJECT?
	cmp.l	#"ORS"<<8,d2
	beq.s	Pwad_IsInLevel

PR_REJECT?	cmp.l	#"REJE",d1
	bne.s	PR_BLOCKMAP?
	cmp.l	#"CT"<<16,d2
	beq.s	Pwad_IsInLevel

PR_BLOCKMAP?	cmp.l	#"BLOC",d1
	bne	PwadRecopy_bcl
	cmp.l	#"KMAP",d2
	bne	PwadRecopy_bcl

	; Remplacer une partie d'un niveau par une autre
	; Mettre a6 dans a5

Pwad_IsInLevel
	move.l	a5,a4
PR_SearchDest_niv
	cmp.l	8(a4),d1
	bne.s	PR_SearchDest_next
	cmp.l	12(a4),d2
	beq.s	PR_DestFound
PR_SearchDest_next
	lea	16(a4),a4
	bra.s	PR_SearchDest_niv
PR_DestFound
	move.l	a4,a1
	move.l	a6,a0
	bsr	PwadReplaceEntry

	bra	PR_CopyLevel_bcl

; -------------	Remplacer  l'emplacement trouv

PR_NotMark	move.l	a0,a1
	move.l	a6,a0
	bsr	PwadReplaceEntry
	bra.s	PwadRecopy_next
	
; -------------	Ajouter  la fin
	
PR_NotFound	move.l	dir_end1,a1
	move.l	a6,a0
	bsr	PwadReplaceEntry
	move.l	a1,dir_end1
;	bra.s	PwadRecopy_next	

; -------------	Entre suivante du PWAD

PwadRecopy_next	lea	16(a6),a6
	dbra	d0,PwadRecopy_bcl
PwadRecopy_stop	
	move.l	dir_end1,d6	; Longueur nouveau directory
	sub.l	dir_start1,d6
	move.l	d6,d7
	lsr.l	#4,d7	; Nb d'entres nouveau directory

	BSS

dir_start1	ds.l	1
dir_end1	ds.l	1

; -------------	On shrink paske ya eu des doublons

	TEXT

	XazMshrink	dir_malloc1,d6
	cmp.l	#XAZ_OK,d0
	bne.s	charger_pwad_erreur

; -------------	On vire l'ancien, on garde le nouveau

	XazMfree	dir_malloc
	move.l	dir_malloc1,dir_malloc
	move.l	d7,dir_length
	move.l	d6,dir_size

	move.l	dir_malloc,dir_start
	move.l	dir_malloc,d0
	add.l	dir_size,d0
	move.l	d0,dir_end

; -------------	Fin du chargement

charger_pwad_fin
	clr.l	d0
	rts
charger_pwad_erreur
charger_iwad_erreur
	moveq	#-1,d0
	rts

; ------------------------------
;	Remplacement d'une entre par une autre
; ------------------------------
;	a0 M	Source (PWAD)
;	a1 M	Destination (IWAD+PWAD)

PwadReplaceEntry
	cmp.l	#$08000000,4(a0)
	beq.s	PR_NoReplace
	INVERSE_LONG2	a0,d1
	add.l	pwad_adress,d1
	move.l	d1,(a1)+
	INVERSE_LONG2	a0,d1
	move.l	d1,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
PR_NoReplace	rts
