; ------------------------------
;	OBJET
; ------------------------------

	RsReset
OBJET_X	rs.l	1	; (16:16) Coordonnes actuelles
OBJET_Y	rs.l	1	; (16:16)
OBJET_Z	rs.l	1	; (16:16)
OBJET_A	rs.w	1	; (16)
OBJET_X1	rs.l	1	; (16:16) Coordonnes suivantes
OBJET_Y1	rs.l	1	; (16:16)
OBJET_Z1	rs.l	1	; (16:16)
OBJET_A1	rs.w	1	; (16)
OBJET_H	rs.w	1	; (16) Hauteur de la vue
OBJET_RAYON	rs.w	1	; Rayon de l'objet
OBJET_TYPE	rs.w	1	; THING_TYPE
OBJET_SPRITE	rs.l	1	; Adresse du sprite de l'objet
OBJET_LIFE	rs.l	1	; Routine qui gre l'objet
OBJET_FIXE	rs.w	1	; 0=Objet fixe -1 objet mobile
OBJET_SSECTOR	rs.w	1	; SSECTOR dans lequel se trouve l'objet
OBJET_GRAVITE	rs.w	1	; 0=Pas de gravit,1=Gravit sol,2=Gravit plafond
OBJET_THING	rs.l	1	; THING originel de cet objet
OBJET_NEXT	rs.l	1	; prochain objet dans le meme SSECTOR
OBJET_PRESENT	rs.w	1	; 0 slot libre -1 slot occup
SIZEOF_OBJET	rs.w	1

; -------------	Rservation des blocs en mmoire

SIZEOF_BLOCOBJ	=	8192
MAXOBJPERBLOC	=	(SIZEOF_BLOCOBJ-4)/SIZEOF_OBJET

; -------------	Dfinition d'un Sprite dans la liste des objets

	RsReset
SPR_NAME	rs.b	6	; char[6] : Nom de base avant init
SPR_EXT	=	SPR_NAME+4	; char [2] : Extension du nom de base
SPR_ANIM	rs.w	1	; int : Nb de sprites pour animation
SPR_LIFE	rs.l	1	; void (*) : Routine qui gere l'objet
SPR_HEIGHT	rs.w	1	; int : Hauteur de l'objet
SPR_RADIUS	rs.w	1	; int : Rayon de l'objet
SPR_WEIGHT	rs.w	1	; int : Masse de l'objet
SPR_FIXE	rs.w	1	; int : objet fixe/mobile
SPR_ENTRY	rs.l	1	; long * : Adresse du premier sprite avec ce nom
SPR_NB	rs.w	1	; int : Nb de sprites ayant ce nom
SIZEOF_SPRITE	rs.w	1

DEF_SPRITE	MACRO
	IFNE	\1
	dc.l	\1	; char [4]
	dc.w	\2	; char [2]
	dc.w	\3	; int anim
	dc.l	\4	; void (*control)()
	dc.w	\5	; int height
	dc.w	\6	; int radius
	dc.w	\7	; int weight
	dc.w	\8	; int fixe
	dc.l	0	; long *adresse
	dc.w	0	; int nb
	ELSE
	dcb.b	6,0	; char [6]
	dc.w	0	; int a
	dc.l	0	; void *
	dc.w	4	; int height=4
	dc.w	0	; int r
	dc.w	0	; int w
	dc.w	0	; int fixe
	dc.l	0	; long *adresse
	dc.w	0	; int nb
	ENDC
	ENDM
