; ------------------------------
;	Objet avec animation PingPong
; ------------------------------
;	d0	=0 si sens normal, =-1 si symetrie
;	a3	adresse de l'objet

	TEXT
ObjPingPong
	movem.l	d1-d2/a2/a4,-(sp)

	move	OBJET_TYPE(a3),d0
	ble.s	ObjPingPong_stop

	jsr	([SrchObjAdrRout])
	mulu	#SIZEOF_SPRITE,d0
	add.l	d0,a4

	move	SPR_ANIM(a4),d1	; d1 = Nb de sprites/anim : ABC
	add	d1,d1	; ABC--- ABCBABCBABC
	subq	#2,d1	; Moins le premier et dernier : ABC-

	move.l	game_timer,d2
	lsr.l	#3,d2	; Anim par 8 vbls
	divu	d1,d2
	swap	d2

	move	SPR_ANIM(a4),d1	; C-2-N
	cmp	d1,d2
	bmi.s	ObjPingPong_next ; Saute si <= moiti
	sub	d1,d2
	subq	#2,d1	; C=C-2
	sub	d2,d1	; C=C-2-N
	move	d1,d2	; N=C
ObjPingPong_next
	lsl	#8,d2
	add	SPR_EXT(a4),d2	; char [2] : Nom  trouver

	bsr	SearchSprite
	
	clr.l	OBJET_SPRITE(a3)
	cmp.l	#0,a2
	beq.s	ObjPingPong_stop
	move.l	(a2),OBJET_SPRITE(a3)
ObjPingPong_stop	
	moveq	#0,d0
	movem.l	(sp)+,d1-d2/a2/a4
	rts
