; -----------------------------
;	Init trac de la pile
; -----------------------------
;	draw_start	Ou on s'est arrete dans la pile

;	drawstack	Pile d'objets
;	0-n : plus pres>plus loin
;	sort_tstart	Indices
;	0-n : plus pres>plus loin
;	sort_ystart	Ymax
;	0-n : plus pres>plus loin
;	sort_number	Nb d'objets dans la pile

	ORG	p:
InitRenderScene
	move	x:sort_tstart,r0
	nop
	lua	(r0)-,r0
	move	r0,x:sort_current

	jmp	<attente

; -----------------------------
;	Trac de la pile
; -----------------------------

	ORG	x:

local_plafond11	ds	1
local_plafond12	ds	1
local_plafond21	ds	1
local_plafond22	ds	1

local_sol11	ds	1
local_sol12	ds	1
local_sol21	ds	1
local_sol22	ds	1
	
local_sinus	ds	1
local_cosinus	ds	1

mur_tx	ds	1
sidedef_offsetx	ds	1
sidedef_offsety	ds	1

	ORG	p:
RenderStackElement
	move	x:sort_current,r1
	move	#>SIZEOF_DRAW,x1
	move	x:(r1)-,x0
	mpy	x0,x1,a	r1,x:sort_current
	asr	a	#>drawstack,r0
	move	a0,n0
	nop
	lua	(r0)+n0,r0
	nop

	POP	x:xe1
	POP	x:xe2
	POP	x:ye1
	POP	x:ye2
	POP	x:seg_orig_x1
	POP	x:seg_orig_y1
	POP	x:seg_orig_x2
	POP	x:seg_orig_y2
	POP	x:seg_x1
	POP	x:seg_y1
	POP	x:seg_x2
	POP	x:seg_y2
	POP	x:local_ceiling1
	POP	x:local_floor1
	POP	x:local_ceiling2
	POP	x:local_floor2
	POP	x:local_bright
	POP	x:local_sinus
	POP	x:local_cosinus
	POP	x:linedef_attrib
	POP	x:sidedef_offsetx
	POP	x:sidedef_offsety
	POP	x:pile_type

	WRITEHOST	x:xe1
	WRITEHOST	x:xe2
	WRITEHOST	x0	; Nb objet  afficher
	WRITEHOST	x:pile_type

	move	x:xe2,a
	move	x:xe1,b
	sub	b,a	#>1,x0
	add	x0,a
	move	a,x:local_longueur

; -------------	Inits pour calcul sols/plafonds

	move	#>trace_K,r4
	move	x:xe1,n4
	move	#>mur_ymapping,r0
	lua	(r4)+n4,r4
	jsr	<InitCalcHoMap
	move	a,x:(r0)

	; Calcul pour xe1,ceiling1,floor1

	move	#>local_plafond11,r1
	move	#>local_sol11,r2
	move	x:local_ceiling1,a
	move	x:local_floor1,b
	jsr	<InitCalcVeMap

	; Calcul pour xe1,ceiling2,floor2

	move	#>local_plafond21,r1
	move	#>local_sol21,r2
	move	x:local_ceiling2,a
	move	x:local_floor2,b
	jsr	<InitCalcVeMap

	; ---

	move	#>trace_K,r4
	move	x:xe2,n4
	move	#>mur_ymapping,r0
	lua	(r4)+n4,r4
	jsr	<InitCalcHoMap
	move	a,x:(r0)
	
	; Calcul pour xe2,ceiling1,floor1
	
	move	#>local_plafond12,r1
	move	#>local_sol12,r2
	move	x:local_ceiling1,a
	move	x:local_floor1,b
	jsr	<InitCalcVeMap

	; Calcul pour xe2,ceiling2,floor2
	
	move	#>local_plafond22,r1
	move	#>local_sol22,r2
	move	x:local_ceiling2,a
	move	x:local_floor2,b
	jsr	<InitCalcVeMap

	jmp	<attente

; -------------	Routine pour calcul mapping

InitCalcHoMap	move	x:seg_orig_x2,b		; Calcul du dnominateur
	move	x:seg_orig_x1,y0
	move	x:seg_orig_y2,a
	move	x:seg_orig_y1,x0
	sub	x0,a	x:(r4),x1
	sub	y0,b	a,y1
	mpy	-x1,y1,a		; (8:16)*(16:8)=(24:24)
	rep	#8-4
	asl	a		; a=(16:32)
	asl	a	x:seg_orig_x1,x0
	asl	a	x:seg_orig_y1,y0
	asl	a	x:seg_orig_x2,x1
	add	a,b	x:seg_orig_y2,y1

	mpy	y0,x1,a	b,x1	; y1*x2
	mac	-x0,y1,a	x:(r4),x0	; y1*x2-x1*y2 (32:16)
	
	jsr	<division_signee	; Calcul de Y
	rts

; -------------	Calcul des lignes de dpart et de fin

InitCalcVeMap	move	#>256,x0
	move	a,x1
	mpy	-x0,x1,a	b,x1
	mpy	-x0,x1,b	a,l:colonne_start
	move	b,l:colonne_end

	move	x:(r0),y0
	move	x:lumiere_const,x0
	mpy	x0,y0,b	x:ecr_ligne,x0
	rep	#9-1
	asr	b
	asr	b	#>1,y0
	move	b0,x1

	; ecran=ecr_ligne+(player_h-hauteur_mur)/ycoef

	; Point de depart ecran

	jsr	<division_entiere
;	tst	a
;	jle	<_mur_debme1
;	add	y0,a
;_mur_debme1	
	add	x0,a
	move	a,x:(r1)

	; Point d'arrivee ecran

	move	l:colonne_end,a
	jsr	<division_entiere
;	tst	a
;	jge	<_mur_finp1
;	sub	y0,a
;_mur_finp1	
	add	x0,a
	move	a,x:(r2)
	rts
