; ------------------------------
;	Routines d'affichage
; ------------------------------

	TEXT
RenderScene
	clr	tcache_flag	; Textures opaques

	move	draw_walls,d0
	add	draw_sprites,d0
	beq	fin_trace_drawstack
	subq.w	#1,d0

	move.l	obj_observateur,a2
	move	OBJET_H(a2),d1
	add	OBJET_Z(a2),d1
	move	d1,RenderHeight

	lea	$ffffa202.w,a6
	
	DSPWAITINPUT	(a6)
	move.l	#"INI",2(a6)
drawstack_bcl
	move	d0,-(sp)
	
	DSPWAITINPUT	(a6)
	move.l	#"RDR",2(a6)

	DSPWAITOUTPUT	(a6)
	move	4(a6),xe1
	DSPWAITOUTPUT	(a6)
	move	4(a6),xe2
	DSPWAITOUTPUT	(a6)
	move	4(a6),d1
	
	lea	drawstack,a5
	mulu	#SIZEOF_DRAW,d1
	add.l	d1,a5
	
	DSPWAITOUTPUT	(a6)
	tst	4(a6)
	bne	drawstack_sprite

; -------------	Mur opaque ou transparent ?

	move	DRAW_TXT_MAIN(a5),d0
	bmi	fin_render_mur
	
	btst.b	#TWO_SIDED,DRAW_LDF_ATTRIB+1(a5)
	bne.s	render_murt
render_mur
	bsr	cherche_texture

	cmp.l	#0,a0
	beq	fin_render_mur
	move.l	(a0)+,a4	; mur_adr
	move	(a0)+,d0
	subq	#1,d0	; mur_tx pour AND

	DSPWAITINPUT	(a6)
	move.l	#"MUR",2(a6)
	DSPWAITINPUT	(a6)
	move	d0,4(a6)
	DSPWAITINPUT	(a6)
	move	(a0),4(a6)	; mur_ty
	jsr	([RenderWallRout])
	bra.s	fin_render_mur
render_murt
	move	#-1,tcache_flag
	bsr	cherche_texture
	clr	tcache_flag

	cmp.l	#0,a0
	beq.s	fin_render_mur
	move.l	(a0)+,a4
	move	(a0)+,d0
	subq	#1,d0	; mur_tx pour AND

	DSPWAITINPUT	(a6)
	move.l	#"MRT",2(a6)
	DSPWAITINPUT	(a6)
	move	d0,4(a6)
	DSPWAITINPUT	(a6)
	move	(a0),4(a6)	; mur_ty
	jsr	([RenderWallTRout])
fin_render_mur

; -------------	Mur haut

	move	DRAW_CEILING2(a5),d0
	cmp	DRAW_CEILING1(a5),d0
	bpl.s	fin_render_murup

	move	DRAW_TXT_UPPER(a5),d0
	bsr	cherche_texture

	cmp.l	#0,a0
	beq.s	fin_render_murup
	move.l	(a0)+,a4	; mur_adr
	move	(a0)+,d0
	subq	#1,d0	; mur_tx pour AND

	DSPWAITINPUT	(a6)
	move.l	#"MUP",2(a6)
	DSPWAITINPUT	(a6)
	move	d0,4(a6)
	DSPWAITINPUT	(a6)
	move	(a0),4(a6)	; mur_ty
	jsr	([RenderWallRout])
fin_render_murup
	
; -------------	Mur bas
	
	move	DRAW_FLOOR1(a5),d0
	cmp	DRAW_FLOOR2(a5),d0
	bpl.s	fin_render_murdn

	move	DRAW_TXT_LOWER(a5),d0
	bsr	cherche_texture

	cmp.l	#0,a0
	beq.s	fin_render_murdn
	move.l	(a0)+,a4	; mur_adr
	move	(a0)+,d0
	subq	#1,d0	; mur_tx pour AND

	DSPWAITINPUT	(a6)
	move.l	#"MDN",2(a6)
	DSPWAITINPUT	(a6)
	move	d0,4(a6)
	DSPWAITINPUT	(a6)
	move	(a0),4(a6)	; mur_ty
	jsr	([RenderWallRout])
fin_render_murdn

; -------------	Plafond ou ciel ?

	lea	DRAW_TXT_CEIL(a5),a0
	tst.l	(a0)
	beq.s	fin_render_ceiling
	cmp.l	#"F_SK",(a0)
	bne.s	render_ceiling
	cmp	#"Y1",4(a0)
	beq.s	render_skyup
render_ceiling
	move	RenderHeight,d0
	sub	DRAW_CEILING1(a5),d0
	bpl.s	fin_render_ceiling
	jsr	([RenderCeilingRout])
	bra.s	fin_render_ceiling
render_skyup
	btst.b	#BETWEEN_UPSKY-8,DRAW_LDF_ATTRIB(a5)
	bne.s	fin_render_ceiling
	DSPWAITINPUT	(a6)
	move.l	#"SKU",2(a6)
	jsr	([RenderSkyRout])
fin_render_ceiling

; -------------	Sol ou ciel ?

	lea	DRAW_TXT_FLOOR(a5),a0
	tst.l	(a0)
	beq.s	fin_render_floor
	cmp.l	#"F_SK",(a0)
	bne.s	render_floor
	cmp	#"Y1",4(a0)
	beq.s	render_skydn
render_floor
	move	DRAW_FLOOR1(a5),d0
	sub	RenderHeight,d0
	bpl.s	fin_render_floor
	jsr	([RenderFloorRout])
	bra.s	fin_render_floor
render_skydn	
	btst.b	#BETWEEN_DNSKY-8,DRAW_LDF_ATTRIB(a5)
	bne.s	fin_render_floor
	DSPWAITINPUT	(a6)
	move.l	#"SKD",2(a6)	; Sky down
	jsr	([RenderSkyRout])
fin_render_floor

; -------------	Suivant

	bra.s	drawstack_next

; -------------	Sprite

drawstack_sprite
	jsr	([RenderSpriteRout])

; -------------	Objet suivant

drawstack_next
	move	(sp)+,d0
	dbra	d0,drawstack_bcl
fin_trace_drawstack
	rts

	BSS

RenderHeight	ds.w	1

xe1	ds.w	1
xe2	ds.w	1

mur_adr	ds.l	1
mur_tx	ds.w	1
mur_ty	ds.w	1

; -------------	Routines d'affichage 1x1

	TEXT

	; Ligne : pixel textur

PH_TEX_1X1	MACRO
	move.l	d1,d7
	move	d4,d7
	lsr.l	#6,d7
	lsr	#4,d7
	move.b	(a3,d7.w),d5
	add.l	d3,d1
	move	(a4,d5.w*4),(a1)+
	add	d6,d4
	ENDM

; -------------	Affichage d'une colonne texture (mur et sprite)

PC_TEX_1X1	MACRO
	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	add	d7,d7
	move	d1,d5
	add.l	d4,d1
	move	d5,d1
	jmp	(trace_colonne1x1\@,d7.w*8)
trace_colonne1x1\@

	and	d6,d5
	move.b	(a2,d5.w),d7
	addx.l	d4,d1
	move	(a3,d7.w*4),(a1)
	move	d1,d5
	adda.w	d3,a1

	and	d6,d5
	move.b	(a2,d5.w),d7
	addx.l	d4,d1
	move	(a3,d7.w*4),(a1)
	move	d1,d5
	adda.w	d3,a1

	and	d6,d5
	move.b	(a2,d5.w),d7
	addx.l	d4,d1
	move	(a3,d7.w*4),(a1)
	move	d1,d5
	adda.w	d3,a1

	and	d6,d5
	move.b	(a2,d5.w),d7
	addx.l	d4,d1
	move	(a3,d7.w*4),(a1)
	move	d1,d5
	adda.w	d3,a1

	dbra	d2,trace_colonne1x1\@
	ENDM

; -------------	Affichage d'une ligne texture (sol et plafond)

PL_TEX_1X1	MACRO
	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	mulu	#trace_ligne1\@-trace_ligne\@,d7
	jmp	(trace_ligne\@,d7.w)
trace_ligne\@
	PH_TEX_1X1
trace_ligne1\@
	PH_TEX_1X1
	PH_TEX_1X1
	PH_TEX_1X1
	dbra	d2,trace_ligne\@
	ENDM

; -------------	Affichage d'une ligne flat (sol et plafond)

PL_FLT_1X1	MACRO
	move.l	(a3,d5.w*4),d6

	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	jmp	(trace_ligne_flat\@,d7.w*2)
trace_ligne_flat\@
	REPT	4
	move	d6,(a1)+
	ENDR
	dbra	d2,trace_ligne_flat\@
	ENDM

; -------------	Routines d'affichage 2x1

	TEXT

	; Ligne : pixel textur

PH_TEX_2X1	MACRO
	move.l	d1,d7
	move	d4,d7
	lsr.l	#6,d7
	lsr	#4,d7
	move.b	(a3,d7.w),d5
	add.l	d3,d1
	move.l	(a4,d5.w*4),(a1)+
	add	d6,d4
	ENDM

; -------------	Affichage d'une colonne texture (mur et sprite)

PC_TEX_2X1	MACRO
	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	add	d7,d7
	move	d1,d5
	add.l	d4,d1
	move	d5,d1
	jmp	(trace_colonne2x1\@,d7.w*8)
trace_colonne2x1\@
	REPT	4
	and	d6,d5
	move.b	(a2,d5.w),d7
	addx.l	d4,d1
	move.l	(a3,d7.w*4),(a1)
	move	d1,d5
	adda.w	d3,a1
	ENDR
	dbra	d2,trace_colonne2x1\@
	ENDM

; -------------	Affichage d'une ligne texture (sol et plafond)

PL_TEX_2X1	MACRO
	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	mulu	#trace_ligne1\@-trace_ligne\@,d7
	jmp	(trace_ligne\@,d7.w)
trace_ligne\@
	PH_TEX_2X1
trace_ligne1\@
	PH_TEX_2X1
	PH_TEX_2X1
	PH_TEX_2X1
	dbra	d2,trace_ligne\@
	ENDM

; -------------	Affichage d'une ligne flat (sol et plafond)

PL_FLT_2X1	MACRO
	move.l	(a3,d5.w*4),d6

	move	d2,d7
	lsr	#2,d2
	not	d7
	and	#3,d7
	jmp	(trace_ligne_flat\@,d7.w*2)
trace_ligne_flat\@
	REPT	4
	move.l	d6,(a1)+
	ENDR
	dbra	d2,trace_ligne_flat\@
	ENDM
