; ------------------------------
;	Affichage d'un mur
; ------------------------------

	ORG	x:
mur_offset_y	ds	1

	ORG	p:
RenderWall
	move	#>256,x0
	move	a,x1
	mpy	-x0,x1,a	b,x1
	mpy	-x0,x1,b	a,l:colonne_start
	move	b,l:colonne_end

	move	x:sidedef_offsety,x1
	mpy	x0,x1,b	l:sauvegarde,a
	addr	a,b
	move	b,l:sauvegarde	

; -------------	Boucle d'affichage	

	move	#>trace_K,r4
	move	x:xe1,n4
	move	x:local_longueur,b
	lua	(r4)+n4,r4
	do	b,fin_trace_mur

	; Calcul du dnominateur

	move	x:seg_orig_x2,b
	move	x:seg_orig_x1,y0
	move	x:seg_orig_y2,a
	move	x:seg_orig_y1,x0
	sub	x0,a	x:(r4),x1
	sub	y0,b	a,y1
	mpy	-x1,y1,a		; (8:16)*(16:8)=(24:24)
	rep	#8-4
	asl	a		; a=(16:32)
	asl	a	x:seg_orig_x1,x0
	asl	a	x:seg_orig_y1,y0
	asl	a	x:seg_orig_x2,x1
	add	a,b	x:seg_orig_y2,y1

	; Calcul du numrateur
	
	mpy	y0,x1,a	b,x1	; y1*x2
	mac	-x0,y1,a	x:(r4),x0	; y1*x2-x1*y2 (32:16)
	
	; Calcul de Y
	
	jsr	<division_signee
	
	; Calcul de X

	move	a,x1
	mpy	x0,x1,a	a,x:mur_ymapping
	rep	#7-1
	asl	a
	asl	a	x:local_cosinus,b
	move	a,x:mur_xmapping	; (16:8)

	; X=x0(16:8) Y=y0(16:8)
	; **** Pb quand cos=0

;	move	x:local_cosinus,b
	abs	b	x:local_sinus,a
	abs	a
	
	cmp	a,b
	jmi	<Xmapping_calcY

	move	x:mur_xmapping,a
	move	x:seg_orig_x1,b
	move	x:local_cosinus,x1
	jmp	<Xmapping_ok
Xmapping_calcY
	move	x:mur_ymapping,a
	move	x:seg_orig_y1,b
	move	x:local_sinus,x1
Xmapping_ok
	sub	b,a	x:lumiere_const,x0
	rep	#15-1
	asr	a
	asr	a	x:mur_ymapping,y0
	jsr	<division_signee
;	move	a,x:to030_x

;	move	x:mur_ymapping,y0
;	move	x:lumiere_const,x0
	mpy	x0,y0,b	a,x:to030_x
	rep	#9-2
	asr	b
	asr	b	l:colonne_start,a
	asr	b	x:ecr_ligne,x0
	move	b0,x:to030_ycoef
	move	b0,x1

	; ecran=ecr_ligne+(player_h-hauteur_mur)/ycoef

	; Point de depart ecran

	jsr	<division_entiere
	tst	a	#>1,y0
	jle	<_mur_debme1
	add	y0,a
_mur_debme1
	add	x0,a
	move	a,x:to030_colstart

	; Point d'arrivee ecran

	move	l:colonne_end,a
	jsr	<division_entiere
	tst	a
	jge	<_mur_finp1
	sub	y0,a
_mur_finp1
	add	x0,a	x:ye2,y1
	move	a,x:to030_colend

	; Clipping ecran

;	move	x:ye2,y1
	move	x:to030_colstart,a

	cmp	y1,a	x:ye1,y0
	jpl	<_mur_horsecran
	cmp	y0,a	x:to030_colend,b
	tmi	y0,a

	cmp	y0,b
	jmi	<_mur_horsecran
	cmp	y1,b	a,x:to030_colstart ; Y de depart
	tgt	y1,b
	
	cmp	a,b	b,x:to030_colend   ; Y de fin
	jmi	<_mur_horsecran

	; Point de depart Y

;	move	x:ecr_ligne,x0
	sub	x0,a	x:to030_ycoef,x1
	move	a,x0
	mpy	x0,x1,a	l:sauvegarde,b
	addr	b,a
	move	a0,x:to030_y

	CALCUL_LUMIERE

	move	x:to030_x,a
	move	x:sidedef_offsetx,b
	add	b,a	x:mur_tx,x0
	and	x0,a
	move	a,x:to030_x
	
	WRITEHOST	x:to030_colstart
	WRITEHOST	x:to030_colend
	WRITEHOST	x:to030_x
	WRITEHOST	x:to030_ycoef
	WRITEHOST	x:to030_y
	WRITEHOST	x:to030_lum
	jmp	<_fin_trace_col

; -------------	Colonne suivante

_mur_horsecran
	WRITEHOST	#>-1
_fin_trace_col
	lua	(r4)+,r4	; Colonne suivante
fin_trace_mur
	jmp	<attente
